<?php 
	include_once ("../../dap-config.php");
	include_once ("authenticationHeaderAdminAjax.php");
	
	$responseArray = array();
	$response = "";
	$responseArray['startContinue'] = Dap_Session::get('start') - Dap_Config::get("SEARCH_USERS_COUNT");
  
	if ( isset($_POST['whatRequest']) && ($_POST['whatRequest'] != "") ) {
		$whatRequest = $_POST['whatRequest'];
		$responseArray['whatRequest'] = $whatRequest;
	}
	
	$userSearchType=$_REQUEST['userSearchType'];
	$userFilter=$_REQUEST['userFilter'];
		
	if($userSearchType == "email") 
	  $user = Dap_User::loadUserByEmail ($userFilter);
	else if($userSearchType == "user_id") 
	  $user = Dap_User::loadUserById ($userFilter);
	
	$userId=$user->getId();
	$productId = trim($_POST['productId']);
	
	$product = Dap_Product::loadProduct($productId);
    
	if ((!isset($user)) || (!isset($product))) {
	  $response = "User ($userId) or Product ($productId) not found.<br/>";
	  $responseArray['responseJSON'] = $response;
	  $responseJSON = json_encode($responseArray);
	  echo $responseJSON;
	  return;
	}
	
	try {
		//check if already has access in usersproducts
		//check if user already has access to product in usercredits
		$found=Dap_UserCondDrip::hasAccessTo($userId, $productId);
		logToFile("addCDFullProductAjax: hasAccessTo set to $found", LOG_DEBUG_DAP);
	
		if($found) {
		  logToFile("addCDFullProductAjax: user (id=$userId) has access to some individual resources under this product (productId=$productId)", LOG_DEBUG_DAP);
		  logToFile("addCDFullProductAjax: call removeUserResources() to remove users access to all individual resources before giving user full access to product", LOG_DEBUG_DAP);
		  //"User has access to some content under that product already. Delete individual content access before giving user full access to product<br/>";
		  Dap_UserCondDrip::removeUserResources($userId, $productId);
		}
		
		$hasAccess = $user->hasAccessTo($productId);
		logToFile("addCDFullProductAjax: check if user hasAccess to product in usersproducts: hasAccess=" . $hasAccess, LOG_DEBUG_DAP);
		
		if(!$hasAccess) {
		  logToFile("addCDFullProductAjax: user does not have access: hasAccess: " . $hasAccess, LOG_DEBUG_DAP);
		  Dap_UsersProducts::addUsersProducts($userId, $productId, $transId='-3',"","","","N");
		}
	} catch (PDOException $e) {
		$response .= ERROR_GENERAL . "<br/>";
	} catch (Exception $e) {
		$response = $e->getMessage() . "<br/>";
	}
	
	//logToFile($response,LOG_DEBUG_DAP);
	if($response == "") {
		$response = "SUCCESS! Added User To Product successfully.<br/>";
	}
	$responseArray['responseJSON'] = $response;
	$responseJSON = json_encode($responseArray);
	echo $responseJSON;
?>