<?php 
	include_once ("../../dap-config.php");
	include_once ("authenticationHeaderAdminAjax.php");
	
	$responseArray = array();
	$response = "";
	$responseArray['startContinue'] = Dap_Session::get('start') - Dap_Config::get("SEARCH_USERS_COUNT");
  
	if ( isset($_POST['whatRequest']) && ($_POST['whatRequest'] != "") ) {
		$whatRequest = $_POST['whatRequest'];
		$responseArray['whatRequest'] = $whatRequest;
	}
	
	$userSearchType=$_REQUEST['userSearchType'];
	$userFilter=$_REQUEST['userFilter'];
		
	if($userSearchType == "email") 
	  $user = Dap_User::loadUserByEmail ($userFilter);
	else if($userSearchType == "user_id") 
	  $user = Dap_User::loadUserById ($userFilter);
	
	$userId=$user->getId();
	$productId = trim($_POST['productId']);
	
	$product = Dap_Product::loadProduct($productId);
    
	if ((!isset($user)) || (!isset($product))) {
	  $response = "User ($userId) or Product ($productId) not found.<br/>";
	  $responseArray['responseJSON'] = $response;
	  $responseJSON = json_encode($responseArray);
	  echo $responseJSON;
	  return;
	}
	  
	$allowContentLevelCredits = $product->getAllowContentLevelCredits();
	logToFile("allowContentLevelCredits: " . $allowContentLevelCredits, LOG_DEBUG_DAP);
	
	$creditsSpent = 0;
	$foundRes=Dap_UserCredits::hasAccessTo($userId, $productId);
	
	if ($allowContentLevelCredits == "Y") {
	  $UserResources = Dap_FileResource::loadFileResourcesSSS($userId, $productId);
	  $alreadyHasAccessToAllContent=false;
	  if (isset($UserResources) || ($UserResources != NULL)) {
		foreach($UserResources as $resource) {
		  $creditsSpent = $creditsSpent +  $resource['credits_assigned'];
		}
	  }
	  
	  if (($creditsSpent == "") || ($creditsSpent == 0)) {
		 if($foundRes) {
		    $alreadyHasAccessToAllContent=true;
		 }
	  }
	  logToFile("addCSFullProductAjax: creditsSpent CALCULATED: " . $creditsSpent, LOG_DEBUG_DAP);
	}
	else {
	  $creditsSpent = Dap_FileResource::getChildCredit($product->getId()); 
	  logToFile("addCSFullProductAjax: countCreditsPerChild for the product: " . $creditsSpent, LOG_DEBUG_DAP);

	  if (($creditsSpent == "") || ($creditsSpent == 0)) {
		$response = "ERROR: Assign credits to the product : " . $product->getName() . "<br/>. It's not assigned currently";
		$responseArray['responseJSON'] = $response;
		$responseJSON = json_encode($responseArray);
		echo $responseJSON;
		return;
	  }
	}
	
	try {
		//check if already has access in usersproducts
		$hasAccess = $user->hasAccessTo($productId);
		logToFile("addCSFullProductAjax: check if user hasAccess to product in usersproducts: hasAccess=" . $hasAccess, LOG_DEBUG_DAP);
		
		if(!$hasAccess) {
		  logToFile("addCSFullProductAjax: user does not have access: hasAccess: " . $hasAccess, LOG_DEBUG_DAP);
		  Dap_UsersProducts::addUsersProducts($userId, $productId, $transId='-3',"","","","N");
		}
		
		//check if user already has access to product in usercredits
		$found=Dap_UserCredits::hasAccessTo($userId, $productId);
		logToFile("addCSFullProductAjax: hasAccessTo set to $found", LOG_DEBUG_DAP);
		
		// check if user has access to individual content
		logToFile("addCSFullProductAjax: user does not have full access to product but check if user has access to individual resources", LOG_DEBUG_DAP);
		$foundRes=Dap_UserCredits::hasAccessToResources($userId, $productId);
		if($foundRes) {
		  logToFile("addCSFullProductAjax: user does not have full access to product but user has access to individual resources", LOG_DEBUG_DAP);
		  logToFile("addCSFullProductAjax: call removeUserResources() to remove users access to all individual resources before giving user full access to product", LOG_DEBUG_DAP);
		  //"User has access to some content under that product already. Delete individual content access before giving user full access to product<br/>";
		  Dap_UserCredits::removeUserResources($userId, $productId);
		}
		 
		$product = Dap_Product::loadProduct($productId);
		$isSSSMaster=$product->getIs_master();
		$userProduct = Dap_UsersProducts::load($userId, $productId);
		$recurring="N";
		if($userProduct != NULL) {
			$recurring="Y";
		}
		if($isSSSMaster == "Y") {
		  if ($recurring == "N") //first time adding user to product
			$credits=$product->getCredits();
		  else { //recurring payment, user already exists
			if( strtolower($product->getIs_recurring()) == "y") {
			  $credits=$product->getRecurringCredits();
			}
		  }
		  logToFile("Dap_UsersProducts.addUsersProducts(): SSS: addign child, credits added to total",LOG_DEBUG_DAP); 
		  Dap_UserCredits::addCredits($userId, $productId, -1, $credits, 0, "By admin - master access");
		}
		else if(!$found) {
		  $credits_available_now=$user->getCredits_available() - $creditsSpent;
		  Dap_UserCredits::redeemCreditsAtProductLevel($userId, $productId, $creditsSpent, $comments="Added By Admin");
		  $user->updateCredits($credits_available_now);
		  logToFile("Dap_UserCredits::addCreditForUserProductAjax.php(): Insert into dap_userscredits Done"); 
		}
		else {
		  $response = "User already has full access to the product - " . $product->getName();
		  logToFile("Dap_UserCredits::user already has full access to the product");
		  $responseArray['responseJSON'] = $response;
		  $responseJSON = json_encode($responseArray);
		  echo $responseJSON;	
		  return;
		}
		
	} catch (PDOException $e) {
		$response .= ERROR_GENERAL . "<br/>";
	} catch (Exception $e) {
		$response = $e->getMessage() . "<br/>";
	}
	
	//logToFile($response,LOG_DEBUG_DAP);
	if($response == "") {
		$response = "SUCCESS! Added User To Product successfully.<br/>";
	}
	$responseArray['responseJSON'] = $response;
	$responseJSON = json_encode($responseArray);
	echo $responseJSON;
?>