<?php 
	include_once ("../../dap-config.php");
	include_once ("authenticationHeaderAdminAjax.php");
	
	$responseArray = array();
	$response = "";
	$responseArray['startContinue'] = Dap_Session::get('start') - Dap_Config::get("SEARCH_USERS_COUNT");
  
	if ( isset($_POST['whatRequest']) && ($_POST['whatRequest'] != "") ) {
		$whatRequest = $_POST['whatRequest'];
		$responseArray['whatRequest'] = $whatRequest;
	}

	$userId = trim($_POST['userId']);
	$productId = trim($_POST['productId']);
	$transAmount = trim($_POST['transAmount']);
	$user = Dap_User::loadUserById($userId);
	
	try {
		$transaction = new Dap_Transactions();
		$transaction->setTrans_num(time());
		$transaction->setTrans_type('manual');
		$transaction->setPayment_status('Completed');
		$transaction->setPayment_currency(Dap_Config::get('CURRENCY_TEXT'));
		$transaction->setPayment_value($transAmount);
		$transaction->setPayer_email($user->getEmail());
		$transaction->setPayment_processor("MANUAL");
		$transaction->setProduct_id($productId);
		$transaction->setTrans_blob("");
		$transaction->create();
		logToFile("Dap_PaymentProcessor::addTransactionForUserProductAjax.php(): Insert into transactions Done. Returning transaction id: " . $transaction->getId()); 
		sendTransactionNotificationEmail($transaction);
		Dap_UsersProducts::markUserProductAsSomething($userId, $productId, $transaction->getId());
		Dap_Transactions::setRecordStatus($transaction->getId(), 5, $dap_dbh);
	} catch (PDOException $e) {
		$response .= ERROR_GENERAL . "<br/>";
	} catch (Exception $e) {
		$response = $e->getMessage() . "<br/>";
	}
	
	//logToFile($response,LOG_DEBUG_DAP);
	if($response == "") {
		$response = "SUCCESS! Manual Transaction added successfully.<br/>";
	}
	$responseArray['responseJSON'] = $response;
	$responseJSON = json_encode($responseArray);
	echo $responseJSON;
?>