<?php 
include_once ("../../dap-config.php");
include_once ("authenticationHeaderAdminAjax.php");

$responseArray = array();
$response = "";

if ( isset($_POST['whatRequest']) && ($_POST['whatRequest'] != "") ) {
	$whatRequest = $_POST['whatRequest'];
	$responseArray['whatRequest'] = $whatRequest;
}

$start_date = isset($_POST['start_date']) ? $_POST['start_date'] : "01-01-2008";
$end_date = isset($_POST['end_date']) ? $_POST['end_date'] : "9999-12-31";

//logToFile("functions_admin.php :  whatRequest is ".$_POST['whatRequest'],LOG_DEBUG_DAP);

if($_POST['whatRequest'] == "loadTopThreeProducts"){
	$response = loadTopThreeProductsDisplayHTML($start_date, $end_date);
}
else if($_POST['whatRequest'] == "loadLastFiveSales"){
	$response = loadLastFiveSalesDisplayHTML($start_date, $end_date);
}

$responseArray['responseJSON'] = $response;
$responseJSON = json_encode($responseArray);
echo $responseJSON;


/* This function is to get the top 3 products in terms of sales in a given time 
	 * This is used in new DAP Dashboard */
	 
function loadTopThreeProductsDisplayHTML($start,$end){
	//logToFile("functions_admin.php : loadTopThreeProductsDisplayHTML(), startdate = '$start',enddate = '$end'",LOG_DEBUG_DAP);
	
	try{ 
		$dap_dbh = Dap_Connection::getConnection(); 
		if ($start == ""){	
			$start = date("Y-m-d");	
		}  	
		if ($end == ""){	
			$end = date("Y-m-d");	
		}
		
		$sql = "select count(t.product_id) as total,p.name as product_name from  dap_transactions t INNER JOIN dap_products p ON t.product_id = p.id where t.date between  '$start'  and '$end' AND (t.payment_status = 'Completed' OR t.payment_status = 'Verified') AND (t.status = 5 OR t.status = 7 OR t.status = 1) GROUP BY t.product_id ORDER BY total DESC limit 3";   
		$stmt = $dap_dbh->prepare($sql); 
		$stmt->execute();	
		while($row = $stmt->fetch(PDO::FETCH_ASSOC)){
			$top_products .= "<li>".$row['product_name']."<span class='pull-right'>(".$row['total']." Sales)</span></li>";
		} 
		
		if($top_products == ""){
			$top_products = "<li>No data available for the selected date range</li>";
		}

		return $top_products;
	}
	catch(PDOException $e){
		logToFile("functions_admin.php : loadTopThreeProductsDisplayHTML() exception".$e->getMessage(),LOG_FATAL_DAP);
	}
	catch (Exception $e) {   
		logToFile("functions_admin.php : loadTopThreeProductsDisplayHTML() exception ".$e->getMessage(), LOG_FATAL_DAP);  
	}
}

/* This function will return the last five sales in that current time
 */
 
function loadLastFiveSalesDisplayHTML($start,$end){
	//logToFile("functions_admin.php: loadLastFiveSalesDisplayHTML(), Start date is '$start',End date is '$end'",LOG_DEBUG_DAP);
	
	if ($start == ""){	
			$start = date("Y-m-d");	
		}  	
		if ($end == ""){	
			$end = date("Y-m-d");	
		}
	
	try{
		$dap_dbh = Dap_Connection::getConnection();
		$sql = "select p.name as product_name,t.payment_value as price from  dap_transactions t INNER JOIN dap_products p ON t.product_id = p.id where t.date between  '$start'  and '$end' AND (t.payment_status = 'Completed' OR t.payment_status = 'Verified') AND (t.status = 5 OR t.status = 7 OR t.status = 1)  ORDER BY t.id DESC limit 5";   
		
		$stmt = $dap_dbh->prepare($sql); 
		$stmt->execute();
		
		$last_sales = "";
		while($row = $stmt->fetch(PDO::FETCH_ASSOC)){
			$last_sales .= "<li>".$row['product_name']."<span class='pull-right'>$".$row['price']."</span><p></p></li>";
		}
		if($last_sales == ""){
			$last_sales = "<li>No data available for the selected date range</li>";
		}
		return $last_sales;
	}
	catch(PDOException $e){
		logToFile("functions_admin.php: loadLastFiveSalesDisplayHTML() error is".$e->getMessage(),LOG_FATAL_DAP);
	}
	catch(Exception $e){
		logToFile("functions_admin.php: loadLastFiveSalesDisplayHTML() error is".$e->getMessage(),LOG_FATAL_DAP);
	}
 
}


?>

