<?php 
include_once ("../../dap-config.php");
include_once ("authenticationHeaderAdminAjax.php");


$responseArray = array();
$response = "";

if ( isset($_REQUEST['whatRequest']) && ($_REQUEST['whatRequest'] != "") ) {
	$whatRequest = $_REQUEST['whatRequest'];
	$responseArray['whatRequest'] = $whatRequest;
}


if($_REQUEST['whatRequest'] == 'saveProductPlanMap'){
	try {
		$id = $_REQUEST['mapId'];
		$product_id = $_REQUEST['product_id'];
		$stripe_plan = $_REQUEST['stripe_plan'];	
		$mode = $_REQUEST['mode'];	
		$product_map = new Dap_ProductPlanMapping();
		$product_map->setId($id);
		$product_map->setProduct_id($product_id);
		$product_map->setStripe_plan($stripe_plan);
		$product_map->setStripe_mode($mode);
		$planArr = Dap_ProductPlanMapping::loadByProductId($product_id , '', $mode);
		if(isset($planArr)){
			$map_ID = 'product_exists';
		}else{
			$map_ID = $product_map->create();
		}	
		echo $map_ID;
	} catch (PDOException $e) {
		$response = ERROR_GENERAL;
	} catch (Exception $e) {
		$response = $e->getMessage() . "<br/>";
	}
	exit;
}

if($_REQUEST['whatRequest'] == 'updateProductPlanMap'){
	try {
		$id = $_REQUEST['mapId'];
		$product_id = $_REQUEST['product_id'];
		$stripe_plan = $_REQUEST['stripe_plan'];	
		$mode = $_REQUEST['mode'];	
		$product_map = new Dap_ProductPlanMapping();
		$product_map->setId($id);
		$product_map->setProduct_id($product_id);
		$product_map->setStripe_plan($stripe_plan);
		$product_map->setStripe_mode($mode);
		$planArr = Dap_ProductPlanMapping::loadByProductId($product_id , $id,$mode);
		if(isset($planArr)){
			$map_ID = 'product_exists';
		}else{
			$map_ID = $product_map->update();
		}	
		
		echo $map_ID;
	} catch (PDOException $e) {
		$response = ERROR_GENERAL;
	} catch (Exception $e) {
		$response = $e->getMessage() . "<br/>";
	}
	exit;
}



if($_REQUEST['whatRequest'] == 'deleteProductPlanMap'){
	try {
		$id = $_REQUEST['id'];
		$product_map = new Dap_ProductPlanMapping();
		$product_map->setId($id);
		$product_map->delete();
	} catch (PDOException $e) {
		$response = ERROR_GENERAL;
	} catch (Exception $e) {
		$response = $e->getMessage() . "<br/>";
	}
	exit;
}


if($_REQUEST['whatRequest'] == 'createStripePlan'){
	try {
		$name = $_REQUEST['name'];
		$currency = $_REQUEST['currency'];
		$price = $_REQUEST['price'];
		$billing_interval = $_REQUEST['billing_interval'];
		$trial_period = $_REQUEST['trial_period'];
		//$name_id = strtolower($name);
		//$name_id = str_replace(' ' , '-', $name);
		
		Stripe::setApiKey($_REQUEST['key']);
		    
		$plan = Stripe_Plan::create(array(
					"amount" => $price,
					"interval" => "day",
					"interval_count" => $billing_interval,
					"product" => array(
					"name" => $name
					),
					"currency" => $currency,
					"id" => $name
			    ));
	 
	} catch (PDOException $e) {
		$response = ERROR_GENERAL;
	} catch (Exception $e) {
		$response = $e->getMessage() . "<br/>";
	}
	exit;
}


if($_REQUEST['whatRequest'] == 'getDapProductDetails'){
	try {
		$id = $_REQUEST['id'];
		$product_details = Dap_Product::loadProduct($id);	
		$response = array();
		if($product_details){
			$response['name'] = $product_details->getName();	
			$response['trial_period'] = $product_details->getRecurring_cycle_1();	
			$response['billing_interval'] = $product_details->getRecurring_cycle_3();	
			$response['price'] = $product_details->getPrice();
			$response['price'] = $response['price'] * 100;
			if($product_details->getTrial_price() > 0 ){
				$msg = "Your users will be charged $".$product_details->getTrial_price()." and given ".$product_details->getRecurring_cycle_1()." days of access initially, and then $".$product_details->getPrice()." every ".$product_details->getRecurring_cycle_3()." days for a total of ".$product_details->getTotal_occur()." times.";
			}else if($response['trial_period']  != $response['billing_interval']){
				$msg = "Your users will be billed $".$product_details->getPrice()." initially. After the first payment, the next recurring billing will happen after ".$product_details->getRecurring_cycle_1()." days. After the first recurring billing, all subsequent recurring billing will happen every ".$product_details->getRecurring_cycle_3()." days for a total of ".$product_details->getTotal_occur()." times.";
			}else if($response['trial_period'] == $response['billing_interval'] ){
				$msg = "Your users will be charged $".$product_details->getPrice()." every ".$product_details->getRecurring_cycle_3()." days for a total of ".$product_details->getTotal_occur()." times .";
			}
			$response['msg'] = $msg;
			
		}
		echo json_encode($response);
	} catch (PDOException $e) {
		$response = ERROR_GENERAL;
	} catch (Exception $e) {
		$response = $e->getMessage() . "<br/>";
	}
	exit;
}

if($_REQUEST['whatRequest'] == 'saveSPCBlogPath'){

	$configArray = array();
	 
	$key="SPC_BLOG_PATH";

	$value = $_REQUEST['spc_blog_path'];

	$key = str_replace("config_","",$key);

	$configArray[$key] = trim($value);
	$msg = '';
	try {
	  Dap_Config::updateConfigNameArray($configArray);
	}  catch (Exception $e) {
	  $msg = "ERROR! An error occurred while processing your request. Please try again.";
	  
	}
	echo json_encode($msg);
}


