<?php
include_once ("../../dap-config.php");
include_once ("authenticationHeaderUserAjax.php");
header('Content-type: text/html; charset=UTF-8') ;

$lldocroot = defined('SITEROOT') ? SITEROOT : $_SERVER['DOCUMENT_ROOT'];
if(file_exists($lldocroot . "/dap/inc/tp/Stripe.php")) include_once ($lldocroot . "/dap/inc/tp/Stripe.php");

$errorMsg = '';   
$status = '';  
if(isset($_POST['operationName']) && $_POST['operationName'] == 'getStatus'){

    if(strtolower($_POST['paymentGateway']) == 'stripe'){
        $stripeStripeKey = Dap_Config::get('STRIPE_SECRET_KEY');

        if($stripeStripeKey != ''){
            \Stripe\Stripe::setApiKey($stripeStripeKey);

            $getSubsId = dapStripeGetSubsId($stripeStripeKey, $_POST['profileId']);
           
            $subscription = \Stripe\Subscription::retrieve($getSubsId);
            
            if(isset($subscription)){
                $currentPeriodEnd = $subscription->current_period_end;
                $currentPeriodStart = $subscription->current_period_start;
            }
          
            $endDate =  date('Y-m-d', $currentPeriodEnd);
            $startDate =  date('Y-m-d', $currentPeriodStart);
            $date =  $endDate;
        }else{
            $errorMsg = 'Error: Missing Stripe Key in <a target="_blank" href="/dap/admin/addEditProducts.php?t=3">DAP Setup >> Config page >> Payment Processing tab.</a>'; 
        }

       
    }else{
        $nvpstr = '&PROFILEID='.$_POST['profileId'];
        $resArray = hash_call_dap("GetRecurringPaymentsProfileDetails", $nvpstr); 
        
        if($resArray == 'missing_params'){
            $errorMsg = 'Error: Missing PayPal API Keys in <a target="_blank" href="/dap/admin/addEditProducts.php?t=3">DAP Setup >> Config page >> Payment Processing tab.</a>'; 
        }else if($resArray['ACK'] == 'Failure'){
            $errorMsg = 'Error: Paypal API Keys are Missing or Incorrect in <a target="_blank" href="/dap/admin/addEditProducts.php?t=3">DAP Setup >> Config page >> Payment Processing tab.</a>';
        }else{
            if($resArray['STATUS'] == 'Active'){
                $date = date('Y-m-d h:i:s' ,strtotime($resArray['NEXTBILLINGDATE']));
            }else{
                $status = $resArray['STATUS'];
                $date = '';
            }
            
        }
        
    }
    echo json_encode(array('errorMsg' => $errorMsg, 'date' => $date, 'status' => $status));die;
    
}else if(isset($_POST['operationName']) && $_POST['operationName'] == 'updateProfile'){
    date_default_timezone_set($_POST['timezone']);

    if(strtolower($_POST['paymentGateway']) == 'stripe'){
        $stripeStripeKey = Dap_Config::get('STRIPE_SECRET_KEY');

        if($stripeStripeKey != ''){

            \Stripe\Stripe::setApiKey($stripeStripeKey);

            \Stripe\Stripe::setApiVersion("2018-02-05");   

            $getSubsId = dapStripeGetSubsId($stripeStripeKey, $_POST['profileId']);
            try{
                if($_POST['dateType'] == 'days'){
                    $subscription = \Stripe\Subscription::update($getSubsId);
                    //print_r($subscription );
                    $currentPeriodEnd = date('Y-m-d', $subscription->current_period_end);
                    $newPeriodEnd = date('Y-m-d', strtotime($currentPeriodEnd. ' + '.$_POST['dateTime'].' days')); 
                }else{
                   $newPeriodEnd = $_POST['dateTime'];
                }
                
                $newPeriodEnd = strtotime($newPeriodEnd);
                $subscription = \Stripe\Subscription::update($getSubsId,['trial_end' => $newPeriodEnd, 'trial_from_plan' => false]);

            }catch(Exception $e){
                echo $e->getMessage();
            }
        }else{
            $errorMsg = 'Error: Missing Stripe Key in <a target="_blank" href="/dap/admin/addEditProducts.php?t=3">DAP Setup >> Config page >> Payment Processing tab.</a>'; 
        }
        
    }else{
        if($_POST['dateType'] == 'datetime'){
            $_POST['dateTime'] = date('Y-m-d h:i:s' ,strtotime($_POST['dateTime']));
           // echo date_default_timezone_get();die;
            $date = $_POST['dateTime'].'Z';
            $date = explode(' ', $date);
            $date = $date[0].'T'.$date[1];
        }else{
            $Date = date('Y-m-d' , strtotime($_POST['currentDateTime']));
            $date = date('Y-m-d h:i:s' , strtotime($Date. ' + '.$_POST['dateTime'].' days'));
            $date = $date.'Z';
            $date = explode(' ', $date);
            $date = $date[0].'T'.$date[1];
        }
        
        $nvpstr = '&PROFILEID='.$_POST['profileId'].'&PROFILESTARTDATE='.$date;
       
      
        $resArray = hash_call_dap("UpdateRecurringPaymentsProfile", $nvpstr);
        if($resArray == 'missing_params'){
            $errorMsg = 'Error: Missing PayPal API Keys in <a target="_blank" href="/dap/admin/addEditProducts.php?t=3">DAP Setup >> Config page >> Payment Processing tab.</a>'; 
        }else if($resArray['ACK'] == 'Failure'){
            $errorMsg = 'Error: Paypal API Keys are Missing or Incorrect in  <a target="_blank" href="/dap/admin/addEditProducts.php?t=3">DAP Setup >> Config page >> Payment Processing tab.</a>'; 
        }else if($resArray['STATUS'] == 'Active'){
            $status = $resArray['STATUS'];
        }

        
    }   
    echo json_encode(array('errorMsg' => $errorMsg, 'date' => $date, 'status' => $status));die;
}



global $PROXY_HOST;
global $PROXY_PORT;
global $API_UserName;
global $API_Password;
global $API_Signature;
global $API_Endpoint;
global $PAYPAL_URL;
global $sBNCode;
global $USE_PROXY;
global $version;

