<?php 
	include_once ("../../dap-config.php");
	include_once ("authenticationHeaderAdminAjax.php");
	
	$responseArray = array();
	$response = "";
	$responseArray['startContinue'] = Dap_Session::get('start') - Dap_Config::get("SEARCH_USERS_COUNT");
  
	if ( isset($_POST['whatRequest']) && ($_POST['whatRequest'] != "") ) {
		$whatRequest = $_POST['whatRequest'];
		$responseArray['whatRequest'] = $whatRequest;
	}
	
	logToFile("removeSelectedUsersAccessToProductAjax: ENTER" . $hasAccess, LOG_DEBUG_DAP);
	
	$userSearchType=$_REQUEST['userSearchType'];
	$userFilter=$_REQUEST['userFilter'];
		
	if($userSearchType == "email") 
	  $user = Dap_User::loadUserByEmail ($userFilter);
	else if($userSearchType == "user_id") 
	  $user = Dap_User::loadUserById ($userFilter);
	
	if (!isset($user)) {
	  $response = "User ($userId) not found.<br/>";
	  $responseArray['responseJSON'] = $response;
	  $responseJSON = json_encode($responseArray);
	  echo $responseJSON;
	  return;
	}
	
	$userId=$user->getId();
	
	if (!isset($user)) {
	  $response = "User ($userId) not found.<br/>";
	  $responseArray['responseJSON'] = $response;
	  $responseJSON = json_encode($responseArray);
	  echo $responseJSON;
	  return;
	}
	
	
	$productId = trim($_POST['productId']);

	
	try {
		//check if already has access in usersproducts
		$hasAccess = $user->hasAccessTo($productId);
		logToFile("removeSelectedUsersAccessToProductAjax: check if user hasAccess to product in usersproducts: hasAccess=" . $hasAccess, LOG_DEBUG_DAP);
		
		//if(!$hasAccess) {
		  //logToFile("removeSelectedUsersAccessToProductAjax: user does not have access: hasAccess: " . $hasAccess, LOG_DEBUG_DAP);
		  
		//}
	} catch (PDOException $e) {
		$response .= ERROR_GENERAL . "<br/>";
		logToFile("removeSelectedUsersAccessToProductAjax: SQL EXCEPTION: " . $response, LOG_DEBUG_DAP);
	} catch (Exception $e) {
		$response = $e->getMessage() . "<br/>";
		logToFile("removeSelectedUsersAccessToProductAjax: SQL EXCEPTION: " . $response, LOG_DEBUG_DAP);
	}
	
	try {
		//check if user already has access to product in usercredits
		$found=Dap_UserCredits::hasAccessTo($userId, $productId);
		logToFile("removeSelectedUsersAccessToProductAjax: hasAccessTo set to $found", LOG_DEBUG_DAP);
		// check if user has access to individual content
		
		$foundRes=Dap_UserCredits::hasAccessToResources($userId, $productId);
		logToFile("removeSelectedUsersAccessToProductAjax: hasAccessToResources foundRes=". $foundRes, LOG_DEBUG_DAP);
		
		if(($found) || ($foundRes)) {
		  logToFile("removeSelectedUsersAccessToProductAjax: user either has full access to product OR user has access to individual resources. Remove full access.", LOG_DEBUG_DAP);
		  //"User has access to some content under that product already. Delete individual content access before giving user full access to product<br/>";
		  Dap_UserCredits::removeFullProduct($userId, $productId);
		}
		else {
		  $response = "User does not have access to the product (productId=". $productId.")";
		  logToFile("removeSelectedUsersAccessToProductAjax: ". $response);
		  $responseArray['responseJSON'] = $response;
		  $responseJSON = json_encode($responseArray);
		  echo $responseJSON;	
		  return;
		}
		
		$product = Dap_Product::loadProduct($productId);
		$userProduct = Dap_UsersProducts::load($userId, $productId);
		$recurring="N";
		if($userProduct != NULL) {
			$recurring="Y";
		}
		//SSS
		/*if (($product->getCredits() > 0) && ($product->getSelf_service_allowed() == "Y")) {
		  logToFile("Dap_UsersProducts.addUsersProducts(): SSS: recurring=".$recurring,LOG_DEBUG_DAP); 
		  $productId=$product->getId();
		  $isSSSMaster=$product->getIs_master();
		  
		  if ($recurring == "N") //first time adding user to product
			$credits=$product->getCredits();
		  else { //recurring payment, user already exists
			if( strtolower($product->getIs_recurring()) == "y") {
			  $credits=$product->getRecurringCredits();
			}
			else {
			  logToFile("Dap_UsersProducts.removeUsersProducts(): SSS: it's a recurring payment for a non-recurring product (free product), no credits assigned. Looks like same user is trying to re-sign for the free product to earn credits. To prevent free product/signup abuse, no credits assigned",LOG_DEBUG_DAP); 
			}
		  }
		  if($credits > 0) {
			if($isSSSMaster == "Y") {
			  logToFile("Dap_UsersProducts.removeUsersProducts(): SSS: adding child, credits added to total",LOG_DEBUG_DAP); 
			  $credits=-($credits);
			  Dap_UserCredits::addCredits($userId, $productId, -1, $credits, 0, "By Purchase");
			}
			else {
			  logToFile("Dap_UsersProducts.removeUsersProducts(): SSS: addign child, credits deducted from total",LOG_DEBUG_DAP); 
			  Dap_UserCredits::addCredits($userId, $productId, -1, 0, $credits, "Admin removed access, add back credits");
			}
		  }
		}*/
		
		$setComplete = "Y"; //remove full access and not just reduce access by 1 recurring cycle
		Dap_UsersProducts::removeUsersProducts($userId, $productId,-1,$setComplete);
		  
	} catch (PDOException $e) {
		$response .= ERROR_GENERAL . "<br/>";
	} catch (Exception $e) {
		$response = $e->getMessage() . "<br/>";
	}
	
	//logToFile($response,LOG_DEBUG_DAP);
	if($response == "") {
		$response = "SUCCESS! Deleted Users access To Selected Product successfully.<br/>";
	}
	$responseArray['responseJSON'] = $response;
	$responseJSON = json_encode($responseArray);
	echo $responseJSON;
?>