jQuery(document).ready(function(){

	jQuery('#dapUpdateSubscriptionTable').dataTable({"order": [[ 0, "desc" ]]});

	jQuery('#updateSubscriptiontimepicker').datetimepicker({
	    ownerDocument: document,
		contentWindow: window,

		value: '',
		rtl: false,

		format: 'Y-m-d H:i:s',
		formatTime: 'H:i',
		formatDate: 'Y-m-d',

		startDate:  false, // new Date(), '1986/12/08', '-1970/01/05','-1970/01/05',
		step: 60,
		monthChangeSpinner: true,

		closeOnDateSelect: false,
		closeOnTimeSelect: true,
		closeOnWithoutClick: true,
		closeOnInputClick: true,
		openOnFocus: true,

		timepicker: true,
		datepicker: true,
		weeks: false,

		defaultTime: false, // use formatTime format (ex. '10:00' for formatTime: 'H:i')
		defaultDate: false, // use formatDate format (ex new Date() or '1986/12/08' or '-1970/01/05' or '-1970/01/05')

		minDate: 0,
		maxDate: false,
		minTime: false,
		maxTime: false,
		minDateTime: false,
		maxDateTime: false,

		allowTimes: [],
		opened: false,
		initTime: true,
		inline: false,
		theme: '',
		touchMovedThreshold: 5,

		onSelectDate: function () {},
		onSelectTime: function () {},
		onChangeMonth: function () {},
		onGetWeekOfYear: function () {},
		onChangeYear: function () {},
		onChangeDateTime: function () {},
		onShow: function () {},
		onClose: function () {},
		onGenerate: function () {},

		withoutCopyright: true,
		inverseButton: false,
		hours12: false,
		next: 'xdsoft_next',
		prev : 'xdsoft_prev',
		dayOfWeekStart: 0,
		parentID: 'body',
		timeHeightInTimePicker: 25,
		timepicker : true,
		todayButton: true,
		prevButton: true,
		nextButton: true,
		defaultSelect: true,

		scrollMonth: true,
		scrollTime: true,
		scrollInput: true,

		lazyInit: false,
		mask: false,
		validateOnBlur: true,
		allowBlank: true,
		yearStart: 1950,
		yearEnd: 2050,
		monthStart: 0,
		monthEnd: 11,
		style: '',
		id: '',
		fixed: false,
		roundTime: 'round', 
		className: '',
		weekends: [],
		highlightedDates: [],
		highlightedPeriods: [],
		allowDates : [],
		allowDateRe : null,
		disabledDates : [],
		disabledWeekDays: [],
		yearOffset: 0,
		beforeShowDay: null,

		enterLikeTab: true,
		showApplyButton: false
	});


	//update_subscription_tab
	//subscription_tab


	jQuery(document).on('click', '.manageSubscriptionTab', function(e){
		e.preventDefault();
		jQuery('.nav-link').removeClass('active');
		jQuery('#update_subscription_tab_main').addClass('active');
	});


	jQuery(document).on('click', '.ordersTab', function(e){
		e.preventDefault();
		jQuery('.nav-link').removeClass('active');
		jQuery('#manage_stats_tab').addClass('active');

	});

	jQuery(document).on('click', '.getSubscriptionStatus', function(e){
		e.preventDefault();
		var profileId = jQuery(this).attr('data-key');
		var paymentGateway = jQuery(this).attr('data-id');
		var num = jQuery(this).attr('data-num');

		jQuery(this).text('Please wait...');

		getSubscriptionStatus(profileId, paymentGateway, num);
			
	});


	jQuery(document).on('click', '.updateSubscriptionDate', function(e){
		var profileId = jQuery('#updateSubscriptionModal .profileId').val();
		var paymentGateway = jQuery('#updateSubscriptionModal .paymentGateway').val();
		var num = jQuery('#updateSubscriptionModal .num').val();
		var dateTime = jQuery('#updateSubscriptionModal #updateSubscriptiontimepicker').val();
		var currentDateTime = jQuery('#updateSubscriptionModal .currentStartDate').text();
		var timezone = jQuery('#updateSubscriptionModal #schedule_zone').val();
		var dateType = 'datetime';
		if(dateTime == ''){
			dateTime = jQuery('#updateSubscriptionModal #updateSubscriptionDays').val();
			dateType = 'days';
		}
		jQuery('.dap_orders_loading_wrapper').show();
		jQuery.ajax({
			url: "/dap/admin/ajax/dapUpdateSubscriptionAjax.php",
			cache: false,
			type: "POST",
			data: {"profileId":profileId,"paymentGateway":paymentGateway, "operationName":"updateProfile", "dateTime" :dateTime,"dateType":dateType, "currentDateTime" :currentDateTime, "timezone" :timezone},
			success: function(response){
				jQuery('.dap_orders_loading_wrapper').hide();
				response = JSON.parse(response);
				if(response.errorMsg != ''){
					swal({
						title: response.errorMsg,
						html : response.errorMsg,
					});	 
					jQuery('.getSubscriptionStatus').text('Check Subscription Status');
				}else{					
					getSubscriptionStatus(profileId, paymentGateway, num);
					swal("Saved Successfully");	 
				}
			}
		}); 

	});

	jQuery(document).on('click', '.updateSubscriptionModal', function(e){
		e.preventDefault();
		var profileId = jQuery(this).attr('data-key');
		var paymentGateway = jQuery(this).attr('data-id');
		var num = jQuery(this).attr('data-num');
		var name = jQuery('#orderName'+num).val();
		var email = jQuery('#orderEmail'+num).val();

		jQuery('#updateSubscriptionModal .currentName').text(name);
		jQuery('#updateSubscriptionModal .currentEmail').text(email);
		jQuery('#updateSubscriptionModal .num').val(num);
		jQuery('#updateSubscriptionModal #updateSubscriptiontimepicker').val('');
		jQuery('#updateSubscriptionModal #updateSubscriptionDays').val('');

		jQuery('.getSubscriptionStatus').text('Check Subscription Status');
		jQuery('.getSubscriptionStatus').show();
		jQuery('.UpdateSubscription-tag').hide();
		jQuery('.dap_orders_loading_wrapper').show();
		getSubscriptionStatus(profileId, paymentGateway, num, 'Y');
	});


});


function getSubscriptionStatus(profileId, paymentGateway, num = '', showModal = 'N'){
	jQuery.ajax({
		url: "/dap/admin/ajax/dapUpdateSubscriptionAjax.php",
		cache: false,
		type: "POST",
		data: {"profileId":profileId,"paymentGateway":paymentGateway, "operationName":"getStatus"},
		success: function(response){
			response = JSON.parse(response);
			jQuery('.dap_orders_loading_wrapper').hide();
			if(response.errorMsg != ''){
				swal({
					title: response.errorMsg,
					html : response.errorMsg,
				});
				jQuery('.getSubscriptionStatus').text('Check Subscription Status');
			}else{
				//if(num != ''){
				jQuery('.checkSubs'+num).hide();				 
				jQuery('.showStats'+num).text(response.date);
				jQuery('.showStats'+num).show();	
				//}else{

				jQuery('.currentStartDate').text(response.date);	
				if(response.status != ''){
					jQuery('.showStats'+num).text(response.status);
				}
				jQuery('#updateSubscriptionModal .profileId').val(profileId);
				jQuery('#updateSubscriptionModal .paymentGateway').val(paymentGateway);
				//}

				if(showModal == 'Y'){
					if(response.status != ''){
						swal('This subscription is cancelled or suspended');
						return false;
					}else{
						jQuery('#updateSubscriptionModal').modal('show');
					}
					
				}
			}
			
			
							 
						 
						 
		}
	}); 

}