<?php

$sql_ddl[] = "update dap_users set activation_key = activation_key + id";
$sql_ddl[] = "ALTER TABLE `dap_aff_comm` ADD `tier` INT( 3 ) NOT NULL DEFAULT '1' AFTER `is_comm_recurring`";

$sql_ddl[] = "ALTER TABLE `dap_aff_comm` DROP PRIMARY KEY ,
	ADD PRIMARY KEY ( `user_id` , `product_id` , `tier` )";


$sql_ddl[] = "ALTER TABLE `dap_aff_earnings` CHANGE `earning_type` `earning_type` CHAR( 2 ) 
	CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'L-Lead, S-Sale, P-Payment, T-Tier'";

$sql_ddl[] = "ALTER TABLE `dap_aff_referrals` DROP INDEX `userproductkey` , 
	ADD UNIQUE `userproductkey` ( `user_id` , `product_id` , `affiliate_id` )";
$sql_ddl[] = "ALTER TABLE `dap_aff_referrals` ADD `tier` INT( 3 ) NOT NULL DEFAULT '1' AFTER `product_id`";


$sql_ddl[] = "
	INSERT INTO `dap_templates` (
		`name` ,
		`description` ,
		`category` ,
		`content` 
		)
	VALUES
		('SHORT', 'Error Msg: SHORT', 'message', '<table><tr><td style=\"background-color: #FFFAAF;\">Sorry, you do not have access to this content.</td></tr></table>'),
		('LONG', 'Error Msg: LONG', 'message', 'Sorry, you do not have access to this content.<br/><a href=\"http://yoursite.com/salespage/\">Click here to get access</a>')
";

$sql_ddl[] = "
	INSERT INTO dap_config (
		`name` ,
		`value` ,
		`description` ,
		`editable` ,
		`type` ,
		`values` ,
		`display_order` ,
		`category` 
	)
	VALUES
		('WP_SYNC_IF_USERNAME', 'N', 'Sync DAP/WP only if Username exists in DAP', 'Y', 'html_select', 'Y|N', '14', 'advanced'),
		('WP_DEF_ROLE_FREE', 'subscriber', 'Default WP Role for FREE users', 'Y', 'html_text', '', '14', 'advanced'),
		('WP_DEF_ROLE_PAID', 'subscriber', 'Default WP Role for PAID users', 'Y', 'html_text', '', '14', 'advanced'),
		('PAYPAL_SANDBOX', 'N', 'Use Paypal Sandbox For Testing', 'Y', 'html_select', 'Y|N', 20, 'payment'),
		('PAYPAL_BUS_EMAIL', '', 'Paypal Business Email ID', 'Y', 'html_text', '', 21, 'payment'),
		('COMM_PROTOCOL', 'FOPEN', 'How DAP communicates with Paypal', 'Y', 'html_select', 'CURL|FOPEN', 22, 'payment'),
		('PAYPAL_AUTH_TOKEN', '', 'Paypal Auth Token to authorize request and retrieve additional payment details', 'Y', 'html_text', '', 24, 'payment'),
		('PAYPAL_PAYMENT_FAIL', '/dap/paymentError.php', 'Redirect users to this page if Paypal Payment Fails.  Default - home page.', 'Y', 'html_text', '', 25, 'payment');
";


$sql_ddl[] = "ALTER TABLE `dap_users` CHANGE `activation_key` `activation_key` VARCHAR( 20 ) NULL DEFAULT '0'";
$sql_ddl[] = "ALTER TABLE `dap_users` ADD UNIQUE (`activation_key`)";
$sql_ddl[] = "ALTER TABLE `dap_transactions` ADD `coupon_id` int(11) DEFAULT NULL AFTER `product_id`";
$sql_ddl[] = "ALTER TABLE `dap_users_products_jn` ADD `coupon_id` int(11) DEFAULT NULL AFTER `transaction_id`";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_coupons` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(30) NOT NULL,
  `description` text,
  `start_date` date NOT NULL DEFAULT '0000-00-00',
  `end_date` date NOT NULL DEFAULT '0000-00-00',
  `discount_amt` decimal(7,2) NOT NULL DEFAULT '0.00',
  `recurring_discount_amt` decimal(7,2) NOT NULL DEFAULT '0.00',
  `discount_rate` int(3) DEFAULT '0',
  `max_usage` int(11) DEFAULT '0',
  `actual_usage` int(11) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8";


$sql_ddl[] = "ALTER TABLE `dap_productchaining` ADD `add_days` INT( 11 ) NOT NULL DEFAULT '0' AFTER `transaction_id`";

$sql_ddl[] = "ALTER TABLE `dap_aff_stats` CHANGE `http_referer` `http_referer` VARCHAR( 200 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT ''";

$sql_ddl[] = "ALTER TABLE `dap_aff_stats` ADD `dest_url` VARCHAR( 100 ) NULL";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_products_coupons_jn` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `coupon_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `productcouponkey` (`product_id`,`coupon_id`),
  KEY `product_id` (`product_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8";


$sql_ddl[] = "
INSERT INTO `dap_config` (`name`, `value`, `description`, `editable`, `type`, `values`, `display_order`, `category`) VALUES
('PAYPAL_PAYMENT_SUCC', '', 'URL to return to after successful Paypal payment. If blank, will use product/global login redirect', 'Y', 'html_text', '', 26, 'payment')
";

$sql_ddl[] = "ALTER TABLE `dap_products` ADD `price_increment` decimal( 7, 2 ) DEFAULT NULL" ;
$sql_ddl[] = "ALTER TABLE `dap_products` ADD `price_increment_ceil` decimal(7,2) DEFAULT NULL";
$sql_ddl[] = "ALTER TABLE `dap_products` ADD `num_sales` int(5) DEFAULT '0'";
$sql_ddl[] = "ALTER TABLE `dap_products` ADD `num_days` smallint(6) DEFAULT '0'";
$sql_ddl[] = "ALTER TABLE `dap_products` ADD `timed_pricing_start_date` date DEFAULT '0000-00-00'";

//this should always be the last update
$sql_ddl[] = "UPDATE `dap_config` SET `value` = '4.0' WHERE  `name` = 'DAP_VERSION_CLIENT'  LIMIT 1";

?>