<?php

$sql_ddl[] = "CREATE TRIGGER `after_dapconfig_update` AFTER UPDATE ON `dap_config` FOR EACH ROW 
BEGIN
	IF ( (NEW.name = 'ADMIN_EMAIL') AND (NEW.value <> OLD.value) )
	THEN
		INSERT INTO 
			dap_mass_actions
		SET 
			actionType = 'EMAIL',
			actionKey = concat( OLD.value,':',UNIX_TIMESTAMP(),FLOOR(RAND() * 999999)),
			payload = concat(OLD.value,'||admin||||DAP ALERT!!! Config Change||AUTOMATED ALERT: DAP Config Change!!\n\nColumn Modified: ', OLD.description, '\nOld Value: ', OLD.value, '\nNew Value: ', NEW.value, '||||'),
			status = 'NEW',
			priority = '4';
	END IF;
	
	IF ( (NEW.name = 'ADMIN_EMAIL') AND (NEW.value <> OLD.value) )
	OR ( (NEW.name = 'GATEWAY_API_LOGIN') AND (NEW.value <> OLD.value) )
	OR ( (NEW.name = 'GATEWAY_TRANS_KEY') AND (NEW.value <> OLD.value) )
	OR ( (NEW.name = 'PAYPAL_API_LOGIN') AND (NEW.value <> OLD.value) )
	OR ( (NEW.name = 'PAYPAL_API_PASSWORD') AND (NEW.value <> OLD.value) )
	OR ( (NEW.name = 'PAYPAL_API_SIGNATURE') AND (NEW.value <> OLD.value) )
	OR ( (NEW.name = 'SECRET_KEY') AND (NEW.value <> OLD.value) )
	OR ( (NEW.name = 'PAYPAL_BUS_EMAIL') AND (NEW.value <> OLD.value) )
	OR ( (NEW.name = 'PAYPAL_AUTH_TOKEN') AND (NEW.value <> OLD.value) )
	OR ( (NEW.name = 'SITE_NAME') AND (NEW.value <> OLD.value) )
	OR ( (NEW.name = 'STRIPE_SECRET_KEY') AND (NEW.value <> OLD.value) )
	OR ( (NEW.name = 'STRIPE_PUBLISH_KEY') AND (NEW.value <> OLD.value) )
	THEN
		INSERT INTO 
			dap_mass_actions
		SET 
			actionType = 'EMAIL',
			actionKey = concat( (select value from dap_config where name='admin_email'),':',UNIX_TIMESTAMP(),FLOOR(RAND() * 999999)),
			payload = concat((select value from dap_config where name='admin_email'),'||admin||||DAP ALERT!!! Config Change||AUTOMATED ALERT: DAP Config Change!!\n\nColumn Modified: ', OLD.description, '\nOld Value: ', OLD.value, '\nNew Value: ', NEW.value, '||||'),
			status = 'NEW',
			priority = '4';
	END IF;
END
";


$sql_ddl[] = "CREATE TRIGGER `after_dapusers_update` AFTER UPDATE ON `dap_users` FOR EACH ROW 
BEGIN
	IF ( (OLD.account_type = 'U') AND (NEW.account_type = 'A') )
	THEN
		INSERT INTO 
			dap_mass_actions
		SET 
			actionType = 'EMAIL',
			actionKey = concat( (select value from dap_config where name='admin_email'),':',UNIX_TIMESTAMP(),FLOOR(RAND() * 999999)),
			payload = concat((select value from dap_config where name='admin_email'),'||admin||||DAP ALERT!!! New Admin Created||ALERT: New Admin Created!!\n\nUser Account Type Changed To Admin: \n\nUser id: ', OLD.id, '\nEmail: ', OLD.email, '||||'),
			status = 'NEW',
			priority = '4';
	END IF;
END
";


//this should always be the last update
$sql_ddl[] = "UPDATE `dap_config` SET `value` = '7.1' WHERE  `name` = 'DAP_VERSION_CLIENT'  LIMIT 1";

?>