<?php


$sql_ddl[] = "ALTER TABLE `dap_users` ADD `custom_role_id` INT(11) NULL";


$sql_ddl[] = "CREATE TABLE `dap_spc_settings` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `name` varchar(255)  NOT NULL,
 `value` varchar(255)  NOT NULL,
 `last_updated_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
 PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";  


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_capabilities` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `name` varchar(50)  NOT NULL,
 `description` tinytext ,
 PRIMARY KEY (`id`),
 UNIQUE KEY `name` (`name`)
  ) ENGINE=InnoDB DEFAULT CHARSET=utf8";  
  
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_roles` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `name` varchar(20)  NOT NULL,
 `description` tinytext ,
 PRIMARY KEY (`id`),
 UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";  
          
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_roles_caps_jn` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `roles_id` int(11) NOT NULL,
 `caps_id` int(11) NOT NULL,
 `allowed` char(1)  NOT NULL DEFAULT 'N',
 PRIMARY KEY (`id`)
)  ENGINE=InnoDB DEFAULT CHARSET=utf8";    
 
  
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_roles_product_access` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `role_id` varchar(20)  NOT NULL,
 `products` varchar(255) NOT NULL,
 PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";  


$sql_ddl[] = "INSERT INTO `dap_capabilities` (`name`, `description`) VALUES
( 'VIEW-ADMHOME', 'Admin Report: Ability to view DAP Admin Home'),
( 'VIEW-PAGE-MANAGEMEMBERS', 'Manage Members: To view the manage member page'),
( 'ALLOW-SEARCH-MANAGEMEMBERS', 'Manage Members: To allow search feature'),
( 'BULKACTION-GIVEACESS-MANAGEMEMBERS', 'Manage Members: This is for give access bulk action on manage members'),
( 'BULKACTION-REMOVEACCESS-MANAGEMEMBERS', 'Manage Members: This is for remove access bulk action on manage members'),
( 'BULKACTION-DELETEUSERS-MANAGEMEMBERS', 'Manage Members: This is for delete users bulk action on manage members'),
( 'LISTADMINUSERS-MANAGEMEMBERS', 'Manage Members: This is for listing of admins on manage members'),
( 'UPDATEUSER-MANAGEMEMBERS', 'Manage Members: Allow other roles to update the users'),
( 'HIDEEMAIL-MANAGEMEMBERS', 'Manage Members: Hide email on manage members'),
('HIDELASTNAME-MANAGEMEMBERS', 'Manage Members: Hide last name on manage members'),
( 'HIDEUSERACCOUNT-MANAGEMEMBERS', 'Manage Members: Hide user count on manage members'),
( 'DISABLE-ACCESSDATEUPDATE-MANAGEMEMBERS', 'Manage Members: Disable access update for other users'),
( 'DISABLE-UPDATEUSERSTATUS-MANAGEMEMBERS', 'Manage Members: Disable access to update other user\'s status on manage members'),
( 'DISABLE-UPDATELOCK-MANAGEMEMBERS', 'Manage Members: Dont allow users with this role to updates lock on manage members'),
( 'DISABLE-OPTINUPDATE-MANAGEMEMBERS', 'Manage Members: Dont allow users with this role to update opt-in status on manage members'),
( 'DISABLE-EDITORDERS-MANAGEMEMBERS', 'Manage Members: Disable edit orders button on manage members'),
( 'DISABLE-EDITMEMBER-MANAGEMEMBERS', 'Manage Members: Disable edit members '),
( 'DISABLE-SENDEMAILS-MANAGEMEMBERS', 'Manage Members: Disable email sending from manage members'),
('DISABLE-ADDAFFILIATE-MANAGEMEMBERS', 'Manage Members: Disable the add affiliate functionality'),
( 'VIEWALL-MANAGEMEMBERS', 'Manage Members: View all the details on manage members'),
( 'ALLOW-ALLUPDATES-MANAGEMEMBERS', 'Manage Members: Allow all updates on manage members'),
( 'DISABLE-ALLUPDATES-MANAGEMEMBERS', 'Manage Members: Disable all updates '),
( 'VIEW-PAGE-MANAGEORDERS', 'Manage Orders: View permission for manage orders'),
( 'DISABLE-UPDATEORDER-MANAGEORDERS', 'Manage Orders:Disable update order'),
( 'DISABLE-REFUNDORDER-MANAGEORDERS', 'Manage Orders:Disable refund'),
( 'DISABLE-DELETEORDER-MANAGEORDERS', 'Manage Orders:Disable delete orders'),
( 'DISABLE-CANCELORDER-MANAGEORDERS', 'Manage Orders:Disable cancel order'),
('BULKACTION-DELETEORDERS-MANAGEORDERS', 'Manage Orders:DIsbale bulk delete'),
( 'VIEW-PAGE-DASHBOARD', 'Admin Reports:  Enable or disable dashboard page view'),
( 'VIEW-SETUP-CONFIG', 'Manage Config: Disable config view'),
( 'HIDE-LICENSEKEY-CONFIG', 'Manage Config: hide dap license'),
( 'HIDE-FROMEMAIL-CONFIG', 'Manage Config: Hide from email'),
( 'HIDE-PAYPAL-CONFIG', 'Manage Config: hide paypal creds'),
( 'HIDE-AUTHNET-CONFIG', 'Manage Config: hide authent creds'),
( 'HIDE-STRIPE-CONFIG', 'Manage Config: Hide stripe creds'),
('HIDE-SECRETKEY-CONFIG', 'Manage Config: Hide secret key'),
( 'HIDE-DRIP-CONFIG', 'Manage Config: Hide drip'),
( 'HIDE-SOCIALMEDIA-CONFIG', 'Manage Config: Hide social media creds'),
( 'DISABLE-LICENSEKEY-CONFIG', 'Manage Config: disable license key update'),
( 'DISABLE-FROMEMAIL-CONFIG', 'Manage Config: disable from email update'),
( 'DISABLE-STRIPE-CONFIG', 'Manage Config: disable stripe settings'),
( 'DISABLE-SECRETKEY-CONFIG', 'Manage Config: disable secret key update'),
( 'DISABLE-DRIP-CONFIG', 'Manage Config: disable drip config update'),
( 'DISABLE-AUTHNET-CONFIG', 'Manage Config: disable authent config'),
( 'DISABLE-PAYPAL-CONFIG', 'Manage Config: Disable paypal update'),
( 'DISABLE-SOCIALMEDIA-CONFIG', 'Manage Config: disable social media creds update'),
( 'DISABLE-ALLUPDATES-CONFIG', 'Disable all the updates'),
( 'VIEWALL-CONFIG', 'Manage Config: View all details'),
( 'VIEW-SYSTEM-LOGS', 'View Logs:  View logs page'),
( 'ALLOW-VIEW-PRODUCT', 'Manage Products: View manage products page'),
( 'ALLOW-UPDATE-PRODUCT', 'Manage Products: Allow product update');
";


//this should always be the last update
$sql_ddl[] = "UPDATE `dap_config` SET `value` = '7.2' WHERE  `name` = 'DAP_VERSION_CLIENT'  LIMIT 1";

?>