<?php
ini_set('pcre.backtrack_limit',100000000);
ini_set('pcre.recursion_limit',100000000);

include_once "dap-config.php";
Dap_Config::loadConfig(true);
$popaddr = Dap_Config::get("EMAIL_SERVER_NAME"); //$_POST['popserver'];
$popport  = Dap_Config::get("EMAIL_SERVER_PORT"); //$_POST['popport'];
$proto  = Dap_Config::get("EMAIL_SERVER_PROTO"); //$_POST['proto'];
$ssl  = Dap_Config::get("EMAIL_SERVER_SSL"); //$_POST['ssl'];
$popuser = Dap_Config::get("EMAIL_SERVER_USER"); //$_POST['popuser'];
$poppass = Dap_Config::get("EMAIL_SERVER_PASS"); //$_POST['poppass'];

//$popaddr = "{imap.gmail.com:993/imap/ssl}INBOX";
if(isset($popport)) {
	$popaddr .= ":".$popport;
}
if(isset($proto)) {
	$popaddr .= "/".$proto;
}
if(isset($ssl) && $ssl == "ssl") {
	$popaddr .= "/ssl/novalidate-cert";
} else {
	$popaddr .= "/novalidate-cert";
	//$popaddr .= "/notls";
}

$popaddr = "{".$popaddr."}";
///imap/ssl}INBOX";
//$popaddr = "{pop.gmail.com:995/pop3/ssl/novalidate-cert}INBOX";
$popuser = $popuser;
$poppasswd = $poppass;

process1ShoppingCart($popaddr, $popuser, $poppasswd);



function process1ShoppingCart($popaddr, $popuser, $poppasswd) {

//lets get templates
$templates = Dap_PaymentProcessor::getEmailOrderTemplates();
if(!isset($templates) || sizeof($templates) < 1) {
	logToFile("Error Loading Email Order Templates..Check Templates Configuration", LOG_FATAL_DAP);
	return;
}
$template_keys = "";

//$searchsubject = "UNSEEN TEXT \"support.mcssl.com\"";
$searchsubject = "UNSEEN ";
//$searchsubject = "UNSEEN TEXT \"ClickBank Sale Notification\"";
//$searchsubject = "UNSEEN SINCE 23-April-2008";
//$searchsubject = "HEADER X-Mailer QUALCOMM";
// Open pop account.
//echo "*Pop/Imap Address: $popaddr*";
logToFile("*Pop/Imap Address: ".$popaddr."*", LOG_INFO_DAP);
//$mbox = imap_open( $popaddr, $popuser, $poppasswd) or die("Can't connect to Pop/Imap Server: " . imap_last_error());
$mbox = imap_open( $popaddr, $popuser, $poppasswd);
if($mbox === FALSE) {
  logToFile("Error Connecting to IMAP:".imap_last_error(), LOG_FATAL_DAP );
  sendAdminEmail("Can't connect to Pop/Imap Server: ",imap_last_error());
  exit; ;
}
$result = imap_search($mbox, $searchsubject, SE_UID);
if ($result) {
	//echo "$key".$value['id'] . ":" . $value['processor'] . $value['blocks'] . $value['template'] . "<br>";
	foreach ($result as $msgid) {
		//$header = imap_header($mbox,$msgid);
		$header = imap_fetchheader($mbox,$msgid,FT_UID);
		logToFile("Processing Email");
		//print_r($header);
		//logToFile("########################################################################################################");
		//echo "**UNSeen*".$header->Unseen."**";
		//if($header->Unseen == "U") {
		//}

		$post = array();

		$body = imap_fetchbody($mbox,$msgid,1,FT_UID);
		$full_msg = "<header>" . $header . "</header><body>" . $body . "</body>";
		//$full_msg = preg_replace("((\r\n)+)", trim("\\n"), $full_msg);
		//$order   = array("\r\n","\r");
		//$full_msg = str_replace($order, "\n", $full_msg);
		$full_msg = quoted_printable_decode($full_msg);
		//echo $full_msg;
		logToFile($full_msg);
		//imap_setflag_full($mbox, imap_uid($mbox, $msgid), "\\Seen \\Flagged", ST_UID);
		//loop thru templates and parse data
		//foreach ($templates as $template) {
		$processed = false;
		foreach ($templates as $key => $template) {
			logToFile("Looping over templates: " . $template['id'], LOG_INFO_DAP);
			preg_match_all($template['template'], $full_msg, $data);
			$ct =  count($data[1]);
			//if regexp didnt result in data, lets continue the loop. If it did, lets break out of loop
			if($ct == 0) continue;
			//we got match on template, so lets update template_keys thats used for db update.
			$template_keys = $template_keys . $template['id'] . ",";
			//
			$keys = explode(",",trim($template['blocks'], " ,"));

			if(sizeof($keys) < 5) {
				logToFile("Template Blocks are not correct..".$template['id'].":".$template['blocks'], LOG_FATAL_DAP);
			}
			$post['txn_id'] =  daptrim($data[$keys[0]][0]); //6 - Block 1 (Order Id)
			$post['txn_type'] =  "emailorder";
			$post['payment_status'] =  "Completed";
			$post['mc_currency'] =  "USD";
			$post['mc_gross'] =  daptrim($data[$keys[1]][0]); //12 - Block 2 (Price)
			$post['payer_email'] = daptrim($data[$keys[2]][0]); //4 - Block 3 (Email)
			$post['processor'] =  $template['processor']; //"1ShoppingCart-Email";
			$post['name'] =  daptrim($data[$keys[3]][0]); //2 - Block 4 (Name)
			$post['first_name'] = $post['name'];
			$names = explode(" ", $post['name']); //split(" ", $post['name']);
			if(sizeof($names) > 1) {
				$post['first_name'] = $names[0];
				$post['last_name'] = $names[1];
			}
			
			$pDesc = daptrim($data[$keys[4]][0]); //11 - Block 5 (Product Name)
			$pDesc = daptrim($pDesc);
			logToFile("Product description: *" . $pDesc . "*");
			//echo $body;
			logToFile("-------------- " . $template['processor'] . " -----------------<br>\n");

			logToFile("Order Number:*" . daptrim($post['txn_id']). "*", LOG_INFO_DAP);
			logToFile("Order Amount:*" . daptrim($post['mc_gross']). "*", LOG_INFO_DAP);
			logToFile("Order Processor:*" . daptrim($post['processor']). "*", LOG_INFO_DAP);
			logToFile("Product:*" . daptrim($pDesc) . "*", LOG_INFO_DAP);
			logToFile("Customer Information:*" . daptrim($post['first_name']) . "," . daptrim($post['last_name']) . "*", LOG_INFO_DAP);
			//logToFile("Customer Information:*" . $post['first_name'] . "," . $post['last_name'] . "*");
			logToFile("Customer Email:*" . daptrim($post['payer_email']) . "*", LOG_INFO_DAP);
			//$products = Dap_Product::loadProducts(trim($pDesc), "");
			$product = Dap_Product::loadProductByName(daptrim($pDesc));
			//echo sizeof($products);
			//if(sizeof($products) >0) {
			if(isset($product)) {
				logToFile("Product Id Match: " . $product->getId(), LOG_INFO_DAP);
				$post['item_number'] = $product->getId();
				try {
					$record_id = Dap_PaymentProcessor::recordEmailOrder($post);
					Dap_Transactions::setRecordStatus($record_id, 1);
					Dap_Transactions::processTransaction($record_id);
				} catch (PDOException $e) {
					logToFile($e->getMessage(),LOG_FATAL_DAP);
				} catch (Exception $e) {
					logToFile($e->getMessage(),LOG_FATAL_DAP);
				}
			} else  {
				logToFile("Product Id MISMatch: *" . $pDesc . "*", LOG_INFO_DAP);
				$product_mismatch = Dap_Config::get("PRODUCT_MISMATCH");
				if(isset($product_mismatch) && $product_mismatch == "Y") {
					$post['item_number'] = 0;
					try {
						$record_id = Dap_PaymentProcessor::recordEmailOrder($post);
						//Dap_Transactions::setRecordStatus($record_id, 1);
						//Dap_Transactions::processTransaction($record_id);
					} catch (PDOException $e) {
						logToFile($e->getMessage(),LOG_FATAL_DAP);
					} catch (Exception $e) {
						logToFile($e->getMessage(),LOG_FATAL_DAP);
					}
				} else {
					break;
				}
			}
			//imap_setflag_full($mbox, imap_uid($mbox, $msgid), "\\Seen \\Flagged", ST_UID);
			$processed = true;
			break;
		}

		if($processed === FALSE) {
			logToFile("UnSetting the Read Flag in Email");
			//imap_clearflag_full($mbox, imap_uid($mbox, $msgid), "\\Seen", ST_UID);
			imap_clearflag_full($mbox, $msgid, "\\Seen", ST_UID);
		}
	}
	logToFile("Use Template Ids:".$template_keys);
} else {
	logToFile("<br>No Emails To Process<br>");
}
}

function daptrim($string) {
	$string = trim($string, " \t\n\r\0\x0B.><*\xc2\xa0");
	return $string;
}

?>
