<?php

include_once ("dap-config.php");	

/**
 * Copyright (C) 2007 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

 /* This is the response handler code that will be invoked every time
  * a notification or request is sent by the Google Server
  *
  * To allow this code to receive responses, the url for this file
  * must be set on the seller page under Settings->Integration as the
  * "API Callback URL'
  * Order processing commands can be sent automatically by placing these
  * commands appropriately
  *
  * To use this code for merchant-calculated feedback, this url must be
  * set also as the merchant-calculations-url when the cart is posted
  * Depending on your calculations for shipping, taxes, coupons and gift
  * certificates update parts of the code as required
  *
  */

  require_once('googcheck/checkout-php-1.3.1/library/googleresponse.php');
  require_once('googcheck/checkout-php-1.3.1/library/googlemerchantcalculations.php');
  require_once('googcheck/checkout-php-1.3.1/library/googleresult.php');
  require_once('googcheck/checkout-php-1.3.1/library/googlerequest.php');

  define('RESPONSE_HANDLER_ERROR_LOG_FILE', 'googleerror.log');
  define('RESPONSE_HANDLER_LOG_FILE', 'googlemessage.log');

/*  
    $merchant_id = trim(Dap_Config::get('PAYPAL_API_LOGIN'));
    $merchant_key = trim(Dap_Config::get('PAYPAL_API_PASSWORD'));
*/

  $gc_connection_params =  Dap_Config::get('SECRET_KEY');
  $merchant_id = strtok($gc_connection_params, "|");
  $merchant_key = strtok ("|");	

  logToFile("dap-gc-responsehandler.php:  merchant_id=" . $merchant_id , LOG_DEBUG_DAP); 
  logToFile("dap-gc-responsehandler.php:  merchant_key=" . $merchant_key , LOG_DEBUG_DAP); 
  
  $server_type = "production";  // change this to go live
  $currency = 'USD';  // set to GBP if in the UK

  $Gresponse = new GoogleResponse($merchant_id, $merchant_key);
  $Grequest = new GoogleRequest($merchant_id, $merchant_key, $server_type, $currency);

  //Setup the log file
  $Gresponse->SetLogFiles(RESPONSE_HANDLER_ERROR_LOG_FILE, 
                                        RESPONSE_HANDLER_LOG_FILE, L_ALL);

  // Retrieve the XML sent in the HTTP POST request to the ResponseHandler
  $xml_response = isset($HTTP_RAW_POST_DATA)?
                    $HTTP_RAW_POST_DATA:file_get_contents("php://input");

  if (get_magic_quotes_gpc()) {
    $xml_response = stripslashes($xml_response);
  }
  
  
  list($root, $data) = $Gresponse->GetParsedXML($xml_response);
//  logToFile("dap-gc-responsehandler.php:  XML response:  " . $xml_response, LOG_DEBUG_DAP);
  
  $Gresponse->SetMerchantAuthentication($merchant_id, $merchant_key);

  /*$status = $Gresponse->HttpAuthentication();
  if(! $status) {
    die('authentication failed');
  }*/

  /* Commands to send the various order processing APIs
   * Send charge order : $Grequest->SendChargeOrder($data[$root]
   *    ['google-order-number']['VALUE'], <amount>);
   * Send process order : $Grequest->SendProcessOrder($data[$root]
   *    ['google-order-number']['VALUE']);
   * Send deliver order: $Grequest->SendDeliverOrder($data[$root]
   *    ['google-order-number']['VALUE'], <carrier>, <tracking-number>,
   *    <send_mail>);
   * Send archive order: $Grequest->SendArchiveOrder($data[$root]
   *    ['google-order-number']['VALUE']);
   *
   */

  switch ($root) {
    case "request-received": {
      break;
    }
    case "error": {
      break;
    }
    case "diagnosis": {
      break;
    }
    case "checkout-redirect": {
      break;
    }
    case "merchant-calculation-callback": {
      // Create the results and send it
/*      $merchant_calc = new GoogleMerchantCalculations($currency);

      // Loop through the list of address ids from the callback
      $addresses = get_arr_result($data[$root]['calculate']['addresses']['anonymous-address']);
      foreach($addresses as $curr_address) {
        $curr_id = $curr_address['id'];
        $country = $curr_address['country-code']['VALUE'];
        $city = $curr_address['city']['VALUE'];
        $region = $curr_address['region']['VALUE'];
        $postal_code = $curr_address['postal-code']['VALUE'];

        // Loop through each shipping method if merchant-calculated shipping
        // support is to be provided
        if(isset($data[$root]['calculate']['shipping'])) {
          $shipping = get_arr_result($data[$root]['calculate']['shipping']['method']);
          foreach($shipping as $curr_ship) {
            $name = $curr_ship['name'];
            //Compute the price for this shipping method and address id
            $price = 12; // Modify this to get the actual price
            $shippable = "true"; // Modify this as required
            $merchant_result = new GoogleResult($curr_id);
            $merchant_result->SetShippingDetails($name, $price, $shippable);

            if($data[$root]['calculate']['tax']['VALUE'] == "true") {
              //Compute tax for this address id and shipping type
              $amount = 15; // Modify this to the actual tax value
              $merchant_result->SetTaxDetails($amount);
            }

            if(isset($data[$root]['calculate']['merchant-code-strings']
                ['merchant-code-string'])) {
              $codes = get_arr_result($data[$root]['calculate']['merchant-code-strings']
                  ['merchant-code-string']);
              foreach($codes as $curr_code) {
                //Update this data as required to set whether the coupon is valid, the code and the amount
                $coupons = new GoogleGiftcerts("true", $curr_code['code'], 10, "debugtest");
                $merchant_result->AddGiftCertificates($coupons);
              }
             }
             $merchant_calc->AddResult($merchant_result);
          }
        } else {
          $merchant_result = new GoogleResult($curr_id);
          if($data[$root]['calculate']['tax']['VALUE'] == "true") {
            //Compute tax for this address id and shipping type
            $amount = 15; // Modify this to the actual tax value
            $merchant_result->SetTaxDetails($amount);
          }
          $codes = get_arr_result($data[$root]['calculate']['merchant-code-strings']
              ['merchant-code-string']);
          foreach($codes as $curr_code) {
            //Update this data as required to set whether the coupon is valid, the code and the amount
            $coupons = new GoogleGiftcerts("true", $curr_code['code'], 10, "debugtest");
            $merchant_result->AddGiftCertificates($coupons);
          }
          $merchant_calc->AddResult($merchant_result);
        }
      }
      $Gresponse->ProcessMerchantCalculations($merchant_calc);*/
      break;
    }
    case "new-order-notification": {
		logToFile("dap-gc-responsehandler.php:  received new-order-notification", LOG_DEBUG_DAP);
 
		$email=$data[$root]['buyer-billing-address']['email']['VALUE'];
	   processNewOrderNotification($data,$root);
	   logToFile("dap-gc-responsehandler.php:  email=".$email, LOG_DEBUG_DAP);

      $Gresponse->SendAck();
      break;
    }
    case "order-state-change-notification": {
		logToFile("dap-gc-responsehandler.php:  received order-state-change-notification", LOG_DEBUG_DAP);
		//$GResponse->ProcessOrderStateChangeNotification();
      
		logToFile("dap-gc-responsehandler.php:  sent ack for order-state-change-notification", LOG_DEBUG_DAP);
     
	  	$new_financial_state = $data[$root]['new-financial-order-state']['VALUE'];
      $new_fulfillment_order = $data[$root]['new-fulfillment-order-state']['VALUE'];

      switch($new_financial_state) {
        case 'REVIEWING': {
			 logToFile("dap-gc-responsehandler.php:  financial state=REVIEWING", LOG_DEBUG_DAP);  
          break;
        }
        case 'CHARGEABLE': {
          //$Grequest->SendProcessOrder($data[$root]['google-order-number']['VALUE']);
          //$Grequest->SendChargeOrder($data[$root]['google-order-number']['VALUE'],'');
			 logToFile("dap-gc-responsehandler.php:  financial state=CHARGEABLE", LOG_DEBUG_DAP); 
          break;
        }
        case 'CHARGING': {
			 logToFile("dap-gc-responsehandler.php:  financial state=CHARGING", LOG_DEBUG_DAP); 
          break;
        }
        case 'CHARGED': {
			 processOrderStateChangeNotification($data,$root);
			 logToFile("dap-gc-responsehandler.php:  financial state=CHARGED", LOG_DEBUG_DAP); 
          break;
        }
        case 'PAYMENT_DECLINED': {
			 logToFile("dap-gc-responsehandler.php:  financial state=PAYMENT_DECLINED", LOG_DEBUG_DAP); 
          break;
        }
        case 'CANCELLED': {
			 logToFile("dap-gc-responsehandler.php:  financial state=CANCELLED", LOG_DEBUG_DAP); 
          break;
        }
        case 'CANCELLED_BY_GOOGLE': {
          //$Grequest->SendBuyerMessage($data[$root]['google-order-number']['VALUE'],
          //    "Sorry, your order is cancelled by Google", true);
          break;
        }
        default:
		    logToFile("dap-gc-responsehandler.php:  default case, financial state=".$new_financial_state, LOG_DEBUG_DAP); 
          
          break;
      }

      switch($new_fulfillment_order) {
        case 'NEW': {
          break;
        }
        case 'PROCESSING': {
          break;
        }
        case 'DELIVERED': {
          break;
        }
        case 'WILL_NOT_DELIVER': {
          break;
        }
        default:
          break;
      }
		
		$Gresponse->SendAck();
      break;
    }
    case "charge-amount-notification": {
      //$Grequest->SendDeliverOrder($data[$root]['google-order-number']['VALUE'],
      //    <carrier>, <tracking-number>, <send-email>);
      //$Grequest->SendArchiveOrder($data[$root]['google-order-number']['VALUE'] );
		logToFile("dap-gc-responsehandler.php:  received charge-amount-notification", LOG_DEBUG_DAP);
      $Gresponse->SendAck();
      break;
    }
    case "chargeback-amount-notification": {
		logToFile("dap-gc-responsehandler.php:  received chargeback-amount-notification", LOG_DEBUG_DAP);
  
      $Gresponse->SendAck();
      break;
    }
    case "refund-amount-notification": {
		logToFile("dap-gc-responsehandler.php:  received refund-amount-notification", LOG_DEBUG_DAP);
      $Gresponse->SendAck();
      break;
    }
    case "risk-information-notification": {
		logToFile("dap-gc-responsehandler.php:  received risk-information-notification", LOG_DEBUG_DAP);
      $Gresponse->SendAck();
      break;
    }
    default:
	   logToFile("dap-gc-responsehandler.php:  received Invalid or not supported Message", LOG_DEBUG_DAP); 
      $Gresponse->SendBadRequestStatus("Invalid or not supported Message");
      break;
  }
  /* In case the XML API contains multiple open tags
     with the same value, then invoke this function and
     perform a foreach on the resultant array.
     This takes care of cases when there is only one unique tag
     or multiple tags.
     Examples of this are "anonymous-address", "merchant-code-string"
     from the merchant-calculations-callback API
  */
  function get_arr_result($child_node) {
    $result = array();
    if(isset($child_node)) {
      if(is_associative_array($child_node)) {
        $result[] = $child_node;
      }
      else {
        foreach($child_node as $curr_node){
          $result[] = $curr_node;
        }
      }
    }
    return $result;
  }

  /* Returns true if a given variable represents an associative array */
  function is_associative_array( $var ) {
    return is_array( $var ) && !is_numeric( implode( '', array_keys( $var ) ) );
  }
  
  
  function processNewOrderNotification($data,$root) 
  {
	//translate
	
	logToFile("dap-gc: processNewOrderNotification", LOG_DEBUG_DAP);
	
	$post=array();
	$post['payment_processor'] = 'gc';
	
	$post['email'] = $post['payer_email'] = $data[$root]['buyer-billing-address']['email']['VALUE'];
	logToFile("dap-gc: processNewOrderNotification, email=" . $post['email'], LOG_DEBUG_DAP);
	
	$post['txn_id'] = $data[$root]['google-order-number']['VALUE'];
	logToFile("dap-gc: processNewOrderNotification, google-order-number=" . $post['txn_id'], LOG_DEBUG_DAP);
	
	$post['txn_type'] = 'GCNewOrder';
	
	$full_name = $data[$root]['buyer-billing-address']['contact-name']['VALUE'];
   $post['last_name'] = strrev(strtok(strrev($full_name), " ")); //Returns surname.
   $post['first_name'] = substr($full_name, 0, ((strlen($post['last_name'])+1)*-1)); //Returns full name minus last name.

	logToFile("dap-gc: processNewOrderNotification, first_name=" .$post['first_name'], LOG_DEBUG_DAP);
	logToFile("dap-gc: processNewOrderNotification, last_name=" . $post['last_name'], LOG_DEBUG_DAP);
	
	$post['address1'] = $data[$root]['buyer-billing-address']['address1']['VALUE'];
	logToFile("dap-gc: processNewOrderNotification, address1=" . $post['address1'], LOG_DEBUG_DAP);
	
	$post['city'] = $data[$root]['buyer-billing-address']['city']['VALUE'];
	logToFile("dap-gc: processNewOrderNotification, state=" . $post['city'], LOG_DEBUG_DAP);
	
	$post['state'] = $data[$root]['buyer-billing-address']['region']['VALUE'];
	logToFile("dap-gc: processNewOrderNotification, state=" . $post['state'], LOG_DEBUG_DAP);
	
	$post['zip'] = $data[$root]['buyer-billing-address']['postal-code']['VALUE'];
	logToFile("dap-gc: processNewOrderNotification, zip=" . $post['zip'], LOG_DEBUG_DAP);
	
	$post['country'] = $data[$root]['buyer-billing-address']['country-code']['VALUE'];
	logToFile("dap-gc: processNewOrderNotification, country=" . $post['country'], LOG_DEBUG_DAP);
	
	$post['phone'] = $data[$root]['buyer-billing-address']['phone']['VALUE'];
	logToFile("dap-gc: processNewOrderNotification, phone=" . $post['phone'], LOG_DEBUG_DAP);
	
	$full_name = $data[$root]['buyer-shipping-address']['contact-name']['VALUE'];
   
	$post['ship_to_last_name'] = strrev(strtok(strrev($full_name), " ")); //Returns surname.
   $post['ship_to_first_name'] = substr($full_name, 0, ((strlen($post['ship_to_last_name'])+1)*-1)); //Returns full name minus last name.

	logToFile("dap-gc: processNewOrderNotification, ship_to_first_name=" . $post['ship_to_first_name'], LOG_DEBUG_DAP);
	
	$post['ship_to_address1'] = $data[$root]['buyer-shipping-address']['structured-name']['last-name']['VALUE'];
 	logToFile("dap-gc: processNewOrderNotification, ship_to_address1=" . $post['ship_to_address1'], LOG_DEBUG_DAP);
	
	$post['ship_to_city'] = $data[$root]['buyer-shipping-address']['city']['VALUE'];
	logToFile("dap-gc: processNewOrderNotification, ship_to_city=" . $post['ship_to_city'], LOG_DEBUG_DAP);
		
	$post['ship_to_state'] = $data[$root]['buyer-shipping-address']['region']['VALUE'];
	logToFile("dap-gc: processNewOrderNotification, ship_to_state=" . $post['ship_to_state'], LOG_DEBUG_DAP);
	
	$post['ship_to_zip'] = $data[$root]['buyer-shipping-address']['postal-code']['VALUE'];
	logToFile("dap-gc: processNewOrderNotification, ship_to_zip=" . $post['ship_to_zip'], LOG_DEBUG_DAP);
	
	$post['ship_to_country'] = $data[$root]['buyer-shipping-address']['country-code']['VALUE'];
	logToFile("dap-gc: processNewOrderNotification, ship_to_country=" . $post['ship_to_country'], LOG_DEBUG_DAP);
	
	$post['mc_currency'] = 'USD';
	
	$post['item_number'] = "1";
	
	if(!isset($post['payment_status'])) { 
		$post['payment_status'] = $data[$root]['financial-order-state']['VALUE'];
	}
	
	logToFile("dap-gc: processNewOrderNotification - calling recordIncoming", LOG_DEBUG_DAP);
	$items = get_arr_result($data[$root]['shopping-cart']['items']['item']);
	
	foreach( $items as $item ) { 
  	  $post['item_name'] = $item['item-name']['VALUE'];
	  logToFile("dap-gc: processNewOrderNotification - item_name" . $post['item_name'], LOG_DEBUG_DAP);
	  
	  $post['mc_gross'] = $item['unit-price']['VALUE'];
	  logToFile("dap-gc: processNewOrderNotification - mc_gross" . $post['mc_gross'], LOG_DEBUG_DAP);
	  
	  $record_id = Dap_PaymentProcessor::recordIncoming($post);
     logToFile("dap-gc.php: recorded incoming gc. id:". $record_id);
	
     if ($record_id != -1) {
		Dap_Transactions::setRecordStatus($record_id, 1);
	  }
	}
	
   return;
   }

	function processOrderStateChangeNotification($data,$root) 
   {
	//translate
	logToFile("dap-gc: processOrderStateChangeNotification", LOG_DEBUG_DAP);
	
	$post=array();
	
	logToFile("dap-gc: processOrderStateChangeNotification, google-order-number=" . $post['txn_id'], LOG_DEBUG_DAP);
	
	$post['payment_processor'] = 'gc';
	
	$transNumFilter = $post['txn_id'];
	$post['txn_id'] = $data[$root]['google-order-number']['VALUE'] . ":CHRG";
	$emailFilter = "";
	$productIdFilter = "";
	$statusFilter = "";
	$post['txn_type'] = 'GCOrderStateCHG';
	$post['mc_currency'] = 'USD';
	$post['payment_status'] = 'Completed';
		
	$TransactionsList = Dap_Transactions::loadTransactions($transNumFilter, $emailFilter, $productIdFilter, $statusFilter);
	foreach ($TransactionsList as $transaction) {
	
		parse_str($transaction->getTrans_blob(), $list);
	   
		$post['item_name'] = $transaction->getProduct_name();
		logToFile("dap-gc: processOrderStateChangeNotification: item_name=" . $post['item_name'], LOG_DEBUG_DAP);

		$post['item_number'] = "1";
		$post['mc_gross'] = $transaction->getPayment_value();
	   logToFile("dap-gc: processOrderStateChangeNotification - mc_gross" . $post['mc_gross'], LOG_DEBUG_DAP);
	
		$post['payer_email'] = $post['email'] = $transaction->getPayer_email();
		$post['first_name'] = $list['first_name'];
		logToFile("dap-gc: processOrderStateChangeNotification - payer_email" . $post['payer_email'], LOG_DEBUG_DAP);
		logToFile("dap-gc: processOrderStateChangeNotification - first_name" . $post['first_name'], LOG_DEBUG_DAP);
		
	   $post['last_name'] = $list['last_name'];
		$post['address1'] = $list['address1'];
		$post['city'] = $list['city'];
		$post['state'] = $list['state'];
		$post['zip'] = $list['zip'];
		$post['country'] = $list['country'];
		$post['phone'] = $list['phone'];
		$post['ship_to_first_name'] = $list['ship_to_first_name'];
		$post['ship_to_address1'] = $list['ship_to_address1'];
		$post['ship_to_city'] = $list['ship_to_city'];
		$post['ship_to_state'] = $list['ship_to_state'];
		$post['ship_to_zip'] = $list['ship_to_zip'];
		$post['ship_to_country'] = $list['ship_to_country'];

		$record_id = Dap_PaymentProcessor::recordIncoming($post);
      logToFile("dap-gc.php: recorded incoming gc. id:". $record_id);
	
      if ($record_id != -1) {
			Dap_Transactions::setRecordStatus($record_id, 1);
			Dap_Transactions::processTransaction($record_id);
	   }
		
	}
	
   return;
   }


?>