<?php
class DAP_CoursePrerequisite{
	
	var $id;
	var $course_id;	
	var $prerequisite_ids;	 
	var $page_url;
	var $error_msg;
	var $date;
	var $type;
	var $error_msg_text;

	
	function getId() {
		return $this->id;
	}
	
	function setId($o) { 
		$this->id = $o;
	}
	
	function getCourseId() {
		return $this->course_id;
	}
	
	function setCourseId($o) {
		$this->course_id = $o;
	}
	
	function getPrerequisiteIds() {
		return $this->prerequisite_ids;
	}
	
	function setPrerequisiteIds($o) {
		$this->prerequisite_ids = $o;
	}
	
	function getPage_url() {
		return $this->page_url;
	}
	
	function setPage_url($o) {
		$this->page_url = $o;
	}
	function getError_msg() {
		return $this->error_msg;
	}
	
	function setError_msg($o) {
		$this->error_msg = $o;
	} 
	function getDate() {
		return $this->date;
	}
	
	function setDate($o) {
		$this->date = $o;
	}
	
	
	function getType() {
		return $this->type;
	}
	
	function setType($o) {
		$this->type = $o;
	}
	
	function getErrorMsgText() {
		return $this->error_msg_text;
	}
	
	function setErrorMsgText($o) {
		$this->error_msg_text = $o;
	}
	
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			 
			$sql = "insert into dap_course_prerequisite
						(course_id, prerequisite_ids, page_url, error_msg, type, error_msg_text, date)
					values
						(:course_id, :prerequisite_ids, :page_url, :error_msg, :type, :error_msg_text, now())";			
		
		
		    
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':course_id', $this->getCourseId(), PDO::PARAM_INT);
 			$stmt->bindParam(':prerequisite_ids', $this->getPrerequisiteIds(), PDO::PARAM_STR);
			$stmt->bindParam(':page_url', $this->getPage_url(), PDO::PARAM_STR);
			$stmt->bindParam(':error_msg', $this->getError_msg(), PDO::PARAM_STR);
			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_STR);
			$stmt->bindParam(':error_msg_text', $this->getErrorMsgText(), PDO::PARAM_STR);
			
			 
			$stmt->execute();

			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	
	
	
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();			

			$sql = "update dap_course_prerequisite set
						course_id = :course_id,
						prerequisite_ids = :prerequisite_ids,
						page_url = :page_url,
						error_msg = :error_msg,						 		
						type = :type,						 		
						error_msg_text = :error_msg_text,						 		
						date  = now() 
						
					where
						id = :id";
		 
	 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':course_id', $this->getCourseId(), PDO::PARAM_INT);
 			$stmt->bindParam(':prerequisite_ids', $this->getPrerequisiteIds(), PDO::PARAM_STR);
			$stmt->bindParam(':page_url', $this->getPage_url(), PDO::PARAM_STR);
			$stmt->bindParam(':error_msg', $this->getError_msg(), PDO::PARAM_STR);
			//$stmt->bindParam(':date', now(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_STR);
			$stmt->bindParam(':error_msg_text', $this->getErrorMsgText(), PDO::PARAM_STR);
			$stmt->execute();		
			
			$stmt = null;
			$dap_dbh = null;

			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	 
	//Load  
	public static function load() {
		$LoadList = array(); 
		$sql = "select * from dap_course_prerequisite ";		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_CoursePrerequisite(); 

				$data->setId( $row["id"] );
				$data->setCourseId( $row["course_id"] );
				$data->setPrerequisiteIds( $row["prerequisite_ids"] );
				$data->setPage_url( $row["page_url"] );
				$data->setError_msg( $row["error_msg"] );		
				$data->setDate( $row["date"] ); 			 
				$data->setType( $row["type"] ); 			 
				$data->setErrorMsgText( $row["error_msg_text"] ); 			 
				$LoadList[] = $data;
			}

			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
  
	 
	//Load  
	public static function loadById($id = 0) {
		
		$sql = "select * from dap_course_prerequisite where id = ".$id;		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_CoursePrerequisite();

				$data->setId( $row["id"] );
				$data->setCourseId( $row["course_id"] );
				$data->setPrerequisiteIds( $row["prerequisite_ids"] );
				$data->setPage_url( $row["page_url"] );
				$data->setError_msg( $row["error_msg"] );		
				$data->setDate( $row["date"] ); 
				$data->setType( $row["type"] ); 
				$data->setErrorMsgText( $row["error_msg_text"] ); 			
				return   $data;
			}

			return false;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	
	public static function loadByCourseId($course_id = 0) {
		
		$sql = "select * from dap_course_prerequisite where course_id = ".$course_id;		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_CoursePrerequisite();

				$data->setId( $row["id"] );
				$data->setCourseId( $row["course_id"] );
				$data->setPrerequisiteIds( $row["prerequisite_ids"] );
				$data->setPage_url( $row["page_url"] );
				$data->setError_msg( $row["error_msg"] );		
				$data->setDate( $row["date"] ); 	
				$data->setType( $row["type"] ); 
				$data->setErrorMsgText( $row["error_msg_text"] ); 		
				return   $data;
			}

			return null;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function delete($id) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$dap_dbh->beginTransaction();			
		
			$sql = "delete from  
					dap_course_prerequisite
					where id =:id";					
					
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);			 
			$stmt->execute();
			
			$dap_dbh->commit(); 			
			$stmt = null;
			$dap_dbh = null;		
			return;			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}		
	}	 
	
	
}
