<?php 
class DAP_CourseRules{ 
	 
	var $id;
	var $course_id;
	var $resource_id;
	var $name;
	var $value;
	var $date;
	var $module_id;
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getCourseId() {
		return $this->course_id;
	}
	function setCourseId($o) {
		$this->course_id = $o;
	}
	function getResourceId() {
		return $this->resource_id;
	}
	function setResourceId($o) {
		$this->resource_id = $o;
	}
	function getName() {
		return $this->name;
	}
	function setName($o) {
		$this->name = $o;
	}
	
	function getValue() {
		return $this->value;
	}
	function setValue($o) {
		$this->value = $o;
	}
	function getDate() {
		return $this->date;
	}
	function setDate($o) {
		$this->date = $o;
	}
	
	function getModuleId() {
		return $this->module_id;
	}
	function setModuleId($o) {
		$this->module_id = $o;
	}
	
	
	
    public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$tableName = "dap_course_rules";
			
			$sql = "insert into ".$tableName." 
						(course_id,resource_id, name, value, date , module_id )
					values
						(:course_id, :resource_id, :name, :value, :date, :module_id)";
			
		 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':course_id', $this->getCourseId(), PDO::PARAM_INT);
			$stmt->bindParam(':module_id', $this->getModuleId(), PDO::PARAM_INT);
			$stmt->bindParam(':resource_id', $this->getResourceId(), PDO::PARAM_INT);
 			$stmt->bindParam(':name', $this->getName(), PDO::PARAM_STR);
			$stmt->bindParam(':value', $this->getValue(), PDO::PARAM_STR);
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->execute();
            $stmt = null;
            $last_id = $dap_dbh->lastInsertId();
			$dap_dbh = null;
			return $last_id;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
    
   
	/*
	 * update message in database
	 */ 
	public function update() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$tableName = "dap_course_rules";
			
			$sql = "update ".$tableName." set
						course_id = :course_id,
						module_id = :module_id,
						resource_id = :resource_id,
						name = :name,
						value = :value ,
						date = :date
					where
						id = :id ";
						
		 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':course_id', $this->getCourseId(), PDO::PARAM_INT);
			$stmt->bindParam(':module_id', $this->getModuleId(), PDO::PARAM_INT);
			$stmt->bindParam(':resource_id', $this->getResourceId(), PDO::PARAM_INT);
 			$stmt->bindParam(':name', $this->getName(), PDO::PARAM_STR);
			$stmt->bindParam(':value', $this->getValue(), PDO::PARAM_STR);
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
			return true;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	
	
	public static function loadByCourseIdAndLessonIdAndModuleId($course_id = 0,$resource_id = 0, $module_id = 0) {
		$dap_dbh = Dap_Connection::getConnection();
		$sqbdataarray = null;
       
		//Load product details from database
		$sql = "select *
			from
				dap_course_rules
			where
			    course_id = :course_id and  
			    module_id = :module_id and  
				resource_id = :resource_id";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':course_id', $course_id, PDO::PARAM_INT);
		$stmt->bindParam(':module_id', $module_id, PDO::PARAM_INT);   
		$stmt->bindParam(':resource_id', $resource_id, PDO::PARAM_INT);   
		$stmt->execute();
		while ($row = $stmt->fetch()) {
				$sqbdata = new DAP_CourseRules();					
				$sqbdata->setId( $row["id"] );
				$sqbdata->setCourseId( stripslashes($row["course_id"]) );
				$sqbdata->setModuleId( stripslashes($row["module_id"]) );
				$sqbdata->setResourceId( stripslashes($row["resource_id"]) );
				$sqbdata->setName( stripslashes($row["name"]) );
				$sqbdata->setValue( stripslashes($row["value"]) );
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdataarray[] = $sqbdata;
		}

		return $sqbdataarray;
		
		
		
	}
	
	public static function loadByCourseIdAndLessonIdAndModuleIdAndName($course_id = 0,$resource_id = 0, $module_id = 0,$name = '') {
		$dap_dbh = Dap_Connection::getConnection();
		$sqbdataarray = null;
      
		//Load product details from database
		$sql = "select *
			from
				dap_course_rules
			where
			    course_id = :course_id and  
			    module_id = :module_id and  
				resource_id = :resource_id and 
				name = :name";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':course_id', $course_id, PDO::PARAM_INT);
		$stmt->bindParam(':module_id', $module_id, PDO::PARAM_INT);   
		$stmt->bindParam(':resource_id', $resource_id, PDO::PARAM_INT);   
		$stmt->bindParam(':name', $name, PDO::PARAM_STR);   
		$stmt->execute();
		while ($row = $stmt->fetch()) {
				$sqbdata = new DAP_CourseRules();					
				$sqbdata->setId( $row["id"] );
				$sqbdata->setCourseId( stripslashes($row["course_id"]) );
				$sqbdata->setModuleId( stripslashes($row["module_id"]) );
				$sqbdata->setResourceId( stripslashes($row["resource_id"]) );
				$sqbdata->setName( stripslashes($row["name"]) );
				$sqbdata->setValue( stripslashes($row["value"]) );
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdataarray = $sqbdata;
		}

		return $sqbdataarray;
		
		
		
	}
	
	
	
	public static function loadByName($name = '') {
		$dap_dbh = Dap_Connection::getConnection();
		$sqbdataarray = null;
      
		//Load product details from database
		$sql = "select *
			from
				dap_course_rules
			where
			   
				name = :name  order by date desc";

		$stmt = $dap_dbh->prepare($sql);
		
		$stmt->bindParam(':name', $name, PDO::PARAM_STR);   
		$stmt->execute();
		while ($row = $stmt->fetch()) {
				$sqbdata = new DAP_CourseRules();					
				$sqbdata->setId( $row["id"] );
				$sqbdata->setCourseId( stripslashes($row["course_id"]) );
				$sqbdata->setModuleId( stripslashes($row["module_id"]) );
				$sqbdata->setResourceId( stripslashes($row["resource_id"]) );
				$sqbdata->setName( stripslashes($row["name"]) );
				$sqbdata->setValue( stripslashes($row["value"]) );
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdataarray[] = $sqbdata;
		}

		return $sqbdataarray;
		
		
		
	}
	
		
	
	/*
	 * load all messages
	*/ 
	public static function load() {
		
		$LoadList = array(); 
		$tableName = "dap_course_rules";
		$sql = "select * from ".$tableName;		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_CourseRules(); 

				$data->setId( $row["id"] );
				$data->setCourseId( $row["course_id"] );
				$data->setResourceId( $row["resource_id"] );
				$data->setModuleId( $row["module_id"] );
				$data->setName( $row["name"] );
				$data->setValue( $row["value"] );
				$data->setDate( $row["date"] );
				$LoadList[] = $data;
			}
			$stmt = null;
			$dap_dbh = null;
			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
			
	}
	 
	public static function deleteById($id = ''){
        
        $tableName = "dap_course_rules";
		$sql = "delete from ".$tableName." where `id` =:id";
		
		try{		
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
			return true;
	    } catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
				
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
       	 
	}
	
	public static function deleteByCourseIdAndModuleIdAndLessonId($course_id = 0, $module_id = 0, $resource_id = 0){
        
        $tableName = "dap_course_rules";
        
		$sql = "delete from ".$tableName." where   course_id = :course_id and  
			    module_id = :module_id and  
				resource_id = :resource_id ";  
		
		try{		
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':course_id', $course_id, PDO::PARAM_INT);
			$stmt->bindParam(':module_id', $module_id, PDO::PARAM_INT);
			$stmt->bindParam(':resource_id', $resource_id, PDO::PARAM_INT);
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
			return true;
	    } catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
				
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
       	 
	}
	
}
		
	
