<?php
class Dap_GroupRules {
	
	var $id;
	var $product_id;
	var $allowed_product_ids;	
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getProductId() {
		return $this->product_id;
	}
	function setProductId($o) {
		$this->product_id = $o;
	}
	
	function getAllowedProductsId() {
		return $this->allowed_product_ids;
	}
	function setAllowedProductsId($o) {
		$this->allowed_product_ids = $o;
	}
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$price = "0.00"; //We don't care about price at this time

			$sql = "insert into dap_group_rules
						(product_id, allowed_product_ids, date)
					values
						(:product_id, :allowed_product_ids, now())";

			$stmt = $dap_dbh->prepare($sql);
			
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_STR);
			$stmt->bindParam(':allowed_product_ids', $this->getAllowedProductsId(), PDO::PARAM_STR);
			$stmt->execute();

			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			
				$sql = "update dap_group_rules set
							product_id = :product_id,
							allowed_product_ids = :allowed_product_ids 
						    where id = :id";
			 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_STR);
			$stmt->bindParam(':allowed_product_ids', $this->getAllowedProductsId(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
		
			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public function updateByProductID($product_id) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			
				$sql = "update dap_group_rules set
							id = :id,
							allowed_product_ids = :allowed_product_ids 
						    where product_id = :product_id";
			
			 	logToFile("updateByProductID: sql=".$sql,LOG_DEBUG_DAP);	
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':product_id', $product_id, PDO::PARAM_STR);
			$stmt->bindParam(':allowed_product_ids', $this->getAllowedProductsId(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
		
			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function loadByProductId($p_id) {
		 
		$sql = "select * from dap_group_rules
					where
						product_id = $p_id";
		

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			
			$groupRulesList = array();
			
			while ($row = $stmt->fetch()) {
				$groupRules = new Dap_GroupRules();

				$groupRules->setId( $row["id"] );
				$groupRules->setProductId($row["product_id"]);
				$groupRules->setAllowedProductsId($row["allowed_product_ids"]);
				$groupRulesList[] = $groupRules;
			}

			return $groupRulesList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function load() {
		 
		$sql = "select * from dap_group_rules ";
		

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			
			$groupRulesList = array();
			
			while ($row = $stmt->fetch()) {
				$groupRules = new Dap_GroupRules();

				$groupRules->setId( $row["id"] );
				$groupRules->setProductId($row["product_id"]);
				$groupRules->setAllowedProductsId($row["allowed_product_ids"]);
				$groupRulesList[] = $groupRules;
			}

			return $groupRulesList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public function delete($id) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$dap_dbh->beginTransaction();
			
			//$id = $this->getId();
			//delete from usersproducts table
			  $sql = "delete from  
					dap_group_rules
					where id =:id"; 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
			
			$dap_dbh->commit(); 
			
			$stmt = null;
			$dap_dbh = null;		
			return;			
		} catch (PDOException $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;				
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;			
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}		
	}
	
	
}
