<?php
class DAP_MemberEngagementRules{
	
	var $id;
	var $engagement_id;
	var $display_option;		
	var $show_list;	 
	var $hide_list;	 
	var $status;	 
	var $show_slider;	 
	var $num_of_products;	 
	var $template_num;	 
	var $total_num_of_products;	 
	var $template_html;	 
	var $date;
	var $custom_values;	 
	var $sorting_option;	 
	var $sorted_products_list;	 
	
	
	function getTemplateHtml() {
		return $this->template_html;
	}
	
	function setTemplateHtml($o) {
		$this->template_html = $o;
	}
	
	function getTemplateNum() {
		return $this->template_num;
	}
	
	function setTemplateNum($o) {
		$this->template_num = $o;
	}
	
	function getId() {
		return $this->id;
	}
	
	function setId($o) {
		$this->id = $o;
	}
	
	function getEngagementId() {
		return $this->engagement_id;
	}
	
	function setEngagementId($o) {
		$this->engagement_id = $o;
	}
	
	function getDisplayOption() {
		return $this->display_option;
	}
	
	function setDisplayOption($o) {
		$this->display_option = $o;
	}
	
	function getHideList() {
		return $this->hide_list;
	}
	
	function setHideList($o) {
		$this->hide_list = $o;
	}
	function getStatus() {
		return $this->status;
	}
	
	function setStatus($o) {
		$this->status = $o;
	}
	
	function getShowSlider() {
		return $this->show_slider;
	}
	
	function setShowSlider($o) {
		$this->show_slider = $o;
	}
	
	function getNumOfProducts() {
		return $this->num_of_products;
	}
	
	function setNumOfProducts($o) {
		$this->num_of_products = $o;
	}	

	function getTotalNumOfProducts() {
		return $this->total_num_of_products;
	}
	
	function setTotalNumOfProducts($o) {
		$this->total_num_of_products = $o;
	}	
	
	function getDate() {
		return $this->date;
	}
	
	function setDate($o) {
		$this->date = $o;
	}
 
    function getCustomValues() {
		return $this->custom_values;
	}
	
	function setCustomValues($o) {
		$this->custom_values = $o;
	}
	function getSortingOption() {
		return $this->sorting_option;
	}	
	function setSortingOption($o) {
		$this->sorting_option = $o;
	}
	function getSortedProductsList() {
		return $this->sorted_products_list;
	}	
	function setSortedProductsList($o) {
		$this->sorted_products_list = $o;
	}
	
   function getShowList() {
		return $this->show_list;
	}
	
	function setShowList($o) {
		$this->show_list = $o;
	}	
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			 
			$sql = "insert into  dap_member_engagement_rules
						(engagement_id, display_option, show_list, hide_list, status, show_slider,num_of_products, total_num_of_products, date, template_num, template_html, custom_values, sorting_option, sorted_products_list)
					values
						(:engagement_id, :display_option, :show_list, :hide_list, :status, :show_slider, :num_of_products,:total_num_of_products,  now(), :template_num, :template_html, :custom_values, :sorting_option, :sorted_products_list)";			
				
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':engagement_id', $this->getEngagementId(), PDO::PARAM_INT);
 			$stmt->bindParam(':display_option', $this->getDisplayOption(), PDO::PARAM_STR);
			$stmt->bindParam(':show_list', $this->getShowList(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':hide_list', $this->getHideList(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':show_slider', $this->getShowSlider(), PDO::PARAM_STR);		 	
			$stmt->bindParam(':num_of_products', $this->getNumOfProducts(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':template_num', $this->getTemplateNum(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':total_num_of_products', $this->getTotalNumOfProducts(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':template_html', $this->getTemplateHtml(), PDO::PARAM_STR);	
			$stmt->bindParam(':custom_values', $this->getCustomValues(), PDO::PARAM_STR);		 	
			$stmt->bindParam(':sorting_option', $this->getSortingOption(), PDO::PARAM_STR);		 	
			$stmt->bindParam(':sorted_products_list', $this->getSortedProductsList(), PDO::PARAM_STR);		 	

			$stmt->execute();
 
			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	
	public function updateByEngagementIdAndDisplayOption() {
		try {
			$dap_dbh = Dap_Connection::getConnection();			
			
			$sql = "update  dap_member_engagement_rules set
						
						show_list = :show_list,						
						hide_list = :hide_list,						
						status = :status,						
						show_slider = :show_slider,						
						num_of_products = :num_of_products,						
						template_num = :template_num,						
						total_num_of_products = :total_num_of_products,						
						template_html = :template_html,						
						custom_values = :custom_values,						
						sorting_option = :sorting_option,						
						sorted_products_list = :sorted_products_list,						
						date  = now() 
					where
						display_option = :display_option and 
						engagement_id = :engagement_id";	
		 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':engagement_id', $this->getEngagementId(), PDO::PARAM_INT);
 			$stmt->bindParam(':display_option', $this->getDisplayOption(), PDO::PARAM_STR);
 			$stmt->bindParam(':show_list', $this->getShowList(), PDO::PARAM_STR);	
			$stmt->bindParam(':hide_list', $this->getHideList(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':show_slider', $this->getShowSlider(), PDO::PARAM_STR);
			$stmt->bindParam(':num_of_products', $this->getNumOfProducts(), PDO::PARAM_STR);
			$stmt->bindParam(':template_num', $this->getTemplateNum(), PDO::PARAM_STR);
			$stmt->bindParam(':total_num_of_products', $this->getTotalNumOfProducts(), PDO::PARAM_STR);	
			$stmt->bindParam(':template_html', $this->getTemplateHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':custom_values', $this->getCustomValues(), PDO::PARAM_STR);			
			$stmt->bindParam(':sorting_option', $this->getSortingOption(), PDO::PARAM_STR);		 	
			$stmt->bindParam(':sorted_products_list', $this->getSortedProductsList(), PDO::PARAM_STR);	
			$stmt->execute();		
			
			$stmt = null;
			$dap_dbh = null;

			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();			
			
			$sql = "update  dap_member_engagement_rules set 
						display_option = :display_option,  
						engagement_id = :engagement_id, 
						show_list = :show_list,						
						hide_list = :hide_list,						
						status = :status,						
						show_slider = :show_slider,						
						num_of_products = :num_of_products,						
						template_num = :template_num,						
						total_num_of_products = :total_num_of_products,						
						template_html = :template_html,						
						custom_values = :custom_values,
						sorting_option = :sorting_option,						
						sorted_products_list = :sorted_products_list,						
						date  = now() 
					where
						id= :id";
		 
	
		 
			$stmt = $dap_dbh->prepare($sql);
			
			$stmt->bindParam(':engagement_id', $this->getEngagementId(), PDO::PARAM_INT);
 			$stmt->bindParam(':display_option', $this->getDisplayOption(), PDO::PARAM_STR);
 			$stmt->bindParam(':show_list', $this->getShowList(), PDO::PARAM_STR);
			$stmt->bindParam(':hide_list', $this->getHideList(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':show_slider', $this->getShowSlider(), PDO::PARAM_STR);
			$stmt->bindParam(':num_of_products', $this->getNumOfProducts(), PDO::PARAM_STR);
			$stmt->bindParam(':template_num', $this->getTemplateNum(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getTemplateNum(), PDO::PARAM_INT);
			$stmt->bindParam(':total_num_of_products', $this->getTotalNumOfProducts(), PDO::PARAM_STR);		
			$stmt->bindParam(':template_html', $this->getTemplateHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':custom_values', $this->getCustomValues(), PDO::PARAM_STR);	
			$stmt->bindParam(':sorting_option', $this->getSortingOption(), PDO::PARAM_STR);		 	
			$stmt->bindParam(':sorted_products_list', $this->getSortedProductsList(), PDO::PARAM_STR);	
			$stmt->execute();		
			
			$stmt = null;
			$dap_dbh = null;

			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	
	public function updateByEngagementId() {
		try {
			$dap_dbh = Dap_Connection::getConnection();			
			
			$sql = "update  dap_member_engagement_rules set
						
						display_option = :display_option,
						show_list = :show_list,						
						hide_list = :hide_list,						
						status = :status,						
						show_slider = :show_slider,						
						num_of_products = :num_of_products,						
						template_num = :template_num,						
						template_html = :template_html,						
						custom_values = :custom_values,	
						sorting_option = :sorting_option,						
						sorted_products_list = :sorted_products_list,						
						date  = now() 
					where
						engagement_id = :engagement_id";
		 
	
		 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':engagement_id', $this->getEngagementId(), PDO::PARAM_STR);
 			$stmt->bindParam(':display_option', $this->getDisplayOption(), PDO::PARAM_STR);
 			$stmt->bindParam(':show_list', $this->getShowList(), PDO::PARAM_STR);
			$stmt->bindParam(':hide_list', $this->getHideList(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':show_slider', $this->getShowSlider(), PDO::PARAM_STR);
			$stmt->bindParam(':num_of_products', $this->getNumOfProducts(), PDO::PARAM_STR);
			$stmt->bindParam(':template_num', $this->getTemplateNum(), PDO::PARAM_STR);
			$stmt->bindParam(':total_num_of_products', $this->getTotalNumOfProducts(), PDO::PARAM_STR);		
			$stmt->bindParam(':template_html', $this->getTemplateHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':custom_values', $this->getCustomValues(), PDO::PARAM_STR);	
			$stmt->bindParam(':sorting_option', $this->getSortingOption(), PDO::PARAM_STR);		 	
			$stmt->bindParam(':sorted_products_list', $this->getSortedProductsList(), PDO::PARAM_STR);
			$stmt->execute();		
			
			$stmt = null;
			$dap_dbh = null;

			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	
	//Load  
	public static function load() {
		$LoadList = null; 
		$sql = "select * from  dap_member_engagement_rules ";		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_MemberEngagementRules(); 

				$data->setId( $row["id"] );
				$data->setEngagementId( $row["engagement_id"] );
				$data->setDisplayOption( $row["display_option"] );
				
				$data->setShowList( $row["show_list"] ); 
				$data->setHideList( $row["hide_list"] ); 
				$data->setStatus( $row["status"] ); 
				$data->setShowSlider( $row["show_slider"] ); 
				$data->setNumOfProducts( $row["num_of_products"] ); 
				$data->setTotalNumOfProducts( $row["total_num_of_products"] ); 
				$data->setDate( $row["date"] ); 
				$data->setTemplateNum( $row["template_num"] ); 
				$data->setTemplateHtml( $row["template_html"] ); 
				$data->setCustomValues( $row["custom_values"] ); 
				$data->setSortingOption( $row["sorting_option"] ); 
				$data->setSortedProductsList( $row["sorted_products_list"] ); 				
				
				$LoadList[] = $data;
			}

			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
 
	//Load  
	public static function loadByEngagementId($engagement_id) {
		$LoadList = null; 
		$sql = "select * from dap_member_engagement_rules where engagement_id = ".$engagement_id." order by id DESC";
			 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				
				$data = new DAP_MemberEngagementRules(); 

				$data->setId( $row["id"] );
				$data->setEngagementId( $row["engagement_id"] );
				$data->setDisplayOption( $row["display_option"] );
				$data->setShowList( $row["show_list"] ); 
				$data->setHideList( $row["hide_list"] ); 
				$data->setStatus( $row["status"] ); 
				$data->setShowSlider( $row["show_slider"] ); 
				$data->setNumOfProducts( $row["num_of_products"] );
				$data->setTotalNumOfProducts( $row["total_num_of_products"] );  
				$data->setDate( $row["date"] ); 
				$data->setTemplateNum( $row["template_num"] ); 
				$data->setTemplateHtml( $row["template_html"] ); 
				$data->setCustomValues( $row["custom_values"] ); 
				$data->setSortingOption( $row["sorting_option"] ); 
				$data->setSortedProductsList( $row["sorted_products_list"] ); 
				$LoadList[] = $data;
			}		
			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	 
	 
	public static function loadByEngagementIdAndDisplayOption($engagement_id = 0,$display_option = '' ) {
		$LoadList = null; 
		$sql = "select * from dap_member_engagement_rules where engagement_id = ".$engagement_id." and display_option = '".$display_option."' order by id DESC";
			
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				
				$data = new DAP_MemberEngagementRules(); 

				$data->setId( $row["id"] );
				$data->setEngagementId( $row["engagement_id"] );
				$data->setDisplayOption( $row["display_option"] );
				$data->setShowList( $row["show_list"] ); 
				$data->setHideList( $row["hide_list"] ); 
				$data->setStatus( $row["status"] ); 
				$data->setShowSlider( $row["show_slider"] ); 
				$data->setNumOfProducts( $row["num_of_products"] ); 
				$data->setTotalNumOfProducts( $row["total_num_of_products"] ); 
				$data->setDate( $row["date"] ); 
				$data->setTemplateNum( $row["template_num"] ); 
				$data->setTemplateHtml( $row["template_html"] ); 
				$data->setCustomValues( $row["custom_values"] ); 
				$data->setSortingOption( $row["sorting_option"] ); 
				$data->setSortedProductsList( $row["sorted_products_list"] ); 
				$LoadList = $data;
			}		
			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	  
	 
	//Load  
	public static function loadById($id = 0) {
		
		$sql = "select * from dap_member_engagement_rules where id = ".$id;		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_MemberEngagementRules(); 

				$data->setId( $row["id"] );
				$data->setEngagementId( $row["engagement_id"] ); 
				$data->setDisplayOption( $row["display_option"] );
				$data->setShowList( $row["show_list"] ); 
				$data->setHideList( $row["hide_list"] ); 
				$data->setStatus( $row["status"] ); 
				$data->setShowSlider( $row["show_slider"] ); 
				$data->setNumOfProducts( $row["num_of_products"] ); 
				$data->setTotalNumOfProducts( $row["total_num_of_products"] ); 
				$data->setDate( $row["date"] ); 
				$data->setTemplateNum( $row["template_num"] ); 
				$data->setTemplateHtml( $row["template_html"] ); 
				$data->setCustomValues( $row["custom_values"] ); 
				$data->setSortingOption( $row["sorting_option"] ); 
				$data->setSortedProductsList( $row["sorted_products_list"] ); 				
				return   $data;
			}

			return null;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function deleteByEngagementId($engagement_id = ''){

		$sql = "delete from `dap_member_engagement_rules` where `engagement_id` =:engagement_id";
		
		try{		
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':engagement_id', $engagement_id, PDO::PARAM_STR);
			$stmt->execute();
			return true;
	    } catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
				
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
       	 
	}
	
	
}
