<?php

class DAP_ProductsTabs{
	
	var $id;
	var $product_id;
	var $tab_list;	 
	var $maintain;		
	var $apply_tab_rule; 	
	var $course_tab; 	
	var $blogname; 	
	
	function getId() {
		return $this->id;
	}

	function setId($o) {
		$this->id = $o;
	}	 	

	function getProductId() {
		return $this->product_id;
	}	

	function setProductId($o) {
		$this->product_id = $o;
	}

	function getTabList() {
		return $this->tab_list;
	}

	function setTabList($o) {
		$this->tab_list = $o;
	}

	function getMaintain() {
		return $this->maintain;
	}

	function setMaintain($o) {
		$this->maintain = $o;
	}

	function getApplyTabRule() {
		return $this->apply_tab_rule;
    }
	
    function setApplyTabRule($o) {
		$this->apply_tab_rule = $o;
	}
	
	function getCourseTab() {
		return $this->course_tab;
    }
	
    function setCourseTab($o) {
		$this->course_tab = $o;
	}
	
	function getBlogname() {
		return $this->blogname;
    }
	
    function setBlogname($o) {
		$this->blogname = $o;
	}
 

	public function create() {

		try {

			$dap_dbh = Dap_Connection::getConnection();			 

			$sql = "insert into dap_products_tabs 
						(product_id, tab_list, maintain, apply_tab_rule, course_tab,blogname) 
					values
						(:product_id, :tab_list, :maintain, :apply_tab_rule, :course_tab, :blogname)";			
 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
 			$stmt->bindParam(':tab_list', $this->getTabList(), PDO::PARAM_STR);
 			$stmt->bindParam(':maintain', $this->getMaintain(), PDO::PARAM_STR); 			
 			$stmt->bindParam(':apply_tab_rule', $this->getApplyTabRule(), PDO::PARAM_STR);
 			$stmt->bindParam(':course_tab', $this->getCourseTab(), PDO::PARAM_STR);
 			$stmt->bindParam(':blogname', $this->getBlogname(), PDO::PARAM_STR);

 			$stmt->execute();
			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;

		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}

	}

 	public function update() {

		try {

			$dap_dbh = Dap_Connection::getConnection();	
			$sql = "update dap_products_tabs set
						product_id = :product_id,
						tab_list = :tab_list ,						
						apply_tab_rule = :apply_tab_rule ,
						course_tab = :course_tab ,
						blogname = :blogname ,
						maintain = :maintain 
					where
						id = :id";

			$stmt = $dap_dbh->prepare($sql);

			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
 			$stmt->bindParam(':tab_list', $this->getTabList(), PDO::PARAM_STR);
 			$stmt->bindParam(':maintain', $this->getMaintain(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->bindParam(':apply_tab_rule', $this->getApplyTabRule(), PDO::PARAM_STR);
			$stmt->bindParam(':course_tab', $this->getCourseTab(), PDO::PARAM_STR);
			$stmt->bindParam(':blogname', $this->getBlogname(), PDO::PARAM_STR);
			
			$stmt->execute();	
			$stmt = null;
			$dap_dbh = null;
			return;

		} catch (PDOException $e) {

			logToFile($e->getMessage(),LOG_FATAL_DAP);

			throw $e;

		} catch (Exception $e) {

			logToFile($e->getMessage(),LOG_FATAL_DAP);

			throw $e;

		}

	}
 

	//Load  

	public static function load() {
		$LoadList = array(); 
		$sql = "select * from dap_products_tabs ";	
		
		try {

			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			while ($row = $stmt->fetch()) {

				$data = new DAP_ProductsTabs(); 
				$data->setId( $row["id"] );
				$data->setProductId( $row["product_id"] );
				$data->setTabList( $row["tab_list"] ); 
				$data->setMaintain( $row["maintain"] ); 				
				$data->setApplyTabRule( $row["apply_tab_rule"] ); 
				$data->setCourseTab( $row["course_tab"] ); 				
				$data->setBlogname( $row["blogname"] ); 				
				$LoadList[] = $data;
			}

			return $LoadList;

		} catch (PDOException $e) {

			logToFile($e->getMessage(),LOG_FATAL_DAP);

			throw $e;

		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}

	}


	 public static function loadByProductId($product_id) {

		$dap_dbh = Dap_Connection::getConnection();

		$product = false;  		

		$sql = "select *
			from
				dap_products_tabs
			where
				product_id = :product_id";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
		$stmt->execute();

		if ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
			$product = new DAP_ProductsTabs(); 
			$product->setId( $row["id"] );
			$product->setProductId( $row["product_id"] );
			$product->setTabList( $row["tab_list"] ); 		
			$product->setMaintain( $row["maintain"] ); 			
			$product->setApplyTabRule( $row["apply_tab_rule"] ); 
			$product->setCourseTab( $row["course_tab"] ); 
			$product->setBlogname( $row["blogname"] ); 
 		}
		return $product;

	}

	

}

