<?php

class Dap_ReferralReports{
	var $id;
	var $affiliate_id;
	var $userids;
	var $product_id;
   	var $rules_total_cycle;
   	var $rules_billing_cycle;
   	var $extended_by_days;
   	var $referral_bonus_date;
   	var $comments;


   	function getId() {
		return $this->id;
	}
	
	function setId($o) {
		$this->id = $o;
	}

	function getAffiliateId() {
		return $this->affiliate_id;
	}
	
	function setAffiliateId($o) {
		$this->affiliate_id = $o;
	}

	function getUserIds() {
		return $this->userids;
	}
	
	function setUserIds($o) {
		$this->userids = $o;
	}

	function getProductId() {
		return $this->product_id;
	}
	
	function setProductId($o) {
		$this->product_id = $o;
	}

	function getRulesTotalCycle() {
		return $this->rules_total_cycle;
	}
	
	function setRulesTotalCycle($o) {
		$this->rules_total_cycle = $o;
	}

	function getRulesBillingCycle() {
		return $this->rules_billing_cycle;
	}
	
	function setRulesBillingCycle($o) {
		$this->rules_billing_cycle = $o;
	}

	function getExtentedByDays() {
		return $this->extended_by_days;
	}
	
	function setExtentedByDays($o) {
		$this->extended_by_days = $o;
	}

	function getReferralBonusDate() {
		return $this->referral_bonus_date;
	}
	
	function setReferralBonusDate($o) {
		$this->referral_bonus_date = $o;
	}

	function getComments() {
		return $this->comments;
	}
	
	function setComments($o) {
		$this->comments = $o;
	}

	public function create(){
		try {
			$dap_dbh = Dap_Connection::getConnection();
			 
			$sql = "insert into dap_affiliates_report
						(affiliate_id, userids,product_id, rules_total_cycle,  rules_billing_cycle, extended_by_days, referral_bonus_date, comments)
					values
						(:affiliate_id, :userids,:product_id,  :rules_total_cycle,  :rules_billing_cycle, :extended_by_days,:referral_bonus_date ,:comments)";			
		 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':affiliate_id', $this->getAffiliateId(), PDO::PARAM_INT);
 			$stmt->bindParam(':userids', $this->getUserIds(), PDO::PARAM_STR);
 			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
 			$stmt->bindParam(':rules_total_cycle', $this->getRulesTotalCycle(), PDO::PARAM_INT);
			$stmt->bindParam(':rules_billing_cycle', $this->getRulesBillingCycle(), PDO::PARAM_INT);			 	
			$stmt->bindParam(':extended_by_days', $this->getExtentedByDays(), PDO::PARAM_INT);			 	
			$stmt->bindParam(':referral_bonus_date', $this->getReferralBonusDate(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':comments', $this->getComments(), PDO::PARAM_STR);			 	
			
			$stmt->execute();
 
			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	public static function load(){
		try {
			$dap_dbh = Dap_Connection::getConnection();
			 
			$sql = "select *
			from
				dap_affiliates_report";			
		 
			$stmt = $dap_dbh->prepare($sql);
				
			
			$stmt->execute();
			$reportsList = array();
 			while ($row = $stmt->fetch()) {
 				$report = new Dap_ReferralReports();
				$report->setId( $row["id"] );
				$report->setAffiliateId($row["affiliate_id"]);
				$report->setUserIds($row["userids"]);
				$report->setProductId($row["product_id"]);
				$report->setRulesTotalCycle($row["rules_total_cycle"]);
				$report->setRulesBillingCycle($row["rules_billing_cycle"]);
				$report->setExtentedByDays($row["extended_by_days"]);
				$report->setReferralBonusDate($row["referral_bonus_date"]);
				$report->setComments($row["comments"]);
				$reportsList[] = $report;
 			}

			return $reportsList;
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	
}