<?php
class DAP_ReferralRules{
	var $id;
	var $product_id;
	var $total_referrals;	
	var $billing_cycle;	
	var $recurring;	 
	var $status;	 
	var $activate_date;	 
	var $date;

	function getId() {
		return $this->id;
	}	
	function setId($o) {
		$this->id = $o;
	}

	function getProductId() {
		return $this->product_id;
	}	
	function setProductId($o) {
		$this->product_id = $o;
	}

	function getTotalReferrals() {
		return $this->total_referrals;
	}	
	function setTotalReferrals($o) {
		$this->total_referrals = $o;
	}

	function getBillingCycle() {
		return $this->billing_cycle;
	}	
	function setBillingCycle($o) {
		$this->billing_cycle = $o;
	}

	function getRecurring() {
		return $this->recurring;
	}	
	function setRecurring($o) {
		$this->recurring = $o;
	}

	function getStatus() {
		return $this->status;
	}	
	function setStatus($o) {
		$this->status = $o;
	}

	function getActivateDate() {
		return $this->activate_date;
	}	
	function setActivateDate($o) {
		$this->activate_date = $o;
	}

	function getDate() {
		return $this->date;
	}	
	function setDate($o) {
		$this->date = $o;
	}

	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			 
			$sql = "insert into dap_referral_rules
						(product_id, total_referrals,billing_cycle,  recurring, status, activate_date, date)
					values
						(:product_id, :total_referrals, :billing_cycle,  :recurring, :status,:activate_date ,:date)";			
		 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
 			$stmt->bindParam(':total_referrals', $this->getTotalReferrals(), PDO::PARAM_INT);
 			$stmt->bindParam(':billing_cycle', $this->getBillingCycle(), PDO::PARAM_INT);
			$stmt->bindParam(':recurring', $this->getRecurring(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_INT);			 	
			$stmt->bindParam(':activate_date', $this->getActivateDate(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);			 	
			
			$stmt->execute();
 
			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "update dap_referral_rules set
						product_id = :product_id,
						total_referrals = :total_referrals,
						billing_cycle = :billing_cycle,
						status = :status,
						activate_date = :activate_date
					where
						id = :id";
			$stmt = $dap_dbh->prepare($sql);

			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
			$stmt->bindParam(':total_referrals', $this->getTotalReferrals(), PDO::PARAM_INT);
			$stmt->bindParam(':billing_cycle', $this->getBillingCycle(), PDO::PARAM_INT);
			$stmt->bindParam(':activate_date', $this->getActivateDate(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_INT);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);

			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;

			return;
		}catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	public function updateStatus() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "update dap_referral_rules set
				status = :status
				where
						id = :id";
			$stmt = $dap_dbh->prepare($sql);

			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_INT);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);

			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;

			return;
		}catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}


	public static function load(){
		try {
			$dap_dbh = Dap_Connection::getConnection();
			 
			$sql = "select *
			from
				dap_referral_rules";			
		 
			$stmt = $dap_dbh->prepare($sql);
				
			
			$stmt->execute();
			$rulesList = array();
 			while ($row = $stmt->fetch()) {
 				$rules = new DAP_ReferralRules();
				$rules->setId( $row["id"] );
				$rules->setProductId($row["product_id"]);
				$rules->setTotalReferrals($row["total_referrals"]);
				$rules->setBillingCycle($row["billing_cycle"]);
				$rules->setRecurring($row["recurring"]);
				$rules->setStatus($row["status"]);
				$rules->setActivateDate($row["activate_date"]);
				$rules->setDate($row["date"]);
				$rulesList[] = $rules;
 			}

			return $rulesList;
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	public static function loadByIdOrProductId($id, $pId = ''){
		try {
			$dap_dbh = Dap_Connection::getConnection();
			 
			$sql = "select *
			from
				dap_referral_rules
			where";
			
			if($id != ''){
				$sql .=" id = $id ";
			}else if($pId != ''){
				$sql .=" product_id = $pId ";
			} 		
		 
			$stmt = $dap_dbh->prepare($sql);
				
			
			$stmt->execute();
			$rules = false;
 			while ($row = $stmt->fetch()) {
 				$rules = new DAP_ReferralRules();
				$rules->setId( $row["id"] );
				$rules->setProductId($row["product_id"]);
				$rules->setTotalReferrals($row["total_referrals"]);
				$rules->setBillingCycle($row["billing_cycle"]);
				$rules->setRecurring($row["recurring"]);
				$rules->setStatus($row["status"]);
				$rules->setActivateDate($row["activate_date"]);
				$rules->setDate($row["date"]);
				
 			}

			return $rules;
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}


	public static function delete($id){
		try {

			$dap_dbh = Dap_Connection::getConnection();
			$sql = "DELETE 
					FROM 
						dap_referral_rules
					WHERE 
						id = :id";

			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();

		}catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}


}