<?php
class DAP_SecurityBlockingMaster{
	
	var $id;
	var $rule_name;
	var $status;		
	
	
	
	function getId() {
		return $this->id;
	}
	
	function setId($o) {
		$this->id = $o;
	}
	
	function getRuleName() {
		return $this->rule_name;
	}
	
	function setRuleName($o) {
		$this->rule_name = $o;
	}
	
	function getStatus() {
		return $this->status;
	}
	
	function setStatus($o) {
		$this->status = $o;
	}
	
	
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			 
			$sql = "insert into  dap_security_blocking_master
						(rule_name, status)
					values
						(:rule_name, :status)";			
				
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':rule_name', $this->getRuleName(), PDO::PARAM_STR);
 			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);	 	

			$stmt->execute();
 
			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();			
			
			$sql = "update  dap_security_blocking_master set
						
						rule_name = :rule_name,						
						status = :status					
						
					where
						id = :id ";	
		 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':rule_name', $this->getRuleName(), PDO::PARAM_STR);
 			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);	
			$stmt->execute();		
			
			$stmt = null;
			$dap_dbh = null;

			return $this->getId();

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	

	public static function load() {
		$LoadList = null; 
		$sql = "select * from  dap_security_blocking_master ";		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_SecurityBlockingMaster(); 
				$data->setId( $row["id"] );
				$data->setRuleName($row["rule_name"]);
				$data->setStatus($row["status"]);
				$LoadList[] = $data;
			}

			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function loadByStatus($status = 'N') {
		$LoadList = array(); 
		$sql = "select * from dap_security_blocking_master where status =:status ";
 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':status', $status, PDO::PARAM_STR);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_SecurityBlockingMaster(); 
				$data->setId( $row["id"] );
				$data->setRuleName($row["rule_name"]);
				$data->setStatus($row["status"]);
				$LoadList[] = $data;
			}

			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	public static function loadByRuleNameAndStatus($rule_name='',$status = 'N') {
		$LoadList = null; 
		$sql = "select * from dap_security_blocking_master where rule_name =:rule_name AND status = :status";

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);  
			$stmt->bindParam(':rule_name', $rule_name, PDO::PARAM_STR);
 			$stmt->bindParam(':status', $status, PDO::PARAM_STR);
			$stmt->execute();		
			
			while ($row = $stmt->fetch()) {
				$data = new DAP_SecurityBlockingMaster(); 
				$data->setId( $row["id"] );
				$data->setRuleName($row["rule_name"]);
				$data->setStatus($row["status"]);
				$LoadList[] = $data;
			}

			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
 
	
	public static function loadByRuleName($rule_name = '') {
		$LoadList = null; 
		$sql = "select * from dap_security_blocking_master where rule_name = '".$rule_name."'";
			 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				
				$data = new DAP_SecurityBlockingMaster(); 

				$data->setId( $row["id"] );
				$data->setRuleName($row["rule_name"]);
				$data->setStatus($row["status"]);
				$LoadList = $data;
			}		
			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
}
