<?php
class DAP_SecurityReports{
	
	var $id;
	var $email;
	var $domain;		
	var $IP;		
	var $country;		
	var $security_blocking_rule_id;		
	var $comments;		
	var $date;		
	
	
	
	function getId() {
		return $this->id;
	}
	
	function setId($o) {
		$this->id = $o;
	}
	
	function getEmail() {
		return $this->email;
	}
	
	function setEmail($o) {
		$this->email = $o;
	}
	
	function getDomain() {
		return $this->domain;
	}
	
	function setDomain($o) {
		$this->domain = $o;
	}
	
	function getIP() {
		return $this->IP;
	}
	
	function setIP($o) {
		$this->IP = $o;
	}
	
	function getCountry() {
		return $this->country;
	}
	
	function setCountry($o) {
		$this->country = $o;
	}
	
	function getSecurityBlockingRuleId() {
		return $this->security_blocking_rule_id;
	}
	
	function setSecurityBlockingRuleId($o) {
		$this->security_blocking_rule_id = $o;
	}
	
	function getComments() {
		return $this->comments;
	}
	
	function setComments($o) {
		$this->comments = $o;
	}
	
	
	function getDate() {
		return $this->date;
	}
	
	function setDate($o) {
		$this->date = $o;
	}
	
	
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			 
			$sql = "insert into  dap_security_reports
						(email, domain, IP, country, security_blocking_rule_id, comments, date)
					values
						(:email, :domain, :IP, :country, :security_blocking_rule_id, :comments, :date)";			
			 	
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':email', $this->getEmail(), PDO::PARAM_STR);
 			$stmt->bindParam(':domain', $this->getDomain(), PDO::PARAM_STR);	 	
 			$stmt->bindParam(':IP', $this->getIP(), PDO::PARAM_STR);	 	
 			$stmt->bindParam(':country', $this->getCountry(), PDO::PARAM_STR);	 	
 			$stmt->bindParam(':security_blocking_rule_id', $this->getSecurityBlockingRuleId(), PDO::PARAM_STR);	 	
 			$stmt->bindParam(':comments', $this->getComments(), PDO::PARAM_STR);	 	
 			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);	 	

			$stmt->execute();
 
			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	
	public static function load() {
		$LoadList = null; 
		$sql = "select * from dap_security_reports";

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_SecurityReports(); 
				$data->setId( $row["id"] );
				$data->setDomain($row["domain"]);
				$data->setIP($row["IP"]);
				$data->setCountry($row["country"]);
				$data->setSecurityBlockingRuleId($row["security_blocking_rule_id"]);
				$data->setComments($row["comments"]);
				$data->setDate($row["date"]); 	
				$data->setEmail($row["email"]);
				$LoadList[] = $data;
			}

			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function loadByRuleName() {
		$LoadList = null; 
		$sql = "select t1.domain as domain,  t1.date as date, t1.comments as comments, t1.country as country, t1.IP as IP, t1.email as email, t2.rule_name as rule_name from dap_security_reports as t1 INNER JOIN dap_security_blocking_master as t2 where t2.id = t1.security_blocking_rule_id";

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_SecurityReports(); 
				$data->setId( $row["id"] );
				$data->setDomain($row["domain"]);
				$data->setIP($row["IP"]);
				$data->setCountry($row["country"]);
				$data->setSecurityBlockingRuleId($row["rule_name"]);
				$data->setComments($row["comments"]);
				$data->setEmail($row["email"]);
				$data->setDate($row["date"]); 	
				$LoadList[] = $data;
			}

			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
 
	
	
}
