<?php
class DAP_SetupWizard{
	
	var $id;
	var $product_id;	 
	var $tablist;	 
	var $shopping_cart_platform;	 
	var $payment_gateway;	 
	var $wp_location;	 
	var $membership_pages;	 
	var $date;
	
	function getId() {
		return $this->id;
	}
	
	function setId($o) {
		$this->id = $o;
	}
	
 	function getProductId() {
		return $this->product_id;
	}
	
	function setProductId($o) {
		$this->product_id = $o;
	}
 	function getTablist() {
		return $this->tablist;
	}
	
	function setTablist($o) {
		$this->tablist = $o;
	}
 	function getMainTablist() {
		return $this->main_tablist;
	}
	
	function setMainTablist($o) {
		$this->main_tablist = $o;
	}
	
	function getShoppingCartPlatform() {
		return $this->shopping_cart_platform;
	}
	function setShoppingCartPlatform($o) {
		$this->shopping_cart_platform = $o;
	}
	function getPaymentGateway() {
		return $this->payment_gateway;
	}
	function setPaymentGateway($o) {
		$this->payment_gateway = $o;
	}
	function getWpLocation() {
		return $this->wp_location;
	}
	function setWpLocation($o) {
		$this->wp_location = $o;
	}
	function getMembershipPages() {
		return $this->membership_pages;
	}
	function setMembershipPages($o) {
		$this->membership_pages = $o;
	}
	 
	function getDate() {
		return $this->date;
	}
	
	function setDate($o) {
		$this->date = $o;
	}
 
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			 
			$sql = "insert into dap_setup_wizard
						( product_id, tablist, main_tablist, shopping_cart_platform, payment_gateway, wp_location, membership_pages, date)
					values
						(:product_id, :tablist, :main_tablist, :shopping_cart_platform, :payment_gateway, :wp_location, :membership_pages, now())";			
			logToFile("insert wiz ");
			$stmt = $dap_dbh->prepare($sql); 
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);			 	
			$stmt->bindParam(':tablist', $this->getTablist(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':main_tablist', $this->getMainTablist(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':shopping_cart_platform', $this->getShoppingCartPlatform(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':payment_gateway', $this->getPaymentGateway(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':wp_location', $this->getWpLocation(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':membership_pages', $this->getMembershipPages(), PDO::PARAM_STR);			 	
			$stmt->execute(); 
			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	
	
	
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();			
			
			$sql = "update dap_setup_wizard set 						 
						product_id = :product_id,						 						
						tablist = :tablist,
						main_tablist = :main_tablist,
						shopping_cart_platform = :shopping_cart_platform,
						payment_gateway = :payment_gateway,
						wp_location = :wp_location,
						membership_pages = :membership_pages,  						
						date  = now() 
					where
						id = :id";	
			logToFile("update wiz ");
			$stmt = $dap_dbh->prepare($sql);			 
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);			 	
			$stmt->bindParam(':tablist', $this->getTablist(), PDO::PARAM_STR);	
			$stmt->bindParam(':main_tablist', $this->getMainTablist(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':shopping_cart_platform', $this->getShoppingCartPlatform(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':payment_gateway', $this->getPaymentGateway(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':wp_location', $this->getWpLocation(), PDO::PARAM_STR);			 	
			$stmt->bindParam(':membership_pages', $this->getMembershipPages(), PDO::PARAM_STR);			 		 
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_STR);
			$stmt->execute();		
			
			$stmt = null;
			$dap_dbh = null;

			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	  
	
	//Load  
	public static function load() {
		$LoadList = array(); 
		$sql = "select * from dap_setup_wizard order by id desc";		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_SetupWizard(); 
				$data->setId( $row["id"] );				 
				$data->setProductId( $row["product_id"] ); 
				$data->setTablist( $row["tablist"] );   
				$data->setMainTablist( $row["main_tablist"] ); 
				$data->setShoppingCartPlatform( $row["shopping_cart_platform"] ); 
				$data->setPaymentGateway( $row["payment_gateway"] ); 
				$data->setWpLocation( $row["wp_location"] ); 
				$data->setMembershipPages( $row["membership_pages"] ); 
				$data->setDate( $row["date"] ); 
				$LoadList[] = $data;
			}

			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
  
	 
	//Load  
	public static function loadById($id = 0) {
		
		$sql = "select * from dap_setup_wizard where id = ".$id;		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_SetupWizard(); 

				$data->setId( $row["id"] );				 
				$data->setProductId( $row["product_id"] ); 
				$data->setTablist( $row["tablist"] ); 
				$data->setMainTablist( $row["main_tablist"] );  
				$data->setShoppingCartPlatform( $row["shopping_cart_platform"] ); 
				$data->setPaymentGateway( $row["payment_gateway"] ); 
				$data->setWpLocation( $row["wp_location"] ); 
				$data->setMembershipPages( $row["membership_pages"] ); 
				$data->setDate( $row["date"] ); 
				return   $data;
			}

			return false;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	//Load  
	public static function loadByProductId($product_id = 0) {
		
		$sql = "select * from dap_setup_wizard where product_id = ".$product_id;		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_SetupWizard(); 

				$data->setId( $row["id"] );				 
				$data->setProductId( $row["product_id"] ); 
				$data->setTablist( $row["tablist"] ); 
				$data->setMainTablist( $row["main_tablist"] );  
				$data->setShoppingCartPlatform( $row["shopping_cart_platform"] ); 
				$data->setPaymentGateway( $row["payment_gateway"] ); 
				$data->setWpLocation( $row["wp_location"] ); 
				$data->setMembershipPages( $row["membership_pages"] ); 
				$data->setDate( $row["date"] ); 
				return   $data;
			}

			return false;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
  
	
	 public static function deleteProduct($p_id){

		$sql = "delete from dap_setup_wizard where product_id=".$p_id."";
		try{		
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			return true;
	    } catch (PDOException $e) {
				logToFile($e->getMessage(),LOG_FATAL_DAP);
				throw $e;
				
		} catch (Exception $e) {
				logToFile($e->getMessage(),LOG_FATAL_DAP);
				throw $e;
		}
       	 
	}  
	 public static function delete(){

		$sql = "delete from dap_setup_wizard";
		try{		
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			return true;
	    } catch (PDOException $e) {
				logToFile($e->getMessage(),LOG_FATAL_DAP);
				throw $e;
				
		} catch (Exception $e) {
				logToFile($e->getMessage(),LOG_FATAL_DAP);
				throw $e;
		}
       	 
	}  
	
	
}
