<?php
 
class DAP_UserPayPerPost {
	
   	var $id;
   	var $user_id;
   	var $product_id;
   	var $resource_id;
   	var $access_start;
   	var $access_end;
   	var $purchase_status; 
   	var $button_type; 
   	var $post_url; 
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	function getUserId() {
		return $this->user_id;
	}
	function setUserId($o) {
		$this->user_id = $o;
	}
	
	function getProductId() {
		return $this->product_id;
	}
	function setProductId($o) {
		$this->product_id = $o;
	}
	
	function getResourceId() {
		return $this->resource_id;
	}
	function setResourceId($o) {
		$this->resource_id = $o;
	}

	function getAccessStart() {
		return $this->access_start;
	}
	function setAccessStart($o) {
		$this->access_start = $o;
	}
	function getAccessEnd() {
		return $this->access_end;
	}
	function setAccessEnd($o) {
		$this->access_end = $o;
	}
	 
	function getPurchaseStatus() {
		return $this->purchase_status;
	}
	function setPurchaseStatus($o) {
		$this->purchase_status = $o;
	}
 	
 	function getButtonType() {
		return $this->button_type;
	}
	function setButtonType($o) {
		$this->button_type = $o;
	}
 	
 	function getPostURL() {
		return $this->post_url;
	}
	function setPostURL($o) {
		$this->post_url = $o;
	}
 	
	public function create() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_user_pay_per_post
						( user_id, product_id, resource_id, access_start, access_end, purchase_status, button_type, post_url )
					values 
						(:user_id,  :product_id, :resource_id, :access_start, :access_end, :purchase_status, :button_type, :post_url)";

			$stmt = $dap_dbh->prepare($sql);
				 
 
			$stmt->bindParam(':user_id', $this->getUserId(), PDO::PARAM_INT);
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
			$stmt->bindParam(':resource_id', $this->getResourceId(), PDO::PARAM_INT);
			$stmt->bindParam(':access_start', $this->getAccessStart(), PDO::PARAM_STR);
			$stmt->bindParam(':access_end', $this->getAccessEnd(), PDO::PARAM_STR);
			$stmt->bindParam(':purchase_status', $this->getPurchaseStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':button_type', $this->getButtonType(), PDO::PARAM_STR);
			$stmt->bindParam(':post_url', $this->getPostURL(), PDO::PARAM_STR);
 			$stmt->execute();
			 
			$last_insert_id = $dap_dbh->lastInsertId();
	 
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
 
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
	
			$sql = "update 
					dap_user_pay_per_post
					set
						 user_id =:user_id, 
						 product_id =:product_id, 
						 resource_id =:resource_id, 
						 access_start=:access_start,
						 access_end=:access_end,
						 purchase_status=now(), 
						 button_type=:button_type ,
						 post_url=:post_url 
					where
						id =:id ";
				 
			$stmt = $dap_dbh->prepare($sql);	
			
			$stmt->bindParam(':user_id', $this->getUserId(), PDO::PARAM_INT);
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
			$stmt->bindParam(':resource_id', $this->getResourceId(), PDO::PARAM_INT);
			$stmt->bindParam(':access_start', $this->getAccessStart(), PDO::PARAM_STR);
			$stmt->bindParam(':access_end', $this->getAccessEnd(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->bindParam(':button_type', $this->getButtonType(), PDO::PARAM_STR);
			$stmt->bindParam(':post_url', $this->getPostURL(), PDO::PARAM_STR);
			$stmt->execute();
			
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
 
	public static function load() {
		$dataarr = array();
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_user_pay_per_post ORDER BY date DESC
					";
			//logToFile($sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			 
			$stmt->execute();
	
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new DAP_UserPayPerPost();
 
				$data->setId( stripslashes($row["id"]) );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setProductId( stripslashes($row["product_id"]) );
				$data->setResourceId( stripslashes($row["resource_id"]) );
				$data->setAccessStart( stripslashes($row["access_start"]) );
				$data->setAccessEnd( stripslashes($row["access_end"]) );
				$data->setPurchaseStatus( stripslashes($row["purchase_status"]) ); 
				$data->setButtonType( stripslashes($row["button_type"]) ); 
				$data->setPostURL( stripslashes($row["post_url"]) ); 
				$dataarr[] = $data;

			}
			
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	}
	
	 public static function loadByUserID($user_id) {
		$dataarr = array();
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_user_pay_per_post
					WHERE
						user_id =:user_id 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':user_id', $user_id, PDO::PARAM_STR);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {				 
				$dataarr[] = $row;
			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
	 public static function loadDataByUserId($user_id, $new="") {
		$dataarr = array();
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			if($new =="expire"){
				$where = " AND 						 
						access_end < curdate( ) ";
						
			}else{
				$where = " AND 						 
						access_end >= curdate( ) ";
			}
					
			
			$sql = "SELECT 
						*
					FROM
						dap_user_pay_per_post
					WHERE
						user_id =:user_id 			
					";
			$sql .= $where;
			
			 
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':user_id', $user_id, PDO::PARAM_STR);
			$stmt->execute();
			
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new DAP_UserPayPerPost();
				
				$data->setId( stripslashes($row["id"]) );
				$data->setProductId( stripslashes($row["product_id"]) );
				$data->setResourceId( stripslashes($row["resource_id"]) );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setAccessStart( stripslashes($row["access_start"]) );
				$data->setAccessEnd( stripslashes($row["access_end"]) );
				$data->setPurchaseStatus( stripslashes($row["purchase_status"]) );  
				$data->setButtonType( stripslashes($row["button_type"]) );
				$data->setPostURL( stripslashes($row["post_url"]) ); 
				$dataarr[] = $data;

			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	}
	
	
	
	public static function loadByName($name) {
		$dataarr = array();
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_user_pay_per_post
					WHERE
						name =:name 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':name', $name, PDO::PARAM_STR);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new DAP_UserPayPerPost();
				
				$data->setId( stripslashes($row["id"]) );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setProductId( stripslashes($row["product_id"]) );
				$data->setResourceId( stripslashes($row["resource_id"]) );
				$data->setAccessStart( stripslashes($row["access_start"]) );
				$data->setAccessEnd( stripslashes($row["access_end"]) );
				$data->setPurchaseStatus( stripslashes($row["purchase_status"]) );  
				$data->setButtonType( stripslashes($row["button_type"]) ); 
				$data->setPostURL( stripslashes($row["post_url"]) ); 
				$dataarr[] = $data;

			}			
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
 
	public function delete($id) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$dap_dbh->beginTransaction();
			
			//$id = $this->getId();
			//delete from usersproducts table
			  $sql = "delete from  
					dap_user_pay_per_post
					where id =:id"; 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
			
			$dap_dbh->commit(); 
			
			$stmt = null;
			$dap_dbh = null;		
			return;			
		} catch (PDOException $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;				
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;			
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}		
	}
	
	public static function loadById($id) {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_user_pay_per_post
					WHERE
						id =:id 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_STR);
			$stmt->execute();
	        if ($row = $stmt->fetch()) {
				$data = new DAP_UserPayPerPost();
				$data->setId( stripslashes($row["id"]) );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setProductId( stripslashes($row["product_id"]) );
				$data->setResourceId( stripslashes($row["resource_id"]) );
				$data->setAccessStart( stripslashes($row["access_start"]) );
				$data->setAccessEnd( stripslashes($row["access_end"]) );
				$data->setPurchaseStatus( stripslashes($row["purchase_status"]) ); 
				$data->setButtonType( stripslashes($row["button_type"]) ); 
				$data->setPostURL( stripslashes($row["post_url"]) ); 
				$dataarr = $data;

			}
			$stmt = null;
			$dap_dbh = null;
			return $dataarr;				
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
	public static function loadByUserAndProductId($user_id, $product_id) {
		$dataarr = array();
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_user_pay_per_post
					WHERE
						user_id =:user_id and
						product_id =:product_id 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':user_id', $user_id, PDO::PARAM_STR);
			$stmt->bindParam(':product_id', $product_id, PDO::PARAM_STR);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {				 
				$dataarr[] = $row;
			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	public static function loadByUserAndProductIdAndResourceId($user_id, $product_id, $resource_id) {
		$dataarr = false;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_user_pay_per_post
					WHERE
						user_id =:user_id and
						product_id =:product_id and
						resource_id =:resource_id 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':user_id', $user_id, PDO::PARAM_STR);
			$stmt->bindParam(':product_id', $product_id, PDO::PARAM_STR);
			$stmt->bindParam(':resource_id', $resource_id, PDO::PARAM_STR);
			$stmt->execute();
	         
			if ($row = $stmt->fetch()) {
				$data = new DAP_UserPayPerPost();
				$data->setId( stripslashes($row["id"]) );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setProductId( stripslashes($row["product_id"]) );
				$data->setResourceId( stripslashes($row["resource_id"]) );
				$data->setAccessStart( stripslashes($row["access_start"]) );
				$data->setAccessEnd( stripslashes($row["access_end"]) );
				$data->setPurchaseStatus( stripslashes($row["purchase_status"]) ); 
				$data->setButtonType( stripslashes($row["button_type"]) ); 
				$data->setPostURL( stripslashes($row["post_url"]) ); 
				$dataarr = $data;

			}
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
	
	public static function hasAccessTo($user_id, $resource_id) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$hasAccessTo = false;
			
			//First activate user
			$sql = "select 
						* 
					from 
						dap_user_pay_per_post 
					where
						user_id = :user_id and 
						resource_id = :resource_id and
						CURDATE() <= access_end";
						                                                             
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
			$stmt->bindParam(':resource_id', $resource_id, PDO::PARAM_INT);
			//$stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
			$stmt->execute();
			
			if ($row = $stmt->fetch()) {
				//$count = $row["count"];
				$hasAccessTo = true;
				//logToFile("DAP_User.class.php: hasaccess=true");	
			}
			
			$sql = null;
			$stmt = null;
			$dap_dbh = null; 
			
			return $hasAccessTo;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
 
}
 
