<?php

class Dap_Certificate {
	var $id;
	var $name;
	var $admin_name;	
	var $template;
	var $template_html;	 
	var $template_no;	 
	var $customizer_values;	 
	var $date;
	var $status;
	var $logo_img;
	var $signature_img;
	var $type;
    
    
    function getSignatureImg() {
		return $this->signature_img;
	}
	function setSignatureImg($o) {
		$this->signature_img = $o;
	}
	function getLogoImg() {
		return $this->logo_img;
	}
	function setLogoImg($o) {
		$this->logo_img = $o;
	}
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getName() {
		return $this->name;
	}
	function setName($o) {
		$this->name = $o;
	}
	
	
	function getTemplateNo() {
		return $this->template_no;
	}
	function setTemplateNo($o) {
		$this->template_no = $o;
	}
	
	function getTemplateHtml() {
		return $this->template_html;
	}
	function setTemplateHtml($o) {
		$this->template_html = $o;
	}
	function getCustomizerValues() {
		return $this->customizer_values;
	}
	function setCustomizerValues($o) {
		$this->customizer_values = $o;
	}	 
	
	function getStatus() {
		return $this->status;
	}
	
	function setStatus($o) {
		$this->status = $o;
	}
		
	function getDate() {
		return $this->date;
	}
	
	function setDate($o) {
		$this->date = $o;
	}
	
	function getAdminName() {
		return $this->admin_name;
	}
	
	function setAdminName($o) {
		$this->admin_name = $o;
	}
	
	function getType() {
		return $this->type;
	}
	
	function setType($o) {
		$this->type = $o;
	}
	
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_certificate
						(name, template_no, template_html, customizer_values, date , status, admin_name, signature_img, logo_img, type)
					values
						(:name, :template_no, :template_html, :customizer_values, :date, :status, :admin_name, :signature_img, :logo_img, :type)";
			$stmt = $dap_dbh->prepare($sql);			
			
			$stmt->bindParam(':name', $this->getName(), PDO::PARAM_STR);			
			$stmt->bindParam(':template_no', $this->getTemplateNo(), PDO::PARAM_STR);
			$stmt->bindParam(':template_html', $this->getTemplateHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':customizer_values', $this->getCustomizerValues(), PDO::PARAM_STR);
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':admin_name', $this->getAdminName(), PDO::PARAM_STR);
			$stmt->bindParam(':signature_img', $this->getSignatureImg(), PDO::PARAM_STR);
			$stmt->bindParam(':logo_img', $this->getLogoImg(), PDO::PARAM_STR);
			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_STR);
			$stmt->execute();			
			$last_id = $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;
			return $last_id;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "update dap_certificate set
					name = :name,
					template_no = :template_no,
					template_html = :template_html,
					customizer_values = :customizer_values,
					date = :date,
					admin_name = :admin_name,
					signature_img = :signature_img,
					logo_img = :logo_img,
					status = :status,
					type = :type 
					where   
						id = :id
					";
					
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':name', $this->getName(), PDO::PARAM_STR);
			$stmt->bindParam(':template_no', $this->getTemplateNo(), PDO::PARAM_STR);
			$stmt->bindParam(':template_html', $this->getTemplateHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':customizer_values', $this->getCustomizerValues(), PDO::PARAM_STR);
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->bindParam(':admin_name', $this->getAdminName(), PDO::PARAM_STR);
			$stmt->bindParam(':signature_img', $this->getSignatureImg(), PDO::PARAM_STR);
			$stmt->bindParam(':logo_img', $this->getLogoImg(), PDO::PARAM_STR);
			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_STR);
			$stmt->execute();			
			$stmt = null;
			$dap_dbh = null;

			return $this->getId();

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function loadById($id) {
		$dap_dbh = Dap_Connection::getConnection();
		$sqbdataReturn = null;

		//Load product details from database
		$sql = "select *
			from
				dap_certificate
			where
				id = :id";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':id', $id, PDO::PARAM_INT);
		$stmt->execute();
			while ($row = $stmt->fetch()) {
				$sqbdata = new Dap_Certificate();					
				$sqbdata->setId( $row["id"] );
				$sqbdata->setName( stripslashes($row["name"]) );				
				$sqbdata->setTemplateNo( stripslashes($row["template_no"]) );
				$sqbdata->setTemplateHtml( stripslashes($row["template_html"]) );
				$sqbdata->setCustomizerValues( stripslashes($row["customizer_values"]) );
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdata->setStatus( stripslashes($row["status"]) );
				$sqbdata->setAdminName( stripslashes($row["admin_name"]));
				$sqbdata->setSignatureImg( stripslashes($row["signature_img"]));
				$sqbdata->setLogoImg( stripslashes($row["logo_img"]));
				$sqbdata->setType( stripslashes($row["type"]));
				
				$sqbdataReturn = $sqbdata;
		}

		return $sqbdataReturn;
	}
	 
	
	public static function load() {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sqbdataarray = null;

		//Load product details from database
		$sql = "select * from dap_certificate order by id desc";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->execute();
		while ($row = $stmt->fetch()) {
				$sqbdata = new Dap_Certificate();					
				$sqbdata->setId( $row["id"] );
				$sqbdata->setName( stripslashes($row["name"]) );				
				$sqbdata->setTemplateNo( stripslashes($row["template_no"]) );				
				$sqbdata->setTemplateHtml( stripslashes($row["template_html"]) );
				$sqbdata->setCustomizerValues( stripslashes($row["customizer_values"]) );
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdata->setStatus( stripslashes($row["status"]) );
				$sqbdata->setAdminName( stripslashes($row["admin_name"]) );
				$sqbdata->setSignatureImg( stripslashes($row["signature_img"]));
				$sqbdata->setLogoImg( stripslashes($row["logo_img"]));
				$sqbdata->setType( stripslashes($row["type"]));
				$sqbdataarray[] = $sqbdata;
		}

		return $sqbdataarray;
	}
	 
	
	 
	public static function deleteById($id = 0) {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sql = "delete from dap_certificate where id = :id";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':id', $id, PDO::PARAM_INT);
		$stmt->execute();

		return $id;
	}
	
	
}
