<?php

class Dap_CourseCertificate {
	var $id;
	var $course_id;
	var $certificate_id;
	var $certificate_generation_criteria;
	var $shortcode_type;
	var $not_earned_certificate_option;
		
	var $date;
	var $status;
	var $download_btn_html;
	var $download_customizer_values;


    function getDownloadBtnHtml() {
		return $this->download_btn_html;
	}
	function setDownloadBtnHtml($o) {
		$this->download_btn_html = $o;
	} 
	
	function getDownloadCustomizerValues() {
		return $this->download_customizer_values;
	}
	function setDownloadCustomizerValues($o) {
		$this->download_customizer_values = $o;
	} 
     
     
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	
	function getCourseId() {
		return $this->course_id;
	}
	function setCourseId($o) {
		$this->course_id = $o;
	}
	
	function getCertificateId() {
		return $this->certificate_id;
	}
	function setCertificateId($o) {
		$this->certificate_id = $o;
	}
	
	
	
	function getCertificateGenerationCriteria() {
		return $this->certificate_generation_criteria;
	}
	function setCertificateGenerationCriteria($o) {
		$this->certificate_generation_criteria = $o;
	}
	
	function getShortcodeType() {
		return $this->shortcode_type;
	}
	function setShortcodeType($o) {
		$this->shortcode_type = $o;
	}
	function getNotEarnedCertificateOption() {
		return $this->not_earned_certificate_option;
	}
	function setNotEarnedCertificateOption($o) {
		$this->not_earned_certificate_option = $o;
	}
	
	
	
	
	
	
	function getStatus() {
		return $this->status;
	}
	
	function setStatus($o) {
		$this->status = $o;
	}
		
	function getDate() {
		return $this->date;
	}
	
	function setDate($o) {
		$this->date = $o;
	}
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_course_certificate
						(course_id, certificate_id, certificate_generation_criteria, shortcode_type, not_earned_certificate_option,  date , status, download_btn_html, download_customizer_values)
					values
						(:course_id, :certificate_id, :certificate_generation_criteria, :shortcode_type, :not_earned_certificate_option, :date, :status, :download_btn_html , :download_customizer_values)";
			$stmt = $dap_dbh->prepare($sql);			
			
			
			$stmt->bindParam(':course_id', $this->getCourseId(), PDO::PARAM_INT);
			$stmt->bindParam(':certificate_id', $this->getCertificateId(), PDO::PARAM_INT);
			$stmt->bindParam(':certificate_generation_criteria', $this->getCertificateGenerationCriteria(), PDO::PARAM_STR);
			$stmt->bindParam(':shortcode_type', $this->getShortcodeType(), PDO::PARAM_STR);
			$stmt->bindParam(':not_earned_certificate_option', $this->getNotEarnedCertificateOption(), PDO::PARAM_STR);
			
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':download_btn_html', $this->getDownloadBtnHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':download_customizer_values', $this->getDownloadCustomizerValues(), PDO::PARAM_STR);
			$stmt->execute();			
			$last_id = $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;
			return $last_id;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "update dap_course_certificate set
				
					course_id = :course_id,
					certificate_id = :certificate_id,
					certificate_generation_criteria = :certificate_generation_criteria,
					shortcode_type = :shortcode_type,
					not_earned_certificate_option = :not_earned_certificate_option,
					download_customizer_values = :download_customizer_values,
					download_btn_html = :download_btn_html,
					
					date = :date,
					status = :status
					where
						id = :id
					";
					
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':course_id', $this->getCourseId(), PDO::PARAM_INT);
			$stmt->bindParam(':certificate_id', $this->getCertificateId(), PDO::PARAM_INT);
			$stmt->bindParam(':certificate_generation_criteria', $this->getCertificateGenerationCriteria(), PDO::PARAM_STR);
			$stmt->bindParam(':shortcode_type', $this->getShortcodeType(), PDO::PARAM_STR);
			$stmt->bindParam(':not_earned_certificate_option', $this->getNotEarnedCertificateOption(), PDO::PARAM_STR);
			
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':download_btn_html', $this->getDownloadBtnHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':download_customizer_values', $this->getDownloadCustomizerValues(), PDO::PARAM_STR);
			
			
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->execute();
			
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
			return $this->getId();

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function loadById($id) {
		$dap_dbh = Dap_Connection::getConnection();
		$sqbdataReturn = null;

		//Load product details from database
		$sql = "select *
			from
				dap_course_certificate
			where
				id = :id";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':id', $id, PDO::PARAM_STR);
		$stmt->execute();
			while ($row = $stmt->fetch()) {
				$sqbdata = new Dap_CourseCertificate();					
				$sqbdata->setId( $row["id"] );
				
				$sqbdata->setCourseId( stripslashes($row["course_id"]) );
				$sqbdata->setCertificateId( stripslashes($row["certificate_id"]) );
				$sqbdata->setCertificateGenerationCriteria( stripslashes($row["certificate_generation_criteria"]) );
				$sqbdata->setShortcodeType( stripslashes($row["shortcode_type"]) );
				$sqbdata->setNotEarnedCertificateOption( stripslashes($row["not_earned_certificate_option"]) );
				
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdata->setStatus( stripslashes($row["status"]) );
				$sqbdata->setDownloadBtnHtml( stripslashes($row["download_btn_html"]) );
				$sqbdata->setDownloadCustomizerValues( stripslashes($row["download_customizer_values"]));
				$sqbdataReturn = $sqbdata;
		}

		return $sqbdataReturn;
	}
	
	public static function loadByCourseId($courseId) {
		$dap_dbh = Dap_Connection::getConnection();
		$sqbdataReturn = false;

		//Load product details from database
		$sql = "select *
			from
				dap_course_certificate
			where
				course_id = :course_id";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':course_id', $courseId, PDO::PARAM_STR);
		$stmt->execute();
			while ($row = $stmt->fetch()) {
				$sqbdata = new Dap_CourseCertificate();					
				$sqbdata->setId( $row["id"] );
				
				$sqbdata->setCourseId( stripslashes($row["course_id"]) );
				$sqbdata->setCertificateId( stripslashes($row["certificate_id"]) );
				$sqbdata->setCertificateGenerationCriteria( stripslashes($row["certificate_generation_criteria"]) );
				$sqbdata->setShortcodeType( stripslashes($row["shortcode_type"]) );
				$sqbdata->setNotEarnedCertificateOption( stripslashes($row["not_earned_certificate_option"]) );
				
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdata->setStatus( stripslashes($row["status"]) );
				$sqbdata->setDownloadBtnHtml( stripslashes($row["download_btn_html"]) );
				$sqbdata->setDownloadCustomizerValues( stripslashes($row["download_customizer_values"]));
				
				$sqbdataReturn = $sqbdata;
		}

		return $sqbdataReturn;
	}
	 
	
	public static function load() {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sqbdataarray = null;

		//Load product details from database
		$sql = "select * from dap_course_certificate ";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->execute();
		while ($row = $stmt->fetch()) {
				$sqbdata = new Dap_CourseCertificate();					
				$sqbdata->setId( $row["id"] );
				$sqbdata->setCourseId( stripslashes($row["course_id"]) );
				$sqbdata->setCertificateId( stripslashes($row["certificate_id"]) );
				$sqbdata->setCertificateGenerationCriteria( stripslashes($row["certificate_generation_criteria"]) );
				$sqbdata->setShortcodeType( stripslashes($row["shortcode_type"]) );
				$sqbdata->setNotEarnedCertificateOption( stripslashes($row["not_earned_certificate_option"]) );
				
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdata->setStatus( stripslashes($row["status"]) );
				$sqbdata->setDownloadBtnHtml( stripslashes($row["download_btn_html"]) );
				$sqbdata->setDownloadCustomizerValues( stripslashes($row["download_customizer_values"]));
				$sqbdataarray[] = $sqbdata;
		}

		return $sqbdataarray;
	}
	
	
	 
	public static function deleteById($id = 0) {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sql = "delete from dap_course_certificate where id = :id";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':id', $id, PDO::PARAM_INT);
		$stmt->execute();

		return $id; 
	}
	
	public static function deleteByCertificateId($certificate_id = 0) {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sql = "delete from dap_course_certificate where certificate_id = :certificate_id";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':certificate_id', $certificate_id, PDO::PARAM_INT);
		$stmt->execute();

		return $id;
	}
	
	
}
