<?php
	
class Dap_CourseTemplate {
	
   	var $id;
   	var $product_id;
   	var $template_id;
   	var $template_data;
   	var $customize_values;
   	var $date; 
   	var $status; 
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	function getProductId() {
		return $this->product_id;
	}
	function setProductId($o) {
		$this->product_id = $o;
	}
	
	function getTemplateId() {
		return $this->template_id;
	}
	function setTemplateId($o) {
		$this->template_id = $o;
	}

	function getTemplateData() {
		return $this->template_data;
	}
	function setTemplateData($o) {
		$this->template_data = $o;
	}
	function getCustomizeValues() {
		return $this->customize_values;
	}
	function setCustomizeValues($o) {
		$this->customize_values = $o;
	}
	 
	function getDate() {
		return $this->date;
	}
	function setDate($o) {
		$this->date = $o;
	}
	
	function getStatus() {
		return $this->status;
	}
	function setStatus($o) {
		$this->status = $o;
	}
 
	
	public function create() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_course_template_details
						( product_id, template_id, template_data, customize_values, date, status)
					values 
						( :product_id, :template_id, :template_data, :customize_values, now(), :status)";

			$stmt = $dap_dbh->prepare($sql);
				 
 
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
			$stmt->bindParam(':template_id', $this->getTemplateId(), PDO::PARAM_STR);
			$stmt->bindParam(':template_data', $this->getTemplateData(), PDO::PARAM_STR);
			$stmt->bindParam(':customize_values', $this->getCustomizeValues(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
 			$stmt->execute();
			 
			$last_insert_id = $dap_dbh->lastInsertId();
	 
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
 
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
	
			$sql = "update 
					dap_course_template_details
					set
						 product_id =:product_id, 
						 template_id =:template_id, 
						 template_data =:template_data, 
						 customize_values=:customize_values,
						 status=:status,
						 date=now()
					where
						id =:id ";
					
			$stmt = $dap_dbh->prepare($sql);	
			
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
			$stmt->bindParam(':template_id', $this->getTemplateId(), PDO::PARAM_STR);
			$stmt->bindParam(':template_data', $this->getTemplateData(), PDO::PARAM_STR);
			$stmt->bindParam(':customize_values', $this->getCustomizeValues(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->execute();
			
			$stmt = null;
			$dap_dbh = null;
			
			return $this->getId();
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
 	public static function updateStatus($product_id=0,$status=""){

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "UPDATE
						dap_course_template_details
						set
							status = :status 
						WHERE product_id =:product_id
						";			 
			
			$stmt = $dap_dbh->prepare($sql);			
			$stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
			$stmt->bindParam(':status', $status, PDO::PARAM_STR);
			$stmt->execute();
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
	public static function load() {
		$dataarr = array();
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_course_template_details ORDER BY date DESC
					";
			//logToFile($sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			 
			$stmt->execute();
	
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_CourseTemplate();
 
				$data->setId( stripslashes($row["id"]) );
				$data->setProductId( stripslashes($row["product_id"]) );
				$data->setTemplateId( stripslashes($row["template_id"]) );
				$data->setTemplateData( stripslashes($row["template_data"]) );
				$data->setCustomizeValues( stripslashes($row["customize_values"]) );
				$data->setDate( stripslashes($row["date"]) ); 
				$data->setStatus( stripslashes($row["status"]) ); 
				$dataarr[] = $data;

			}
			
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	}
	
	 public static function loadByCourseId($course_id) {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_course_template_details
					WHERE
						product_id =:product_id 
						
					";
					
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':product_id', $course_id, PDO::PARAM_INT);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_CourseTemplate();
				
				$data->setId( stripslashes($row["id"]) );
				$data->setProductId( stripslashes($row["product_id"]) );
				$data->setTemplateId( stripslashes($row["template_id"]) );
				$data->setTemplateData( stripslashes($row["template_data"]) );
				$data->setCustomizeValues( stripslashes($row["customize_values"]) );
				$data->setDate( stripslashes($row["date"]) ); 
				$data->setStatus( stripslashes($row["status"]) );
				$dataarr = $data;

			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
	
 
	public  function delete($id) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$dap_dbh->beginTransaction();
			
			//$id = $this->getId();
			//delete from usersproducts table
			  $sql = "delete from  
					dap_course_template_details
					where id =:id"; 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
			
			$dap_dbh->commit(); 
			
			$stmt = null;
			$dap_dbh = null;		
			return;			
		} catch (PDOException $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;				
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;			
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}		
	}
	
	public static function deleteByPID($product_id) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$dap_dbh->beginTransaction();
			
			//$id = $this->getId();
			//delete from usersproducts table
			  $sql = "delete from  
					dap_course_template_details
					where product_id =:product_id"; 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
			$stmt->execute();
			
			$dap_dbh->commit(); 
			
			$stmt = null;
			$dap_dbh = null;		
			return;			
		} catch (PDOException $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;				
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;			
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}		
	}
	
	public static function loadById($id) {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_course_template_details
					WHERE
						id =:id 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_STR);
			$stmt->execute();
	        if ($row = $stmt->fetch()) {
				$data = new Dap_CourseTemplate();
				$data->setId( stripslashes($row["id"]) );
				$data->setProductId( stripslashes($row["product_id"]) );
				$data->setTemplateId( stripslashes($row["template_id"]) );
				$data->setTemplateData( stripslashes($row["template_data"]) );
				$data->setCustomizeValues( stripslashes($row["customize_values"]) );
				$data->setDate( stripslashes($row["date"]) ); 
				$data->setStatus( stripslashes($row["status"]) );
				$dataarr = $data;

			}
			$stmt = null;
			$dap_dbh = null;
			return $dataarr;				
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
 
}
 
