<?php
	
class Dap_GopBadge {
	
   	var $id;
   	var $name;
   	var $description;
   	var $criteria;
   	var $badge_image_url;
   	var $badge_html;
   	var $badge_customizer;
   	var $send_email_status;
   	var $from_email;
   	var $from_name;
   	var $email_subject;
   	var $email_body;
   	var $display_message;
   	var $date; 
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	function getName() {
		return $this->name;
	}
	function setName($o) {
		$this->name = $o;
	}
	function getDescription() {
		return $this->description;
	}
	function setDescription($o) {
		$this->description = $o;
	}
	function getCriteria() {
		return $this->criteria;
	}
	function setCriteria($o) {
		$this->criteria = $o;
	}
	
	function getBadgeImageURL() {
		return $this->badge_image_url;
	}
	function setBadgeImageURL($o) {
		$this->badge_image_url = $o;
	}
	
	function getBadgeHtml() {
		return $this->badge_html;
	}
	function setBadgeHtml($o) {
		$this->badge_html = $o;
	}
	
	function getBadgeCustomizer() {
		return $this->badge_customizer;
	}
	function setBadgeCustomizer($o) {
		$this->badge_customizer = $o;
	}
	
	function getSendEmailStatus() {
		return $this->send_email_status;
	}
	function setSendEmailStatus($o) {
		$this->send_email_status = $o;
	}
	
	function getFromEmail() {
		return $this->from_email;
	}
	function setFromEmail($o) {
		$this->from_email = $o;
	}
	
	function getFromName() {
		return $this->from_name;
	}
	function setFromName($o) {
		$this->from_name = $o;
	}
	
	function getEmailSubject() {
		return $this->email_subject;
	}
	function setEmailSubject($o) {
		$this->email_subject = $o;
	}
	
	function getEmailBody() {
		return $this->email_body;
	}
	function setEmailBody($o) {
		$this->email_body = $o;
	}
	
	function getDisplayMessage() {
		return $this->display_message;
	}
	function setDisplayMessage($o) {
		$this->display_message = $o;
	}

	function getDate() {
		return $this->date;
	}
	function setDate($o) {
		$this->date = $o;
	}

	public function create() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_gop_badge
						( name, description, criteria, badge_image_url, badge_html, badge_customizer, send_email_status, from_email, from_name, email_subject, email_body, display_message , date)
					values 
						( :name, :description, :criteria, :badge_image_url, :badge_html, :badge_customizer, :send_email_status, :from_email, :from_name, :email_subject, :email_body, :display_message, now())";

			$stmt = $dap_dbh->prepare($sql);
				 
 
			$stmt->bindParam(':name', $this->getName(), PDO::PARAM_STR);
			$stmt->bindParam(':description', $this->getDescription(), PDO::PARAM_STR);
			$stmt->bindParam(':criteria', $this->getCriteria(), PDO::PARAM_STR);
			$stmt->bindParam(':badge_image_url', $this->getBadgeImageURL(), PDO::PARAM_STR);
			$stmt->bindParam(':badge_html', $this->getBadgeHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':badge_customizer', $this->getBadgeCustomizer(), PDO::PARAM_STR);
			$stmt->bindParam(':send_email_status', $this->getSendEmailStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':from_email', $this->getFromEmail(), PDO::PARAM_STR);
			$stmt->bindParam(':from_name', $this->getFromName(), PDO::PARAM_STR);
			$stmt->bindParam(':email_subject', $this->getEmailSubject(), PDO::PARAM_STR);
			$stmt->bindParam(':email_body', $this->getEmailBody(), PDO::PARAM_STR);
			$stmt->bindParam(':display_message', $this->getDisplayMessage(), PDO::PARAM_STR);
			
 			$stmt->execute();
			 
			$last_insert_id = $dap_dbh->lastInsertId();
	 
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
 
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
	
			$sql = "update 
					dap_gop_badge
					set
						 name =:name, 
						 description =:description, 
						 criteria =:criteria,
						 badge_image_url =:badge_image_url, 
						 badge_html =:badge_html, 
						 badge_customizer =:badge_customizer, 
						 send_email_status =:send_email_status, 
						 from_email =:from_email, 
						 from_name =:from_name, 
						 email_subject =:email_subject, 
						 email_body =:email_body, 
						 display_message =:display_message,
						 date = now() 
					where
						id =:id ";
					
			$stmt = $dap_dbh->prepare($sql);	
			
			$stmt->bindParam(':name', $this->getName(), PDO::PARAM_STR);
			$stmt->bindParam(':description', $this->getDescription(), PDO::PARAM_STR);
			$stmt->bindParam(':criteria', $this->getCriteria(), PDO::PARAM_STR);
			$stmt->bindParam(':badge_image_url', $this->getBadgeImageURL(), PDO::PARAM_STR);
			$stmt->bindParam(':badge_html', $this->getBadgeHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':badge_customizer', $this->getBadgeCustomizer(), PDO::PARAM_STR);
			$stmt->bindParam(':send_email_status', $this->getSendEmailStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':from_email', $this->getFromEmail(), PDO::PARAM_STR);
			$stmt->bindParam(':from_name', $this->getFromName(), PDO::PARAM_STR);
			$stmt->bindParam(':email_subject', $this->getEmailSubject(), PDO::PARAM_STR);
			$stmt->bindParam(':email_body', $this->getEmailBody(), PDO::PARAM_STR);
			$stmt->bindParam(':display_message', $this->getDisplayMessage(), PDO::PARAM_STR);
			
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
 
	public static function load() {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_gop_badge ORDER BY date DESC
					";
			//logToFile($sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			 
			$stmt->execute();
	
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_GopBadge();
				$data->setId( stripslashes($row["id"]) );
				$data->setName( stripslashes($row["name"]) );
				$data->setDescription( stripslashes($row["description"]) );
				$data->setCriteria( stripslashes($row["criteria"]) );
				$data->setBadgeImageURL( stripslashes($row["badge_image_url"]) );
				$data->setBadgeHtml( stripslashes($row["badge_html"]) );
				$data->setBadgeCustomizer( stripslashes($row["badge_customizer"]) );
				$data->setSendEmailStatus( stripslashes($row["send_email_status"]) );
				$data->setFromEmail( stripslashes($row["from_email"]) );
				$data->setFromName( stripslashes($row["from_name"]) );
				$data->setEmailSubject( stripslashes($row["email_subject"]) );
				$data->setEmailBody( stripslashes($row["email_body"]) );
				$data->setDisplayMessage( stripslashes($row["display_message"]) );
				$data->setDate( stripslashes($row["date"]) );
				$dataarr[] = $data;

			}
			
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	}
	
	 public static function loadById($id = 0) {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_gop_badge
					WHERE
						id =:id 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_GopBadge();
				$data->setId( stripslashes($row["id"]) );
				$data->setName( stripslashes($row["name"]) );
				$data->setDescription( stripslashes($row["description"]) );
				$data->setCriteria( stripslashes($row["criteria"]) );
				$data->setBadgeImageURL( stripslashes($row["badge_image_url"]) );
				$data->setBadgeHtml( stripslashes($row["badge_html"]) );
				$data->setBadgeCustomizer( stripslashes($row["badge_customizer"]) );
				$data->setSendEmailStatus( stripslashes($row["send_email_status"]) );
				$data->setFromEmail( stripslashes($row["from_email"]) );
				$data->setFromName( stripslashes($row["from_name"]) );
				$data->setEmailSubject( stripslashes($row["email_subject"]) );
				$data->setEmailBody( stripslashes($row["email_body"]) );
				$data->setDisplayMessage( stripslashes($row["display_message"]) );
				$data->setDate( stripslashes($row["date"]) );
				$dataarr = $data;
			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
	
	public static function delete($id = 0) {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sql = "delete from dap_gop_badge where id = :id";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':id', $id, PDO::PARAM_INT);
		$stmt->execute();

		return $id;
	}
 
}
