<?php
	
class Dap_GopBadgeSteps {
	
   	var $id;
   	var $badge_id;
   	var $action;
   	var $value;
   	var $total_times;
   	var $limited_to;
   	var $limit_by;
   	var $status; 
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	function getBadgeId() {
		return $this->badge_id;
	}
	function setBadgeId($o) {
		$this->badge_id = $o;
	}
	function getAction() {
		return $this->action;
	}
	function setAction($o) {
		$this->action = $o;
	}
	function getValue() {
		return $this->value;
	}
	function setValue($o) {
		$this->value = $o;
	}

	function getTotalTimes() {
		return $this->total_times;
	}
	function setTotalTimes($o) {
		$this->total_times = $o;
	}
	
	
	function getLimitedTo() {
		return $this->limited_to;
	}
	function setLimitedTo($o) {
		$this->limited_to = $o;
	}
	
	function getLimitBy() {
		return $this->limit_by;
	}
	function setLimitBy($o) {
		$this->limit_by = $o;
	}
	
	function getStatus() {
		return $this->status;
	}
	function setStatus($o) {
		$this->status = $o;
	}
	 
	 
	 
	 
	
	public function create() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_gop_badge_steps
						( badge_id, action, value, total_times, limited_to, limit_by, status)
					values 
						( :badge_id, :action, :value,:total_times, :limited_to, :limit_by, :status )";

			$stmt = $dap_dbh->prepare($sql);
				 
 
			$stmt->bindParam(':badge_id', $this->getBadgeId(), PDO::PARAM_INT);
			$stmt->bindParam(':action', $this->getAction(), PDO::PARAM_STR);
			$stmt->bindParam(':value', $this->getValue(), PDO::PARAM_STR);
			$stmt->bindParam(':total_times', $this->getTotalTimes(), PDO::PARAM_STR);
			$stmt->bindParam(':limited_to', $this->getLimitedTo(), PDO::PARAM_STR);
			$stmt->bindParam(':limit_by', $this->getLimitBy(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			
 			$stmt->execute();
			 
			$last_insert_id = $dap_dbh->lastInsertId();
	 
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
 
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
	
			$sql = "update 
					dap_gop_badge_steps
					set
						 badge_id =:badge_id, 
						 action =:action, 
						 value =:value, 
						 total_times =:total_times, 
						 limited_to =:limited_to, 
						 limit_by =:limit_by, 
						 status =:status 
					where
						id =:id ";
					
			$stmt = $dap_dbh->prepare($sql);	
			
			$stmt->bindParam(':badge_id', $this->getBadgeId(), PDO::PARAM_INT);
			$stmt->bindParam(':action', $this->getAction(), PDO::PARAM_STR);
			$stmt->bindParam(':value', $this->getValue(), PDO::PARAM_STR);
			$stmt->bindParam(':total_times', $this->getTotalTimes(), PDO::PARAM_STR);
			$stmt->bindParam(':limited_to', $this->getLimitedTo(), PDO::PARAM_STR);
			$stmt->bindParam(':limit_by', $this->getLimitBy(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->execute();
			
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
 
	public static function load() {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_gop_badge_steps ORDER BY date DESC
					";
			//logToFile($sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			 
			$stmt->execute();
	
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_GopBadgeSteps();
				$data->setBadgeId( stripslashes($row["badge_id"]) );
				$data->setAction( stripslashes($row["action"]) );
				$data->setValue( stripslashes($row["value"]) );
				$data->setTotalTimes( stripslashes($row["total_times"]) );
				$data->setLimitedTo( stripslashes($row["limited_to"]) );
				$data->setLimitBy( stripslashes($row["limit_by"]) );
				$data->setStatus( stripslashes($row["status"]) );
				$dataarr[] = $data;

			}
			
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	}
	
	 public static function loadById($id = 0) {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_gop_badge_steps
					WHERE
						id =:id 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_GopBadgeSteps();
				$data->setBadgeId( stripslashes($row["badge_id"]) );
				$data->setAction( stripslashes($row["action"]) );
				$data->setValue( stripslashes($row["value"]) );
				$data->setTotalTimes( stripslashes($row["total_times"]) );
				$data->setLimitedTo( stripslashes($row["limited_to"]) );
				$data->setLimitBy( stripslashes($row["limit_by"]) );
				$data->setStatus( stripslashes($row["status"]) );
				$dataarr = $data;
			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	 public static function loadByActionAndValueAndStatus($action = '', $value=0, $status='') {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_gop_badge_steps
					WHERE
						action =:action  AND
						value =:value  AND
						status =:status  
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':action', $action, PDO::PARAM_STR);
			$stmt->bindParam(':value', $value, PDO::PARAM_STR);
			$stmt->bindParam(':status', $status, PDO::PARAM_STR);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_GopBadgeSteps();
				$data->setBadgeId( stripslashes($row["badge_id"]) );
				$data->setAction( stripslashes($row["action"]) );
				$data->setValue( stripslashes($row["value"]) );
				$data->setTotalTimes( stripslashes($row["total_times"]) );
				$data->setLimitedTo( stripslashes($row["limited_to"]) );
				$data->setLimitBy( stripslashes($row["limit_by"]) );
				$data->setStatus( stripslashes($row["status"]) );
				$dataarr = $data;
			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
	
	 public static function loadByActionAndValue($action = '', $value= '') {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_gop_badge_steps
					WHERE
						action =:action  AND
						value =:value  
						
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':action', $action, PDO::PARAM_STR);
			$stmt->bindParam(':value', $value, PDO::PARAM_STR);
			
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_GopBadgeSteps();
				$data->setBadgeId( stripslashes($row["badge_id"]) );
				$data->setAction( stripslashes($row["action"]) );
				$data->setValue( stripslashes($row["value"]) );
				$data->setTotalTimes( stripslashes($row["total_times"]) );
				$data->setLimitedTo( stripslashes($row["limited_to"]) );
				$data->setLimitBy( stripslashes($row["limit_by"]) );
				$data->setStatus( stripslashes($row["status"]) );
				$dataarr = $data;
			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
	
	public static function delete($id = 0) {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sql = "delete from dap_gop_badge_steps where id = :id";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':id', $id, PDO::PARAM_INT);
		$stmt->execute();

		return $id;
	}
 
}
