<?php
	
class Dap_GopNotifications {
	
   	var $id;
   	var $type;
   	var $subject;
   	var $body;
   	var $from_email; 
   	var $from_name; 
   	var $status; 
   	var $date; 
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	
	function setType($o) {
		$this->type = $o;
	}
	function getType() {
		return $this->type;
	}
	
	function setSubject($o) {
		$this->subject = $o;
	}
	function getSubject() {
		return $this->subject;
	}
	
	function setBody($o) {
		$this->body = $o;
	}
	function getBody() {
		return $this->body;
	}
	
	function setFromEmail($o) {
		$this->from_email = $o;
	}
	function getFromEmail() {
		return $this->from_email;
	}
	
	function setFromName($o) {
		$this->from_name = $o;
	}
	function getFromName() {
		return $this->from_name;
	}
	
	
	function setStatus($o) {
		$this->status = $o;
	}
	function getStatus() {
		return $this->status;
	}
	
	function setDate($o) {
		$this->date = $o;
	}
	function getDate() {
		return $this->date;
	}
	 
	 
	 
	 
	
	public function create() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_gop_notifications
						( type, subject, body, from_email, from_name, status, date)
					values 
						( :type, :subject, :body, :from_email, :from_name, :status, now())";

			$stmt = $dap_dbh->prepare($sql);
				 
 
			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_INT);
			$stmt->bindParam(':subject', $this->getSubject(), PDO::PARAM_STR);
			$stmt->bindParam(':body', $this->getBody(), PDO::PARAM_STR);
			$stmt->bindParam(':from_email', $this->getFromEmail(), PDO::PARAM_STR);
			$stmt->bindParam(':from_name', $this->getFromName(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			
 			$stmt->execute();
			 
			$last_insert_id = $dap_dbh->lastInsertId();
	 
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
 
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
	
			$sql = "update 
					dap_gop_notifications
					set
						 type =:type, 
						 subject =:subject, 
						 body =:body, 
						 from_email =:from_email, 
						 from_name =:from_name, 
						 status =:status 
					where
						id = :id ";
					
			$stmt = $dap_dbh->prepare($sql);	
			
			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_INT);
			$stmt->bindParam(':subject', $this->getSubject(), PDO::PARAM_STR);
			$stmt->bindParam(':body', $this->getBody(), PDO::PARAM_STR);
			$stmt->bindParam(':from_email', $this->getFromEmail(), PDO::PARAM_STR);
			$stmt->bindParam(':from_name', $this->getFromName(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->execute();
			
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
 
	public static function load() {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_gop_notifications ORDER BY date DESC
					";
			//logToFile($sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			 
			$stmt->execute();
	
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_GopNotifications();
				$data->setId( stripslashes($row["id"]) );
				$data->setType( stripslashes($row["type"]) );
				$data->setSubject( stripslashes($row["subject"]) );
				$data->setBody( stripslashes($row["body"]) );
				$data->setFromEmail( stripslashes($row["from_email"]) );
				$data->setFromName( stripslashes($row["from_name"]) );
				$data->setStatus( stripslashes($row["status"]) );
				$data->setDate( stripslashes($row["date"]) );
				$dataarr[] = $data;

			}
			
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	}
	
	 public static function loadByType($type = '') {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_gop_notifications
					WHERE
						type =:type 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':type', $type, PDO::PARAM_STR);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_GopNotifications();
				$data->setId( stripslashes($row["id"]) );
				$data->setType( stripslashes($row["type"]) );
				$data->setSubject( stripslashes($row["subject"]) );
				$data->setBody( stripslashes($row["body"]) );
				$data->setFromEmail( stripslashes($row["from_email"]) );
				$data->setFromName( stripslashes($row["from_name"]) );
				$data->setStatus( stripslashes($row["status"]) );
				$data->setDate( stripslashes($row["date"]) );
			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	 
	
	
	public static function delete($id = 0) {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sql = "delete from dap_gop_notifications where id = :id";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':id', $id, PDO::PARAM_INT);
		$stmt->execute();

		return $id;
	}
 
}
