<?php 
class Dap_MasterTags{
	
	var $id;
	var $tag_name;
	var $action;
	var $template;
	var $template_html;
	var $styling_options;
	var $date;
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getTagName() {
		return $this->tag_name;
	}
	function setTagName($o) {
		$this->tag_name = $o;
	}
	
	
	
	
	
    public function create() {
		 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$tableName = "dap_master_tags";
			
			$sql = "insert into ".$tableName." 
						(tag_name)
					values
						(:tag_name)";
			
		
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':tag_name', $this->getTagName(), PDO::PARAM_STR);
			$stmt->execute();
           
            $last_id = $dap_dbh->lastInsertId();
            $stmt = null;
			$dap_dbh = null;
			return $last_id;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
    
   
	/*
	 * update message in database
	 */ 
	public function update() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$tableName = "dap_master_tags";
			
			$sql = "update ".$tableName." set
						tag_name = :tag_name,
						where	id = :id";
		
			$stmt = $dap_dbh->prepare($sql);
			
 			$stmt->bindParam(':tag_name', $this->getTagName(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
			return $this->getId();

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
		
	
	/*
	 * load all messages
	*/ 
	public static function load() {
		$LoadList = array(); 
		$tableName = "dap_master_tags";
		$sql = "select * from ".$tableName."  order by id desc";		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_MasterTags(); 

				$data->setId( $row["id"] );
				$data->setTagName( $row["tag_name"] );
				$LoadList[] = $data;
			}
			$stmt = null;
			$dap_dbh = null;
			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
			
	}
	
	
	
	
	public static function loadById($id = 0) {
		
		$LoadList = null; 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$tableName = "dap_master_tags";
			
			$sql = "select * from ".$tableName." where id = :id";
			
			$stmt = $dap_dbh->prepare($sql);
 			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_MasterTags(); 
				$data->setId( $row["id"] );
				$data->setTagName( $row["tag_name"] );
				
				$LoadList = $data;
			}
			
            $stmt = null;
			$dap_dbh = null;
			return $LoadList;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}			
	}
	
	
	
	
	public static function loadByTagName($tag_name = '') {
		
		$LoadList = null; 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$tableName = "dap_master_tags";
			
			$sql = "select * from ".$tableName." where tag_name = :tag_name";
			
			$stmt = $dap_dbh->prepare($sql);
 			$stmt->bindParam(':tag_name', $tag_name, PDO::PARAM_STR);
			
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_MasterTags(); 
				$data->setId( $row["id"] );
				$data->setTagName( $row["tag_name"] );
				
				$LoadList = $data;
			}
			
            $stmt = null;
			$dap_dbh = null;
			return $LoadList;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}			
	}
	
	
	
	
	public static function deleteById($id = ''){
        
        $tableName = "dap_master_tags";
		$sql = "delete from ".$tableName." where `id` =:id";
		
		try{		
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
			return true;
	    } catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
				
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
       	 
	}
	
}
		
	
