<?php 
class Dap_TagRules{
	
	var $id;
	var $product_id;
	var $action;
	var $add_tag_ids;
	var $remove_tag_ids;
	var $lesson_id;
	var $date;
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getProductId() {
		return $this->product_id;
	}
	function setProductId($o) {
		$this->product_id = $o;
	}
	
	function getAction() {
		return $this->action;
	}
	function setAction($o) {
		$this->action = $o;
	}
	
	function getAddTagIds() {
		return $this->add_tag_ids;
	}
	function setAddTagIds($o) {
		$this->add_tag_ids = $o;
	}
	
	function getRemoveTagIds() {
		return $this->remove_tag_ids;
	}
	function setRemoveTagIds($o) {
		$this->remove_tag_ids = $o;
	}
	function getLessonId() {
		return $this->lesson_id;
	}
	function setLessonId($o) {
		$this->lesson_id = $o;
	}
	function getDate() {
		return $this->date;
	}
	function setDate($o) {
		$this->date = $o;
	}
	
	
	
    public function create() {
		 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$tableName = "dap_tag_rules";
			
			$sql = "insert into ".$tableName." 
						(product_id, action, add_tag_ids,remove_tag_ids, lesson_id,date )
					values
						(:product_id, :action, :add_tag_ids, :remove_tag_ids, :lesson_id, :date)";
			
		
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
 			$stmt->bindParam(':action', $this->getAction(), PDO::PARAM_STR);
			$stmt->bindParam(':add_tag_ids', $this->getAddTagIds(), PDO::PARAM_STR);
			$stmt->bindParam(':remove_tag_ids', $this->getRemoveTagIds(), PDO::PARAM_STR);
			$stmt->bindParam(':lesson_id', $this->getLessonId(), PDO::PARAM_INT);
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->execute();
           
            $last_id = $dap_dbh->lastInsertId();
            $stmt = null;
			$dap_dbh = null;
			return $last_id;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
    
   
	/*
	 * update message in database
	 */ 
	public function update() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$tableName = "dap_tag_rules";
			
			$sql = "update ".$tableName." set
						product_id = :product_id,
						action = :action,
						add_tag_ids = :add_tag_ids,
						remove_tag_ids = :remove_tag_ids,
						lesson_id = :lesson_id,
						
						date = :date
						where	id = :id";
		
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
 			$stmt->bindParam(':action', $this->getAction(), PDO::PARAM_STR);
			$stmt->bindParam(':add_tag_ids', $this->getAddTagIds(), PDO::PARAM_STR);
			$stmt->bindParam(':remove_tag_ids', $this->getRemoveTagIds(), PDO::PARAM_STR);
			$stmt->bindParam(':lesson_id', $this->getLessonId(), PDO::PARAM_INT);
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
			return $this->getId();

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
		
	
	/*
	 * load all messages
	*/ 
	public static function load() {
		$LoadList = array(); 
		$tableName = "dap_tag_rules";
		$sql = "select * from ".$tableName;		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_TagRules(); 

				$data->setId( $row["id"] );
				$data->setProductId( $row["product_id"] );
				$data->setAction( $row["action"] );
				$data->setAddTagIds( $row["add_tag_ids"] );
				$data->setRemoveTagIds( $row["remove_tag_ids"] );
				$data->setLessonId( $row["lesson_id"] );
				
				$data->setDate( $row["date"] );
				$LoadList[] = $data;
			}
			$stmt = null;
			$dap_dbh = null;
			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
			
	}
	
	
	
	public static function loadByActionName($action = '') {
		$LoadList = array(); 
		$tableName = "dap_tag_rules";
		$sql = "select * from ".$tableName." where action = :action";
		
		

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			
 			$stmt->bindParam(':action', $action, PDO::PARAM_STR);
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_TagRules(); 
				$data->setId( $row["id"] );
				$data->setProductId( $row["product_id"] );
				$data->setAction( $row["action"] );
				$data->setAddTagIds( $row["add_tag_ids"] );
				$data->setRemoveTagIds( $row["remove_tag_ids"] );
				$data->setLessonId( $row["lesson_id"] );
				$data->setDate( $row["date"] );
				$LoadList[] = $data;
			}
			$stmt = null;
			$dap_dbh = null;
			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
			
	}
	
	
	
	
	public static function loadById($id = 0) {
		
		$LoadList = null; 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$tableName = "dap_tag_rules";
			
			$sql = "select * from ".$tableName." where id = :id";
			
			$stmt = $dap_dbh->prepare($sql);
 			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_TagRules(); 
				$data->setId( $row["id"] );
				$data->setProductId( $row["product_id"] );
				$data->setAction( $row["action"] );
				$data->setAddTagIds( $row["add_tag_ids"] );
				$data->setRemoveTagIds( $row["remove_tag_ids"] );
				$data->setLessonId( $row["lesson_id"] );
				$LoadList = $data;
			}
			
            $stmt = null;
			$dap_dbh = null;
			return $LoadList;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}			
	}
	
	
	
	public static function loadByProductIdAndLessonIdAndActionName($product_id = 0, $lesson_id= 0 , $action = '') {
		$LoadList = null; 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$tableName = "dap_tag_rules"; 			
			$sql = "select
						*
					from 			
						".$tableName."
					where
						product_id = :product_id and 
						lesson_id = :lesson_id and
						action = :action 
					";			
			
			$stmt = $dap_dbh->prepare($sql);
 			
 			$stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
 			$stmt->bindParam(':lesson_id', $lesson_id, PDO::PARAM_INT);
 			$stmt->bindParam(':action', $action, PDO::PARAM_STR);			
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_TagRules(); 
				$data->setId( $row["id"] );
				$data->setProductId( $row["product_id"] );
				$data->setAction( $row["action"] );
				$data->setAddTagIds( $row["add_tag_ids"] );
				$data->setRemoveTagIds( $row["remove_tag_ids"] );				
				$LoadList = $data;
			}
			
            $stmt = null;
			$dap_dbh = null;
			return $LoadList;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}			
	}
	public static function loadByProductIdAndActionName($product_id = 0, $action = '') {
		
		$LoadList = null; 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$tableName = "dap_tag_rules"; 			
			$sql = "select
						*
					from 			
						".$tableName."
					where
						product_id = :product_id and
						action = :action 
					";			
			
			$stmt = $dap_dbh->prepare($sql);
 			
 			$stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
 			$stmt->bindParam(':action', $action, PDO::PARAM_STR);			
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_TagRules(); 
				$data->setId( $row["id"] );
				$data->setProductId( $row["product_id"] );
				$data->setAction( $row["action"] );
				$data->setAddTagIds( $row["add_tag_ids"] );
				$data->setRemoveTagIds( $row["remove_tag_ids"] );				
				$LoadList = $data;
			}
			
            $stmt = null;
			$dap_dbh = null;
			return $LoadList;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}			
	}
	
	public static function loadByCourseIdAndLessonIdAndActionName($product_id = 0, $lesson_id = 0,  $action = '') {
		
		$LoadList = null; 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$tableName = "dap_tag_rules";
					
			$sql = "select
						*
					from 
						
						".$tableName."
					where
						product_id = :product_id and action = :action";
						
			
					if($lesson_id != 0){			
						$sql .= " and lesson_id = :lesson_id";
					}
									
			
			
			$stmt = $dap_dbh->prepare($sql);
 			
 			$stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
 			if($lesson_id != 0){			
				$stmt->bindParam(':lesson_id', $lesson_id, PDO::PARAM_INT);
			}
 			$stmt->bindParam(':action', $action, PDO::PARAM_STR);
			
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_TagRules(); 
				$data->setId( $row["id"] );
				$data->setProductId( $row["product_id"] );
				$data->setLessonId( $row["lesson_id"] );
				$data->setAction( $row["action"] );
				$data->setAddTagIds( $row["add_tag_ids"] );
				$data->setRemoveTagIds( $row["remove_tag_ids"] );
				
				$LoadList = $data;
			}
			
            $stmt = null;
			$dap_dbh = null;
			return $LoadList;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}			
	}
	
	
	
	
	
	
	public static function deleteById($id = ''){
        
        $tableName = "dap_tag_rules";
		$sql = "delete from ".$tableName." where `id` =:id";
		
		try{		
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
			return true;
	    } catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
				
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
       	 
	}
	
}
		
	
