<?php

class Dap_UserFiles {
	
	var $id;
	var $user_id;
	var $filename;
	var $url;
	var $date;
	
	function getId() {
		return $this->id;
	}

	function setId($o) {
		$this->id = $o;
	}

	function getUserId() {
		return $this->user_id;
	}

	function setUserId($o) {
		$this->user_id = $o;
	}

	function getFileName() {
		return $this->filename;
	}

	function setFileName($o) {
		$this->filename = $o;
	}

	function getUrl() {
		return $this->url;
	}

	function setUrl($o) {
		$this->url = $o;
	}

	function getDate() {
		return $this->date;
	}

	function setDate($o) {
		$this->date = $o;
	}
	
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			//return $this->getFormName()."--".$this->getProductId();
			$sql = "insert into dap_users_files
						(user_id, filename, url, date)
					values
						(:user_id, :filename, :url,now() )";  
						
			logToFile("Dap_FormFields.class.php, create() sql=".$sql, LOG_INFO_DAP);
			
			$stmt = $dap_dbh->prepare($sql);

			$stmt->bindParam(':user_id', $this->getUserId(), PDO::PARAM_INT);
			$stmt->bindParam(':filename', $this->getFileName(), PDO::PARAM_STR);
			$stmt->bindParam(':url', $this->getUrl(), PDO::PARAM_STR);
			$stmt->execute();

			$last_insert_id = $dap_dbh->lastInsertId();
			$this->setId($last_insert_id);
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	
		
	public static function loadByUserId($user_id = 0) {  
		
		$LoadList = false; 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$tableName = "dap_users_files";
			
			$sql = "select * from ".$tableName." where user_id = :user_id";
			
			$stmt = $dap_dbh->prepare($sql);
 			$stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
			
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_UserFiles(); 
				$data->setId( $row["id"] );
				$data->setUserId($row["user_id"] );
				$data->setFileName($row["filename"] );
				$data->setUrl( $row["url"] );
				$data->setDate( $row["date"] );
				
				$LoadList[] = $data;
			}
			
            $stmt = null;
			$dap_dbh = null;
			return $LoadList;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}			
	}
	
	public static function delete($id){
        
        $tableName = "dap_users_files";
		$sql = "delete from ".$tableName." where `id` =:id";
		
		try{		
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
			return true;
	    } catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
				
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
       	 
	}
	
	

}
