<?php 

class Dap_UserTagAction {
	var $id;
	var $user_id;
	var $automation_rule_id;	
	var $user_tag_id;	
	var $status;	
	var $date;	
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getUserId() {
		return $this->user_id;
	}
	function setUserId($o) {
		$this->user_id = $o;
	}
	
	function getAutomationRuleId() {
		return $this->automation_rule_id;
	}
	function setAutomationRuleId($o) {
		$this->automation_rule_id = $o;
	}
	
	function getUserTagId() {
		return $this->user_tag_id;
	}
	function setUserTagId($o) {
		$this->user_tag_id = $o;
	}
	
	function getStatus() {
		return $this->status;
	}
	function setStatus($o) {
		$this->status = $o;
	}
	
	function getDate() {
		return $this->date;
	}
	function setDate($o) {
		$this->date = $o;
	}
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
		
			$sql = "insert into dap_user_tag_action
						(user_id, automation_rule_id, user_tag_id, status, date)
					values
						(:user_id, :automation_rule_id, :user_tag_id,  :status, :date)";

			$stmt = $dap_dbh->prepare($sql);
			
			$stmt->bindParam(':user_id', $this->getUserId(), PDO::PARAM_INT);
			$stmt->bindParam(':automation_rule_id', $this->getAutomationRuleId(), PDO::PARAM_INT);
			$stmt->bindParam(':user_tag_id', $this->getUserTagId(), PDO::PARAM_INT);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->execute();

			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			
				$sql = "update dap_user_tag_action set
							user_id = :user_id,
							automation_rule_id = :automation_rule_id ,
							user_tag_id = :user_tag_id ,
							status = :status ,
							date = :date ,
						    where id = :id";
			 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':user_id', $this->getUserId(), PDO::PARAM_INT);
			$stmt->bindParam(':automation_rule_id', $this->getAutomationRuleId(), PDO::PARAM_INT);
			$stmt->bindParam(':user_tag_id', $this->getUserTagId(), PDO::PARAM_INT);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
		
			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	
	public static function loadById($id) {  
		
		$data = false; 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$tableName = "dap_user_tag_action";
			
			$sql = "select * from ".$tableName." where id = :id";
			
			$stmt = $dap_dbh->prepare($sql);
 			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_UserTagAction(); 
				$data->setId( $row["id"] );
				$data->setUserId($row["user_id"] );
				$data->setAutomationRuleId($row["automation_rule_id"] );
				$data->setUserTagId( $row["user_tag_id"] );
				$data->setStatus( $row["date"] );
				$data->setDate( $row["lesson_id"] );
			}
			
            $stmt = null;
			$dap_dbh = null;
			return $data;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}			
	}
	
	
	
	
	
	
}
