<?php 

class Dap_UserTags {
	
	var $id;
	var $user_id;
	var $tag_id;	
	var $type;	
	var $product_id;	
	var $lesson_id;
	var $date;	
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getUserId() {
		return $this->user_id;
	}
	function setUserId($o) {
		$this->user_id = $o;
	}
	
	function getTagId() {
		return $this->tag_id;
	}
	function setTagId($o) {
		$this->tag_id = $o;
	}
	
	
	function getType() {
		return $this->type;
	}
	function setType($o) {
		$this->type = $o;
	}
	
	function getProductId() {
		return $this->product_id;
	}
	function setProductId($o) {
		$this->product_id = $o;
	}
	function getLessonId() {
		return $this->lesson_id;
	}
	function setLessonId($o) {
		$this->lesson_id = $o;
	}
	
	function getDate() {
		return $this->date;
	}
	function setDate($o) {
		$this->date = $o;
	}
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
		
			$sql = "insert into dap_user_tags
						(user_id, tag_id, type, product_id,lesson_id, date)
					values
						(:user_id, :tag_id, :type, :product_id, :lesson_id, now())";

			$stmt = $dap_dbh->prepare($sql);
			
			$stmt->bindParam(':user_id', $this->getUserId(), PDO::PARAM_INT);
			$stmt->bindParam(':tag_id', $this->getTagId(), PDO::PARAM_INT);
			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_STR);
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
			$stmt->bindParam(':lesson_id', $this->getLessonId(), PDO::PARAM_INT);
			$stmt->execute();

			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			
				$sql = "update dap_user_tags set
							user_id = :user_id,
							tag_id = :tag_id ,
							type = :type ,
							product_id = :product_id ,
							date = :date 
						    where id = :id";
			 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':user_id', $this->getUserId(), PDO::PARAM_INT);
			$stmt->bindParam(':tag_id', $this->getTagId(), PDO::PARAM_INT);
			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_STR);
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
			$stmt->bindParam(':lesson_id', $this->getLessonId(), PDO::PARAM_INT);
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
		
			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	
	
	public static function loadByUserId($user_id = 0) {  
		
		$LoadList = null; 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$tableName = "dap_user_tags";
			
			$sql = "select * from ".$tableName." where user_id = :user_id";
			
			$stmt = $dap_dbh->prepare($sql);
 			$stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
			
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_UserTags(); 
				$data->setId( $row["id"] );
				$data->setTagId($row["tag_id"] );
				$data->setType($row["type"] );
				$data->setProductId( $row["product_id"] );
				$data->setDate( $row["date"] );
				$data->setLessonId( $row["lesson_id"] );
				
				$LoadList[] = $data;
			}
			
            $stmt = null;
			$dap_dbh = null;
			return $LoadList;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}			
	}

	public static function loadByTagId($tag_id = 0) {  
		
		$LoadList = null; 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$tableName = "dap_user_tags";
			
			$sql = "select * from ".$tableName." where tag_id = :tag_id";
			
			$stmt = $dap_dbh->prepare($sql);
 			$stmt->bindParam(':tag_id', $tag_id, PDO::PARAM_INT);
			
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_UserTags(); 
				$data->setId( $row["id"] );
				$data->setTagId($row["tag_id"] );
				$data->setType($row["type"] );
				$data->setProductId( $row["product_id"] );
				$data->setDate( $row["date"] );
				$data->setLessonId( $row["lesson_id"] );
				
				$LoadList[] = $data;
			}
			
            $stmt = null;
			$dap_dbh = null;
			return $LoadList;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}			
	}
	
	
	public static function load() {  
		
		$LoadList = null; 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$tableName = "dap_user_tags";
			
			$sql = "select * from ".$tableName;
			
			$stmt = $dap_dbh->prepare($sql);
 			
			
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_UserTags(); 
				$data->setId( $row["id"] );
				$data->setTagId($row["tag_id"] );
				$data->setType($row["type"] );
				$data->setProductId( $row["product_id"] );
				$data->setDate( $row["date"] );
				$data->setLessonId( $row["lesson_id"] );
				
				$LoadList[] = $data;
			}
			
            $stmt = null;
			$dap_dbh = null;
			return $LoadList;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}			
	}
	
	
	
	public static function loadByJoinUserTagAction() {  
		
		$LoadList = null; 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$tableName = "dap_user_tags";
			
			$sql = "select * from ".$tableName." ut  join  dap_user_tag_action uta	on ut.id = uta.user_tag_id ";  
			
			$stmt = $dap_dbh->prepare($sql);
 			
			
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				//data = new Dap_UserTags(); 
				
				
				$LoadList[] = $row; 
			}
			
            $stmt = null;
			$dap_dbh = null;
			return $LoadList;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}			
	}
	
	
	public static function loadUserTags($search_tag_ids = '', $start){
	
		try {
			$dap_dbh = Dap_Connection::getConnection();
			if($search_tag_ids != ''){
				$search_tag_ids_arr = explode(',' , $search_tag_ids);	
				
				$search_tag_ids = implode("','", $search_tag_ids_arr);
			}
			
			
			if( !isset($start) || ($start == "undefined")  || ($start == "")) {
				//if(Dap_Session::get('start')
				$start = 0;
			}
			$end = Dap_Config::get("SEARCH_USERS_COUNT");
			$userTagArrayList = array();
			
			$sql = "select
						u.id,
						u.first_name,
						u.last_name,
						u.user_name,
						u.email,
						u.paypal_email,
						u.account_type,
						u.opted_out,
						u.status,
						u.credits_available,
						u.login_count,
						u.ipaddress,
						u.last_login_date,
						p.id as product_id,
						p.name as product_name,
						p.is_recurring,
						dmt.tag_name,
						upj.transaction_id,
						upj.coupon_id,
						upj.access_start_date as access_start_date,
						upj.access_end_date as access_end_date,
						upj.status as upj_status
						
					from 
						
					dap_users u join dap_user_tags ut
						on u.id = ut.user_id 
					join dap_users_products_jn upj
						on ut.user_id  = upj.user_id	
					join dap_products p
						on ut.product_id = p.id 
					join dap_master_tags dmt 
						on  ut.tag_id = dmt.id  
					
						
					";
				if($search_tag_ids != ''){
					$sql .= " WHERE ut.tag_id IN ('".$search_tag_ids."')";
				}	
			
			$sql .= " limit $start, $end";
			$stmt = $dap_dbh->prepare($sql);
			
			$stmt->execute();
			while ($row = $stmt->fetch()) {
				$userArray = array();
				
				$userArray["id"] = $row["id"] ;
				$userArray["first_name"] = htmlentities($row["first_name"], ENT_QUOTES, 'UTF-8');
				$userArray["last_name"] = htmlentities($row["last_name"], ENT_QUOTES, 'UTF-8');
				$userArray["user_name"] = htmlentities($row["user_name"], ENT_QUOTES, 'UTF-8');
				$userArray["email"] = htmlentities($row["email"], ENT_QUOTES, 'UTF-8');
							
				$userArray["paypal_email"] = $row["paypal_email"] ;
				$userArray["product_id"] = $row["product_id"] ;
				$userArray["product_name"] = $row["product_name"] ;
				$userArray["product_name"] = htmlentities($row["product_name"], ENT_QUOTES, 'UTF-8');
				
				$userArray["is_recurring"] = $row["is_recurring"] ;
				$userArray["access_start_date"] = $row["access_start_date"];
				$userArray["access_end_date"] = $row["access_end_date"];
				$userArray["transaction_id"] = $row["transaction_id"];
				$userArray["coupon_id"] = $row["coupon_id"];
				$userArray["upj_status"] = $row["upj_status"];
				$userArray["opted_out"] = $row["opted_out"];
				$userArray["status"] = $row["status"];
				$userArray["credits_available"] = $row["credits_available"] ;
				$userArray["login_count"] = $row["login_count"] ;
				$userArray["ipaddress"] = $row["ipaddress"] ;
				$userArray["last_login_date"] = $row["last_login_date"] ;
				$userArray["resource_id"] = $row["resource_id"] ;
				$userArray["tag_name"] = $row["tag_name"] ;
				$userTagArrayList[] = $userArray;
			}
			$stmt = null;
			$dap_dbh = null;
		
			return $userTagArrayList;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function loadBySentEmailStatus(){
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$userTagArrayList = array();
			$sql = "select
						ut.id,
						ut.user_id,
						ut.tag_id,
						ut.type,
						ut.product_id,
						ut.date
					from 
						dap_user_tags ut
					where
						ut.id NOT IN ( select uta.user_tag_id from dap_user_tag_action uta) 
					";
			
			
			$stmt = $dap_dbh->prepare($sql);
			
			$stmt->execute();
			while ($row = $stmt->fetch()) {
				$userTagArray = new Dap_UserTags();

				$userTagArray->setId( $row["id"] );
				$userTagArray->setUserId($row["user_id"]);
				$userTagArray->setTagId($row["tag_id"]);
				$userTagArray->setType($row["type"]);
				$userTagArray->setProductId($row["product_id"]);
				$userTagArray->setLessonId($row["lesson_id"]);
				$userTagArray->setDate($row["date"]);
				$userTagArrayList[] = $userTagArray;
			}
			$stmt = null;
			$dap_dbh = null;
		
			return $userTagArrayList;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function loadByUserIdAndTagIdAndType($tag_id, $user_id, $type, $product_id = 0) {
		
		$LoadList = null; 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$tableName = "dap_user_tags";
			
			$sql = "select * from ".$tableName." where `user_id` = :user_id AND `tag_id` = :tag_id AND `type` = :type AND product_id = :product_id";
			
			$stmt = $dap_dbh->prepare($sql);
 			$stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
 			$stmt->bindParam(':tag_id', $tag_id, PDO::PARAM_INT);
 			$stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
 			$stmt->bindParam(':type', $type, PDO::PARAM_STR);
			
			$stmt->execute();
			
			while ($row = $stmt->fetch()) {
				$data = new Dap_UserTags(); 
				$data->setId( $row["id"] );
				$LoadList = $data;
			}
			
            $stmt = null;
			$dap_dbh = null;
			return $LoadList;
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}			
	}
	
	
	
	public static function delete($tagId, $userId, $tagType){
        
        $tableName = "dap_user_tags";
		$sql = "delete from ".$tableName." where `user_id` =:user_id AND `tag_id` = :tag_id ";
		
		try{		
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':user_id', $userId, PDO::PARAM_INT);
			$stmt->bindParam(':tag_id', $tagId, PDO::PARAM_INT);
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
			return true;
	    } catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
				
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
       	 
	}
	
	public static function deleteByTypeAndUserId($userId, $tagType){
        
        $tableName = "dap_user_tags";
		$sql = "delete from ".$tableName." where `user_id` =:user_id AND `type` = :type ";
		
		try{		
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':user_id', $userId, PDO::PARAM_INT);
			$stmt->bindParam(':type', $tagType, PDO::PARAM_STR);
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
			return true;
	    } catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
				
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
       	 
	}
	
	
	
	public static function deleteById($id){
        
        $tableName = "dap_user_tags";
		$sql = "delete from ".$tableName." where `id` =:id";
		
		try{		
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
			return true;
	    } catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
				
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
       	 
	}	

	public static function deleteBytagId($tagId){
        
        $tableName = "dap_user_tags";
		$sql = "delete from ".$tableName." where `tag_id` =:tag_id";
		
		try{		
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':tag_id', $tagId, PDO::PARAM_INT);
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
			return true;
	    } catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
				
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
       	 
	}
	
}
