<?php

//function to check if user course should be marked as complete or not
function shouldTheUserCourseBeMarkedAsComplete($course_id = 0) {
	   logToFile("function_course.php: shouldTheUserCourseBeMarkedAsComplete(): course_id - ".$course_id, LOG_DEBUG_DAP);		
					
	   $course_complete = '';
	   $session = Dap_Session::getSession();
	   $user = $session->getUser();
	   $user_course_module_details= array();
	   if(isset($user))	{
		   
		   $user_id =  $user->getId();
		   $productobj = Dap_Product::loadProduct($course_id);
		   if(isset($productobj)){
			   
				$course_name = $productobj->getName();	
				$skip_module_info = $productobj->getSkipModule();
				$course_progress = $productobj->getCourseProgress();
				$product_structure = $productobj->getProductStructure();
				
				$skip_module_action = '';
				$skip_module_ids = array();
				$skip_module_info_array = explode("||", $skip_module_info);
				
				if( isset($skip_module_info_array[0]) ){
					$skip_module_action = $skip_module_info_array[0];
				}
				
				if(isset($skip_module_info_array[1])){
					$skip_module_ids = $skip_module_info_array[1];
				}
				
				$user_course_module_details = DAPGetUserCourseOutlineDetailsArray($user_id, $course_id, $course_progress, $skip_module_info);
				
				if($course_progress == 'notallow'){
					if($user_course_module_details['all_module_completed'] == 'yes'){
						$course_complete = "yes" ;
					}
				}else if($course_progress == 'skipmodule'){
					
					if(($skip_module_action == 3) && ($user_course_module_details['all_module_completed'] == 'yes')){
						$course_complete = "yes" ;
					}else if(($skip_module_action == 4) && (count($user_course_module_details['completed_module']) > 0 )){
						$course_complete = "yes" ;
					}
					
				}else if($course_progress == 'skipselectedmodule'){
					
					if(($skip_module_action == 3) && ($user_course_module_details['all_module_completed'] == 'yes')){
						$course_complete = "yes" ;
					}else if(($skip_module_action == 4) && (count($user_course_module_details['completed_module']) > 0 )){
						
						if(count(array_intersect($user_course_module_details['skip_module_ids'], $user_course_module_details['completed_module'])) == count($user_course_module_details['skip_module_ids'])){
							$course_complete = "yes" ;
						}		
					}
					
				}else if($course_progress == 'allow'){
					
					if($user_course_module_details['all_module_completed'] == 'yes'){
						$course_complete = "yes" ;
					}
						  
				}
			}
	  }	
	  return array("course_complete"=>$course_complete,"user_course_module_details" => $user_course_module_details);
}

// Get course module details of user 
function DAPGetUserCourseOutlineDetailsArray($user_id = 0, $course_id = 0, $course_progress = '', $skip_module_info = 0){
	
	$details = array();
	$details['user_id'] = $user_id;
	$details['course_id'] = $course_id;
	$details['skip_module_ids'] = array();
	$details['course_progress'] = $course_progress;
	$details['module_data'] = array();
	$details['completed_module'] = array();
	$details['completed_lesson'] = array();
	$details['all_lesson'] = array();
	$details['all_module'] = array();	
	$details['in_progress_module'] = array();
	$details['all_module_completed'] = 'no';

	$skip_module_action = '';
	$skip_module_ids = array();
	$skip_module_info_array = explode("||", $skip_module_info);
	
	if( isset($skip_module_info_array[0]) ){	
		$skip_module_action = $skip_module_info_array[0];
		$details['skip_module_action'] = $skip_module_action;
	}
	
	if(isset($skip_module_info_array[1])){	
		$skip_module_ids = $skip_module_info_array[1];
		$details['skip_module_ids'] = explode(",", $skip_module_ids);;
	}
	
	//set all modules list of course
	$moduledata = DAP_CourseModule::loadByCourseId($course_id);
	
	//set in progress module and completed lesson info 
	if( isset($moduledata) ) {
		
		foreach($moduledata as $mod){		
			$module_id = $mod->getId();
			$lessons_list = DAP_UserCourseProgress::lessonDetailsByCourseIdModuleIduserId($course_id , $module_id , $user_id );	
			if(is_array($lessons_list) && count($lessons_list)){			
				foreach($lessons_list as $lesson_id){
					$details['in_progress_module'][$module_id][] = $lesson_id;				
					$details['completed_lesson'][] = $lesson_id; 
				}
		    }
	   }
   }
	
   if( isset($moduledata) ) {
        $module_i = 0; 
		foreach($moduledata as $mod){
			
			 $module_id = $mod->getId();
			 $details['module_data'][$module_i]['id'] =  $module_id;
			 $details['module_data'][$module_i]['name'] =  $mod->getModuleName();
			 $details['module_data'][$module_i]['description'] =  $mod->getModuleDesc();
			 $details['all_module'][] = $module_id;
			 //set all lesson list of module
			  $lessons_urls  =  Dap_Product::displayFileResourcesWithModuleIdCourseId($course_id, $mod->getId(), "N");
			  $details['module_data'][$module_i]['lesson'] =  array();
			  
			  if(is_array($lessons_urls) && count($lessons_urls)){
				  $lesson_i = 0; 
				  $lesson_first_index = 0;
				  foreach($lessons_urls as $lesson_urls){
					  
					  $lesson_enable = 0;
					  $lesson_completed = 0;
					  $lesson_id = $lesson_urls['id'];
					  
					  
					  if(in_array($lesson_id,$details['completed_lesson'])){
						  $lesson_completed = 1;
						  $lesson_first_index++;
						  $lesson_enable = 1;
					  }
				
					  if($course_progress == 'notallow'){
						  if($lesson_i == $lesson_first_index){
							$lesson_enable = 1;
						  }
					  }else if($course_progress == 'skipmodule'){
						  if($lesson_i == $lesson_first_index){
							$lesson_enable = 1;
						  }
					  }else if($course_progress == 'skipselectedmodule'){			  
						  $lesson_enable = 1;
						  if(in_array($module_id,$details['skip_module_ids'])){
							  $lesson_enable = 0;
							  if( $lesson_i == $lesson_first_index ){
								$lesson_enable = 1;
							   }
						  }
					  }else if($course_progress == 'allow'){		  
						  $lesson_enable = 1;
					  }
					  
					  $lesson_urls['lesson_link_enable'] = $lesson_enable;
					  $lesson_urls['lesson_completed'] = $lesson_completed;
					  $details['module_data'][$module_i]['lesson'][] = $lesson_urls;
					  $details['all_lesson'][] = $lesson_id;
					  $lesson_i++;
				  }
			  }			  
			 $module_i++; 
	   }
	}
	
	
	foreach($details['module_data'] as $module_info){	
		$module_id = $module_info['id'];
		// set completed module info
		if(isset($details['in_progress_module'][$module_id]) && (count($details['in_progress_module'][$module_id]) == count($module_info['lesson']))){
			unset($details['in_progress_module'][$module_id]);
			$details['completed_module'][] = $module_id;
		}
	}
	
	if(count($details['module_data']) == count($details['completed_module'])){
		$details['all_module_completed'] = 'yes';
	}	
	
	return $details;
}


//function to check if course should be marked as complete or not
function shouldTheCourseBeMarkedAsComplete($course_progress, $skip_module, $userId, $course_id ) {
	$course_complete = "" ;
	$nonSkippableModuleArr ="1,2,3";
	if($course_progress =="skipmodule"){	
		$course_complete = hasUserCompletedAllRequiredModule( $nonSkippableModuleArr , $skip_module, $userId, $course_id  );
	}else if($course_progress =="skipselectedmodule"){
		$course_complete = hasUserCompletedAllRequiredModule( $nonSkippableModuleArr , $skip_module , $userId, $course_id );
	}else{
		$course_complete = "yes" ;
	}
	return $course_complete;
}

//function to check if user has completed all required module
function hasUserCompletedAllRequiredModule( $nonSkippableModuleArr, $skip_module, $userId, $course_id  ) {
	$has_completed="";
	foreach($nonSkippableModuleArr as $module_id) {
		$has_completed= hasUserCompletedThisModule($module_id, $skip_module, $userId, $course_id );
	}
	return $has_completed;
}

//function to check if user has completed this module
function hasUserCompletedThisModule($module_id, $skip_module, $userId, $course_id ) {
	$module_completed="";
	if(isset($module_id)){
		$lessonurls  =  Dap_Product::displayFileResourcesWithModuleIdCourseId($course_id, $module_id);	
		$lessonurlcount = count($lessonurls);			
		$lessoncount = DAP_UserCourseProgress::lessonCountByCourseIdModuleIduserId($course_id , $module_id , $userId );		

		if($lessoncount >= $lessonurlcount)	{	
			//send module completed	 email to user	
			$module_completed = "yes";
		}	
	}
	return $module_completed;
}

//get users data
function dapManageCoursesReport(){
	$dap_cdata = Dap_Product::loadProductByProductType("y");
	
	$html ='<table class="table cell-border" id="dap_manage_course_report">
				<thead>
					<tr class="report_cid_head">
						<th class="cr_name">Course Name</th>
						<th class="cr_enrolled"  >Enrolled</th>
						<th class="cr_notstarted" >Not Started</th>
						<th class="cr_inprogress">In-Progress</th>
						<th class="cr_completed">Completed</th>
						<th class="cr_avg_time_spent">Avg Time Spent</th>											 
					</tr> 
				</thead>
				<tbody>';
				
		
	if(isset($dap_cdata)){
		
		$dap_cdata = array_reverse($dap_cdata);
	
		foreach($dap_cdata as $data){
			$cId = $data->getId();
			 
			$cName = $data->getName();
			$enrolled = Dap_User::getUserCountForEnrolledCourses($cId);
			$notstarted = Dap_User::getUserCountForNotStartedCourses($cId);
			
			$completed = getCourseStatusReport($cId,$product_structure,"completed");
			$inprogress = getCourseStatusReport($cId,$product_structure,"inprogress");
			if($completed >0){
				$completed_data =  '<a class=" completed_view course_report_btn" data-course-id="'.$cId.'" data-type="completed" data-type-name="Completed"  data-course-name="'.$cName.'" >'.$completed.'</a>';
			}else{
				$completed_data = $completed;
			}
			if($inprogress >0){
				$inprogress_data = '<a class="inprogress_view course_report_btn" data-course-id="'.$cId.'" data-type="inprogress" data-type-name="In-Progress"  data-course-name="'.$cName.'" >'.$inprogress.'</a>';
			}else{
				$inprogress_data = $inprogress;
			}
			
			$product_structure = $data->getProductStructure();
			$html .='<tr class="report_cid'.$cId.'"> 
						<td class="cr_name text-left">'.$cName.'</td>
						<td class="cr_enrolled"  >'.$enrolled.'<a class="enrolled_view course_report_btn" data-course-id="'.$cId.'" data-type="enrolled" style="display:none" >View</a></td>
						<td class="cr_notstarted"  >'.$notstarted.'<a class="notstarted_view course_report_btn" data-course-id="'.$cId.'" data-type="notstarted"  style="display:none">View</a></td>
						<td class="cr_inprogress">'.$inprogress_data.'</td>
						<td class="cr_completed">'.$completed_data.'</td>
						<td class="cr_avg_time_spent">'.getCourseStatusReport($cId,$product_structure,"avg_time_spent").'</td>
						
					</tr> ';
								 
		}
	}else{
		$html .='<tr class="report_cid">
					<td class="no_data">No data found</td>					 
				</tr> ';
	}
	$html .='</tbody></table>';
	
	return $html ;
	
}


//function to get the report status
function getCourseStatusReport($course_id, $product_structure, $type){
	
	$hascompleted = 0;	
	$hasinprogress = 0;	
	$hasenrolled = 0;	
	$notstarted = 0;	
	$get_total_time= 0;
	
	//$user_array = Dap_User::getAllUsershasAccessTo($course_id);
	$user_array = Dap_User::getUserArrayForCompletedAndInProgress($course_id);
 
	if(isset($user_array)){
		//user loop				
		foreach($user_array as $user){
			$userId = $user['id'];
			 $get_course_status= getCourseStatusReportByUserId($course_id, $userId);
			//lesson loop	
			/*if($product_structure == "lesson"){		
					$product_obj_var = new Dap_Product();				
					$lessonurls  = $product_obj_var->displayFileResourcesWithCourseId($course_id);
					$dap_course_obj_var = new DAP_UserCourseProgress();
					$lessoncount = $dap_course_obj_var->lessonCountByCourseIduserId($course_id , $userId );	
					 
				
			}else{ //module  	
				$moduledata = DAP_CourseModule::loadByCourseId($course_id) ;	
				if(isset($moduledata)) {							 
					$lessonurls = array();
						
					// module loop					
					foreach($moduledata as $mod){		
						 $product_obj_var = new Dap_Product();								
						 $lessonurls[]  =  $product_obj_var->displayFileResourcesWithModuleIdCourseId($course_id, $mod->getId());
						 $user_course_obj_var = new DAP_UserCourseProgress();		
						 $lessoncount += $user_course_obj_var->lessonCountByCourseIdModuleIduserId($course_id , $mod->getId(), $userId );				 							
					}							
						
			
					if(count($lessonurls)){
						$lessonurls_new = array();
						foreach($lessonurls as $lessonurl){
							foreach($lessonurl as $lessonurl_single){
								$lessonurls_new[] = $lessonurl_single;										 
							}
						}								
						$lessonurls = $lessonurls_new;								
					}	
					 
				}
			}				

			$lessonurlcount1 = count($lessonurls);
			if($lessoncount ==""){
				$lessoncount =0;
			}
			*/
			 
			//if($lessoncount >0){	
			if(isset($get_course_status['output'])){
				
				if($get_course_status['output'] == 'completed'){
					$hascompleted++;
				}else if($get_course_status['output'] == 'inprogress'){
					$hasinprogress++;
				}
			}				 
				/*if($lessoncount == $lessonurlcount1 || $lessonurlcount1 < $lessoncount ){	//completed		
					$hascompleted++;
				} else{	//in-progress	
					$hasinprogress++;
				}	*/			
			//} 
			
			//get the total avgtime
			//$get_total_time=0;
			$get_total_time = DAP_UserCourseProgress::getTotalTimeSpentForCourses($course_id) ;
			 
			
		}//end user foreach
	}
 	
	if($type == "avg_time_spent"){
		if($get_total_time>0){
			$get_total_time= secTohms($get_total_time);
		} 
		return $get_total_time;
	}
	if($type == "completed"){
		return $hascompleted;
	}
	if($type == "inprogress"){
		return $hasinprogress;
	} 
	/*if($type == "notstarted"){
		return $notstarted;
	}
	if($type == "enrolled"){	 
		return count($user_array);
	}*/
}

function secTohms($secs) {
   $secs = round($secs);
   $secs = abs($secs);
   $hours = floor($secs / 3600) . 'h ';    
   $minutes = substr('00' . floor(($secs / 60) % 60), -2) . 'm ';
   $seconds = substr('00' . $secs % 60, -2).'s';
  return $hours . $minutes . $seconds ;
}


function getCourseStatusReportByUserId($course_id = 0, $userId = 0){
	
	$output = array();
	$productobj = Dap_Product::loadProduct($course_id);
	if(isset($productobj)){	  
		$product_structure = $productobj->getProductStructure();
		//lesson loop	
		$unit_url_list_id_array = array();
		$lessonurls = array();
		$user_lessons = array();
		if($product_structure == "lesson"){		
				$product_obj_var = new Dap_Product();				
				$lessonurls	  = $product_obj_var->displayFileResourcesWithCourseId($course_id);
				
				$dap_course_obj_var = new DAP_UserCourseProgress();
				$user_lessons = $dap_course_obj_var->lessonReturnUnitIdsByCourseIduserId($course_id , $userId );	 
				
		}else{
			$moduledata = DAP_CourseModule::loadByCourseId($course_id);
		
			if(isset($moduledata)) {							 
				$lessonurls = array();
					
				// module loop					
				foreach($moduledata as $mod){		
					 $product_obj_var = new Dap_Product();								
					 $lessonurls_module  =  $product_obj_var->displayFileResourcesWithModuleIdCourseId($course_id, $mod->getId());
					 $lessonurls = array_merge($lessonurls,$lessonurls_module);
					 $user_course_obj_var = new DAP_UserCourseProgress();		
					 $user_lessons_new = $user_course_obj_var->lessonReturnUnitIdsByCourseIdModuleIduserId($course_id , $mod->getId(), $userId );		
					 if(isset($user_lessons_new)){
						$user_lessons = array_merge($user_lessons,$user_lessons_new);
					 }
					 		 							
				}									 
			}
		}		

		if(isset($lessonurls) && is_array($lessonurls)) {							 
			foreach($lessonurls as $lessonurl){
				$unit_url_list[]  = $lessonurl['url'];	
				$unit_url_list_id_array[] =	$lessonurl['id'];					 					 
			}						  
		}	
		
		$user_lesson_completed_ids = array();
		if(is_array($lessonurls) && count($lessonurls) && isset($user_lessons)){
			foreach($user_lessons as $user_lesson){
				
				$user_lesson_completed_ids[] = $user_lesson['unit_id'];
			}
		
			$user_completed_all_lesson = array_diff($unit_url_list_id_array,$user_lesson_completed_ids);
			
			if(count($user_completed_all_lesson) == 0){
				$output["output"] = "completed";
			}else{
				$output["output"] = "inprogress";
			}
		}else{
			$output["output"] = "enrolled";
		}

	}else{
		$output['output'] = 'product_deleted';
	}
	
	return $output;
}
