<?php

//require_once('/dap/inc/tp/aweber_api/aweber_api.php');
class aweber{

   
	//======== USER REGISTRATION ========
	function register($userId, $productId, $params)
	{
		
		$lldocroot = defined('SITEROOT') ? SITEROOT : $_SERVER['DOCUMENT_ROOT'];
		require_once($lldocroot . '/dap/inc/tp/aweber_api/aweber_api.php');
		
		$dapver=floatval(DAP_VERSION);
		if($dapver<4.7) {
			logToFile("aweber.class.php: ADD NOT SUPPORTED", LOG_DEBUG_DAP);	
			return;
		}

		//logToFile("aweber.class.php: $action(): user_id = $userId", LOG_DEBUG_DAP);
		try {
			$dapuser = Dap_User::loadUserById($userId);
			//logToFile("aweber.class.php: $action(): Dap_User::loadUserById() was ok", LOG_INFO_DAP);
			
			if(!isset($dapuser)){
				return;
			}
			
			$address1 = trim($dapuser->getAddress1());
			$address2 = trim($dapuser->getAddress2());
			$city = trim($dapuser->getCity());
			$state = trim($dapuser->getState());
			$zip = trim($dapuser->getZip());
			$country = trim($dapuser->getCountry());
			
			$phone = trim($dapuser->getPhone());
			$company = trim($dapuser->getCompany());
			$client_ip = getIpOfUser(); //required
			
			$lastname = $dapuser->getLast_name();
			if($lastname!="")
				$name = $dapuser->getFirst_name() . " " . $dapuser->getLast_name();
			else
				$name = $dapuser->getFirst_name();
				
			logToFile("aweber.class.php:register(),params are,".$params, LOG_DEBUG_DAP);	
			$data=explode(":",$params);$consumerKey=Dap_Config::get('AWEBER_CONSUMER_KEY');$consumerSecret=Dap_Config::get('AWEBER_CONSUMER_SECR');$accessKey=Dap_Config::get('AWEBER_ACCESS_KEY');$accessSecret=Dap_Config::get('AWEBER_ACCESS_SECRET');if($consumerKey==""||$consumerSecret==""||$accessKey==""||$accessSecret==""){logToFile("aweber.class.php: One of the CK,CS,AK or AS is missing",LOG_DEBUG_DAP);return true;}

			$list_name        = $data[1]; # put the List ID here
	  		if(!isset($list_name)) {
				logToFile("aweber.class.php: missing list name in the plugin notification list - (format: aweber:list_id)", LOG_DEBUG_DAP);	
				/* return; */
			}
			
			//logToFile("aweber.class.php: $action(): list_id=".$list_id, LOG_INFO_DAP);
			
			$email = $dapuser->getEmail();
			try{
				$aweber = new AWeberAPI($consumerKey, $consumerSecret);
				$account = $aweber->getAccount($accessKey, $accessSecret);
			}
			catch(AWeberAPIException $e){
				logToFile("aweber.class.php: aweber account exceptiion ".$e->getMessage(), LOG_INFO_DAP);
				return;
			}
			

				
			if(!isset($account)) {
				logToFile("aweber.class.php: could not find aweber account using the current database credentials", LOG_DEBUG_DAP);	
				 return; 
			}
			
			$account_id = $account->id;
			logToFile("aweber.class.php: $action(): got aweber account details: account_id=".$account_id, LOG_INFO_DAP);
			
			logToFile("aweber.class.php:aweber list id  =".$data[1], LOG_INFO_DAP);

			$list_id = "";
			
			if($data[4] == "Y"){ // this means that this is automation
				logToFile("aweber.class.php: We are coming from automation, so get list id from string", LOG_INFO_DAP);
				$list_id=$data[1];
			}
			else{   // this is coming from plugin notifications
				logToFile("aweber.class.php: We are coming from plugin notifications ,so get list id from unique_list_id ", LOG_INFO_DAP);
				$foundLists = $account->lists->find( array( 'id' => $data[1] ) );
				if(!isset($foundLists)) {
					logToFile("aweber.class.php: no such list found (list_name = ".$list_name . ").", LOG_DEBUG_DAP);	
					/* return; */
				}
				else{
					foreach($foundLists As $key){
						if($key->unique_list_id == $data[1]){ // we are doing this because right now we are getting all lists.
							$list_id = $key->id;
							break;
						}
					}
				}
				
			}

  		//	$list = $foundLists[0]; 
  		//	$list_id=$list->id;
			//$list_id=$data[1];
			
			logToFile("aweber.class.php: $action(): got list details: list_id=".$list_id, LOG_INFO_DAP);
			$subscribers = $account->loadFromUrl("/accounts/$account_id/lists/$list_id/subscribers");
	
			logToFile("aweber.class.php: loaded from url", LOG_INFO_DAP);
			
			/*
			$params = array('email' => $email);
			
			$subscribers = $list->subscribers;
			logToFile("aweber.class.php: get subscribers", LOG_INFO_DAP);		
			if(isset($subscribers)) {
			  $found_subscribers = $subscribers->find($params);
			  if(isset( $found_subscribers )) {
			  foreach($found_subscribers as $subscriber) {
				  logToFile("aweber.class.php: subscribed = " . $email . " already on the list : " . $list_name, LOG_INFO_DAP);	
				  return;
				  //echo $subscriber->email . "\n";
			  }
			  }
			  else {
				   logToFile("aweber.class.php: subscriber not found", LOG_INFO_DAP);	
			  }
			}
			else {
				 logToFile("aweber.class.php: subscriber list empty", LOG_INFO_DAP);		
			}
			*/
			if(isset($data[2])) {			
			  $sendPassword=$data[2];
			  $pwd=$dapuser->getPassword();
			}
			logToFile("aweber.class.php: param for password : " . $sendPassword, LOG_DEBUG_DAP);	
			if( ($sendPassword == "yes" || $sendPassword == "sendpassword") && $pwd != "") {
				  # create a subscriber
				  logToFile("aweber.class.php: send password to aweber", LOG_DEBUG_DAP);	
				  $params = array(
					'email' => $email,
					'name' => $name,
					'ip_address' => $client_ip,
					'custom_fields' => array('Password' => $pwd,),
				  );
			  
			}
			else {
				# create a subscriber
				$params = array(
				  'email' => $email,
				  'name' => $name,
				  'ip_address' => $client_ip
				);
			}
			
			if(isset($data[3])) {			
				$tags = $data[3];
			}
			if($tags != ""){
				logToFile("aweber.class.php: Tags are present so update the user with tags" , LOG_DEBUG_DAP);	
				$tags = explode(",",$tags);
				$params['tags'] = $tags;
				logToFile("aweber.class.php: Tags are present so update the user with tags" , LOG_DEBUG_DAP);	
			}
			//logToFile("aweber.class.php: call create subscriber()", LOG_DEBUG_DAP);
			
			$new_subscriber = $subscribers->create($params);
			//logToFile("aweber.class.php: called aweber create", LOG_DEBUG_DAP);
			
			# success!
			$msg ="A new subscriber ($email) was added to the $list_id list!";
			logToFile("aweber.class.php: success! " . $msg, LOG_DEBUG_DAP);		
			
		} catch(AWeberAPIException $e) {
			logToFile("aweber.class.php: exception: " . $e->getMessage(), LOG_DEBUG_DAP);
			try{
				$params = array('email'=>$email);
				$found_subscribers = $account->findSubscribers($params);

				foreach($found_subscribers as $subscriber) {
					logToFile("aweber.class.php: subscriber found : " . $subscriber->email, LOG_DEBUG_DAP); 
					$subscriber=$found_subscribers[0];
					break;
				}
				if(isset($subscriber)){
					$subscriber = $subscriber->loadFromUrl($subscriber->url);/* This is neccasaary to get all the info of user */
					$tags = $data[3];
					if($tags != ""){
						logToFile("aweber.class.php: Tags are present so update the user with tags" , LOG_DEBUG_DAP);
						$tags = explode(",",$tags);
						$subscriber->tags =  array('add' => $tags);
					}
					$subscriber->status = "subscribed";
					$subscriber->save();	
				}	
			}
			catch(Exception $e){
				logToFile("aweber.class.php: Exception: cannot add subscriber: ".$e->getMessage(), LOG_INFO_DAP);
			}		
		} catch (Exception $e) {
			logToFile("aweber.class.php: Exception: cannot add subscriber: ".$e->getMessage(), LOG_INFO_DAP);
		}

	} // function register($userId, $productId, $params)


	function unregister($userId, $productId, $params)
	{
	 
		$lldocroot = defined('SITEROOT') ? SITEROOT : $_SERVER['DOCUMENT_ROOT'];
		require_once($lldocroot . '/dap/inc/tp/aweber_api/aweber_api.php');
		
		logToFile("aweber.class.php: unregister: ENTER", LOG_INFO_DAP);
		$dapver=floatval(DAP_VERSION);
		if($dapver<4.7) {
			logToFile("aweber.class.php: REMOVE NOT SUPPORTED", LOG_DEBUG_DAP);	
			return;
		}
		
		$consumerKey    = Dap_Config::get('AWEBER_CONSUMER_KEY'); # put your credentials here
		$consumerSecret = Dap_Config::get('AWEBER_CONSUMER_SECR'); # put your credentials here
		$accessKey      = Dap_Config::get('AWEBER_ACCESS_KEY'); # put your credentials here
		$accessSecret   = Dap_Config::get('AWEBER_ACCESS_SECRET'); # put your credentials here
	
		try {
			$dapuser = Dap_User::loadUserById($userId);
			if(!isset($dapuser)){
				return;
			}
			$email = $dapuser->getEmail();
			
			logToFile("aweber.class.php: unregister: Dap_User::loadUserById() was ok", LOG_INFO_DAP);
			logToFile("aweber.class.php: unregister: params are ".$params, LOG_INFO_DAP);
			
			$data = explode(":",$params);  
			
			$action=$data[1];
			
			if(isset($data[2]))
				$source_list = $data[2];
			else {
				if($action=="move") {
				logToFile("aweber.class.php: missing listname: FORMAT:  aweber:ACTION:SOURCE_LIST_NAME:DEST_LIST_NAME", LOG_DEBUG_DAP);
				return;	
				}
				else {
					logToFile("aweber.class.php: missing listname: FORMAT:  aweber:ACTION:SOURCE_LIST_NAME", LOG_DEBUG_DAP);
					return;
				}
			}
			
			$aweber = new AWeberAPI($consumerKey, $consumerSecret);
			$account = $aweber->getAccount($accessKey, $accessSecret);
				
			if(!isset($account)) {
				logToFile("aweber.class.php: unregister: could not find aweber account using the current database credentials", LOG_DEBUG_DAP);	
				return;
			}
			
			$account_id = $account->id; 

			if($action=="delete") {
				//delete subscriber from aweber 	 
				logToFile("aweber.class.php: action=delete", LOG_DEBUG_DAP); 
			//	$params = array('email' => $email);
				//$found_subscribers = $account->findSubscribers($params);
				//print_r($account);
				
				logToFile("aweber.class.php: check if tags are prsent and remove from list id is present,remove from list id is ".$data[4] , LOG_DEBUG_DAP);
				if($data[3]!="" && $data[4]!=""){
					try{
						$found_subscribers1 = $account->loadFromUrl('https://api.aweber.com/1.0/accounts/'.$account->id.'/lists/'.$data[4].'/subscribers?ws.op=find&email='.$email);
						$link = $found_subscribers1->data['entries'][0]['self_link']; /* link for that list to remove from */
						logToFile("aweber.class.php: subscriber link is : " . $link, LOG_DEBUG_DAP); 
						if($link != ""){
							$subscriber = $account->loadFromUrl($link);/* This is neccasaary to get all the info of user */	
							logToFile("aweber.class.php: subscriber found : " . $subscriber->email, LOG_DEBUG_DAP); 
							$tags = explode(',',$data[3]);
							if(count($tags)>0){
								logToFile("aweber.class.php: Tags are present so update the user with tags" , LOG_DEBUG_DAP);
								$subscriber->tags =  array('remove' => $tags);
							}	
							$subscriber->save();
							logToFile("aweber.class.php: tags removed for user from aweber : " . $subscriber->email, LOG_DEBUG_DAP); 						
						}
					}
					catch(Exception $e){
						logToFile("aweber.class.php: tags removed error is : " . $e->getMessage(), LOG_DEBUG_DAP);
					}
				}else{
					logToFile("aweber.class.php: either tags or removefromlistid not present" , LOG_DEBUG_DAP);
				}
				
				logToFile("aweber.class.php: check if we have to remove from list" , LOG_DEBUG_DAP);				
				if($data[2]!=""){
					logToFile("aweber.class.php: going to fetch user data for list" , LOG_DEBUG_DAP);			
					try{
						
						if($data[5] == "Y"){ // this means that this is automation
							logToFile("aweber.class.php: unregister(),We are coming from automation, so get list id from string", LOG_INFO_DAP);
							$list_id=$data[2];
						}
						else{   // this is coming from plugin notifications
							logToFile("aweber.class.php: unregister(),We are coming from plugin notifications ,so get list id from unique_list_id ", LOG_INFO_DAP);
							$foundLists = $account->lists->find( array( 'id' => $data[2] ) );
							if(!isset($foundLists)) {
								logToFile("aweber.class.php: no such list found (list_id = ".$data[2] . ").", LOG_DEBUG_DAP);	
								/* return; */
							}
							else{
								foreach($foundLists As $key){
									if($key->unique_list_id == $data[2]){ // we are doing this because right now we are getting all lists.
										$list_id = $key->id;
										break;
									}
								}
							}
							
						}
						logToFile("aweber.class.php: unregister(), remove from list =  $list_id ", LOG_DEBUG_DAP);	
						
						$found_subscribers1 = $account->loadFromUrl('https://api.aweber.com/1.0/accounts/'.$account->id.'/lists/'.$list_id.'/subscribers?ws.op=find&email='.$email);
						$link = $found_subscribers1->data['entries'][0]['self_link']; /* link for that list to remove from */
						if($link != ""){
							$subscriber = $account->loadFromUrl($link);/* This is neccasaary to get all the info of user */	
							logToFile("aweber.class.php: subscriber found : " . $subscriber->email, LOG_DEBUG_DAP); 		
							$subscriber->status = "unsubscribed"; 
							$tags = explode(',',$data[3]);
							if(count($tags)>0){
								logToFile("aweber.class.php: Tags are present so update the user with tags" , LOG_DEBUG_DAP);
								$subscriber->tags =  array('remove' => $tags);
							}
							$subscriber->save();
							logToFile("aweber.class.php: subscriber deleted from aweber : " . $subscriber->email, LOG_DEBUG_DAP); 						
						}
						else{
							logToFile("aweber.class.php: subscriber not found in the list", LOG_DEBUG_DAP);
						}
					}	
					catch(Exception $e){
						logToFile("aweber.class.php: tags removed error is : " . $e->getMessage(), LOG_DEBUG_DAP);
					}
										
				}else{
					logToFile("aweber.class.php: remove list id not set" , LOG_DEBUG_DAP);
				}			

			} /*delete */ 
			else {
				logToFile("aweber.class.php: undefined action - $action", LOG_DEBUG_DAP);
				return;
			}
		
		} catch(AWeberAPIException $exc) {
			logToFile("aweber.class.php: " . $exc->message, LOG_DEBUG_DAP);	
			return "AWeberAPIException: " . $exc->message;
		} catch (Exception $e) {
			logToFile("aweber.class.php: unregister $action: failed with exception: ".$e->getMessage(), LOG_INFO_DAP);
			return;
		}
		
		
	} // function unregister($userId, $productId, $params)
	
}



?>
