<?php

class drip {

	// constructor

	function drip() {

	}

	// ======== USER REGISTRATION / UPDATE / DELETE ========

	function register($userId, $productId, $params) {

		logToFile ( "drip.class.php: register(): calling storeAddress", LOG_INFO_DAP );

		logToFile ( "drip.class.php: register():  format: drip:accountId:apiToken:campaignId:tagIds (tagIds separated by a | delimiter)", LOG_INFO_DAP );

		$this->storeAddress ( $userId, $productId, $params );

	}

	function storeAddress($userId, $productId, $params) {

		//exploding the variable and create an array.

		$params=explode(":",$params);if($params[3]==""&&$params[4]==""){logToFile("drip.class.php: storeAddress(), neither campaignId or tagid is set so return",LOG_INFO_DAP);return;}if(isset($params[1])&&$params[1]!=''){$accountId=$params[1];}if($accountId==""){logToFile("drip.class.php: storeAddress(): missing account Id",LOG_INFO_DAP);return "Missing Account Id";}if(isset($params[2])&&$params[2]!=''){$apiToken=$params[2];}if($apiToken==""){logToFile("drip.class.php: storeAddress(): missing API Token",LOG_INFO_DAP);return "Missing API Token";}if(isset($params[3])&&$params[3]!=''){$campaignId=$params[3];}$justTag=false;if((!(isset($params[3]))||($params[3]==""))&&((isset($params[4]))||($params[4]!=""))){$justTag=true;}if(isset($params[4])&&$params[4]!=''){$tags=$params[4];$tagArr=explode("|",$params[4]);if(strpos($params[4],'|')!==false){$tagArr=explode('|',$params[4]);}else{$tagArr=explode(',',$params[4]);}}

		//Get the user details from DAP by using $userId

		$dapuser = Dap_User::loadUserById ( $userId );

		if(!isset($dapuser)){
			logToFile ( "drip.class.php: storeAddress(): User doesn't exists", LOG_INFO_DAP );

			return "User Not Exist";
		}

		$email = trim ( $dapuser->getEmail () );

		$username = trim ( $dapuser->getUser_name () );

		$firstname = trim ( $dapuser->getFirst_name () );

		$lastname = trim ( $dapuser->getLast_name () );

		$password = $dapuser->getPassword ();

		

		$customfieldlist = Dap_API::loadCustomFieldsForUser ( $dapuser );

		logToFile ( "drip.class.php:lastname: " . $lastname . "", LOG_INFO_DAP );

		logToFile ( "drip.class.php:tags: " . $tags . "", LOG_INFO_DAP );

		

		// check $customfieldlist isset 

		if (isset ( $customfieldlist ) && ($customfieldlist != NULL) && ($customfieldlist != "")) {

			foreach ( $customfieldlist as $key => $val ) {

				// $key is the name of the field and $val is the value of the custom field

				logToFile ( "drip.class.php:key=value: " . $key . "=" . $val, LOG_INFO_DAP );

			}

		}

	

		// End custom field retrieval

		logToFile ( "drip.class.php: storeAddress(): email =" . $email, LOG_INFO_DAP );

		//check that the provided email is valid or not.

		if (! preg_match ( "/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*$/i", $email )) {

			logToFile ( "drip.class.php: storeAddress(): invalid email", LOG_INFO_DAP );

			return "Email address is invalid";

		}

		//create an array of customfields to use during curl call.

		$fields = array (

			'first_name' => urldecode($firstname),

			'last_name' => urldecode($lastname),

			'password' => $password 

		);

		

		if($justTag) {

		  // add subscriber to account

		  $subscriber = array (

			  "account_id" => $accountId, 

			  'email' => $email,

			  'custom_fields' => $fields,

			  'tags' => $tagArr

		  );

		  

		  $postfields = array('subscribers' => array($subscriber));

		  $data_string = json_encode($postfields);



		  logToFile ( "drip.class.php: just add subscriber with a tag", LOG_INFO_DAP );

		  $url = "https://api.getdrip.com/v2/" . $accountId . "/subscribers";

		  

		  logToFile ( "drip.class.php: url :" . $url . "", LOG_INFO_DAP );

		  $result=$this->make_drip_request($url, $apiToken, $data_string);

 		}

		else {

			//add subscriber to campaign

			logToFile ( "drip.class.php: add subscriber to campaign: " . $campaignId, LOG_INFO_DAP );

			if(isset($params[4])) {

				$subscriber = array (

					"account_id" => $accountId, 

					'email' => $email,

					'custom_fields' => $fields,

					'tags' => $tagArr

				);

			}

			else {

				$subscriber = array (

					"account_id" => $accountId, 

					'email' => $email,

					'custom_fields' => $fields

				); 

			}

		   

			$postfields = array('subscribers' => array($subscriber));

			$data_string = json_encode($postfields);

  

			$url = "https://api.getdrip.com/v2/" . $accountId . "/campaigns/".$campaignId."/subscribers";

			$result=$this->make_drip_request($url, $apiToken, $data_string);

	

	    }

		

	 	logToFile ( "drip.class.php: storeAddress(): result =" . $result . "", LOG_INFO_DAP );

		return $result;

	}

	

	

	function unregister($userId, $productId, $params) {

		logToFile ( "drip.class.php: unregister(): calling removeAddress", LOG_INFO_DAP );

		logToFile ( "drip.class.php: unregister(): format:  drip:accountId:apiToken:campaignId:tagIds (tagIds separated by a | delimiter)", LOG_INFO_DAP );

		$this->removeAddress ( $userId, $productId, $params );

	}

	

	

	function removeAddress($userId, $productId, $params) {

		//exploding the variable and create an array.

		$params = explode ( ":", $params );

		

		if($params[3] == "" && $params[4] == ""){

			logToFile ( "drip.class.php: removeAddress(), neither campaignId or tagid is set so return", LOG_INFO_DAP );

			return;

		}

		//check that $params[1] isset - accountId

		if (isset ( $params[1] ) && $params[1] != '') {

			//create an array if account id is present..

			$accountId = $params[1];

		}

		

		if ($accountId=="") {

			logToFile ( "drip.class.php: storeAddress(): missing account Id", LOG_INFO_DAP );

			return "Missing Account Id";

		}

		

		//check that $params[2] isset - apiToken

		if (isset ( $params[2] ) && $params[2] != '') {

			$apiToken = $params[2];

		}

		

		if ($apiToken=="") {

			logToFile ( "drip.class.php: storeAddress(): missing API Token", LOG_INFO_DAP );

			return "Missing API Token";

		}

		

		//check that $params[3] isset - campaignId

		if (isset ( $params[3] ) && $params[3] != '') {

			$campaignId = $params[3];

		}

		

		$justTag=false;

		if( (!(isset ( $params[3] )) || ($params[3]=="") )  && ((isset($params[4])) || ($params[4]!="")  ) ) {

			$justTag=true;	

		}

		

		//check that $params[4] isset

		if (isset ( $params[4] ) && $params[4] != '') {

			$tags = $params[4];

		  	if (strpos($params[4], '|') !== false) {

				$tagArr = explode('|',$params[4]);

			}

			else{

				$tagArr = explode(',',$params[4]);

			}

		}

		

		//Get the user details from DAP by using $userId

		$dapuser = Dap_User::loadUserById ( $userId );

		

		if(!isset($dapuser)){

			return;

		}

		

		$email = trim ( $dapuser->getEmail () );

		$username = trim ( $dapuser->getUser_name () );

		$firstname = trim ( $dapuser->getFirst_name () );

		$lastname = trim ( $dapuser->getLast_name () );

		$password = $dapuser->getPassword();

		

		$customfieldlist = Dap_API::loadCustomFieldsForUser ( $dapuser );

		logToFile ( "drip.class.php:lastname: " . $lastname . "", LOG_INFO_DAP );

		logToFile ( "drip.class.php:tags: " . $tags . "", LOG_INFO_DAP );

		

		// check $customfieldlist isset 

		if (isset ( $customfieldlist ) && ($customfieldlist != NULL) && ($customfieldlist != "")) {

			foreach ( $customfieldlist as $key => $val ) {

				// $key is the name of the field and $val is the value of the custom field

				logToFile ( "drip.class.php:key=value: " . $key . "=" . $val, LOG_INFO_DAP );

			}

		}

	

		// End custom field retrieval

		logToFile ( "drip.class.php: storeAddress(): email =" . $email, LOG_INFO_DAP );

		//check that the provided email is valid or not.

		if (! preg_match ( "/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*$/i", $email )) {

			logToFile ( "drip.class.php: storeAddress(): invalid email", LOG_INFO_DAP );

			return "Email address is invalid";

		}

		//create an array of customfields to use during curl call.

		$fields = array (

			'first_name' => $firstname,

			'last_name' => $lastname,

			'Password' => $password 

		);

		

		

		if($tagArr!="") {

			try{

				// add subscriber to account

				$subscriber = array (

					"account_id" => $accountId, 

					'email' => $email,

					'custom_fields' => $fields,

					'tags' => $tagArr

				);

				$postfields = array('subscribers' => array($subscriber));

				$data_string = json_encode($postfields); /* This is done because if the tag has spaces then the URL was malformed */

		

				logToFile ( "drip.class.php: delete subscriber tag", LOG_INFO_DAP );

				foreach ( $tagArr as $tagId ) {

					logToFile ( "drip.class.php: remove tagId :" . $tagId . "", LOG_INFO_DAP );

					$tagId = urlencode($tagId);

					$url = "https://api.getdrip.com/v2/" . $accountId . "/subscribers/".$email."/tags/".$tagId;

					logToFile ( "drip.class.php: delete subscriber url ".$url, LOG_INFO_DAP );

					$result=$this->make_drip_request($url, $apiToken, $data_string, "DELETE");

				}	

			}

			catch(Exception $e){

				logToFile("drip.class.php: drip tag remove error is ".$e->getMessage(), LOG_INFO_DAP);

			}

 		}

		

		if($campaignId != "") {

			try{

				$apiparams = array (

					'campaign_id' => $campaignId  

					);

		  

				$data_string = json_encode($apiparams);

				$url = "https://api.getdrip.com/v2/" . $accountId . "/subscribers/".$email."/remove?campaign_id=".$campaignId;

				logToFile ( "drip.class.php: url :" . $url . "", LOG_INFO_DAP );

				$result=$this->make_drip_request($url, $apiToken, $data_string, "POST");

			}

			catch(Exception $e){

				logToFile("drip.class.php: drip remove campaign error is ".$e->getMessage(), LOG_INFO_DAP);

			}

		  //create an array of fields to use during curl call if $tags are there.

		}

		

		logToFile ( "drip.class.php: removeAddress(): result =" . $result . "", LOG_INFO_DAP );

		

		return $result;

	}

	

	function make_drip_request($url, $apiToken, $data_string, $action="POST") {

		 $curl = curl_init ( $url );

		 if ($curl) {

			  curl_setopt($curl, CURLOPT_FRESH_CONNECT, true);

			  curl_setopt($curl, CURLOPT_FORBID_REUSE, true);

			  curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

			  curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);

			  curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);

			  curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);

			  curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 30 );

			  curl_setopt($curl, CURLOPT_TIMEOUT, 30 );

			  curl_setopt($curl, CURLOPT_USERPWD, "$apiToken:");

			  curl_setopt($curl, CURLOPT_USERAGENT, 'DAP-DRIP' );	

			  curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);

			  curl_setopt($curl, CURLOPT_CUSTOMREQUEST, $action);

			  curl_setopt($curl, CURLOPT_POSTFIELDS, $data_string);

			  curl_setopt($curl, CURLOPT_HEADER, TRUE);

			  

			  curl_setopt($curl, CURLOPT_URL,$url);

			  curl_setopt($curl, CURLOPT_HTTPHEADER, array(

				 'Accept:application/json, text/javascript, */*; q=0.01',

				 'Content-Type: application/vnd.api+json',

			  ));

		  

			  $response = curl_exec ( $curl );

			/*  print_r($response); */

			  if (curl_errno ( $curl ) > 0) {

				  $error=curl_error ( $curl );

				  curl_close ( $curl );

				  return "Error: " . $error;

			  } else {

				  $success_msg=curl_getinfo( $curl, CURLINFO_HTTP_CODE );

				  curl_close ( $curl );

				  return "Response HTTP-CODE: " . $success_msg;

			  }

		    

		} //if

	} ///make_drip_request

	

	

}

