<?php 
class mailchimp {
	function mailchimp(){ } // constructor
	
	function register($userId, $productId, $params){
		logToFile("mailchimp.class.php: register(): calling storeAddress", LOG_DEBUG_DAP);
		$this->storeAddress($userId, $productId, $params);
	}
	
	function storeAddress($userId, $productId, $params){
		$dapuser = Dap_User::loadUserById($userId);
		if(!isset($dapuser)){
			logToFile("mailchimp.class.php: register(): user not found in dap, so return", LOG_DEBUG_DAP);
			return;
		}
		$email = trim($dapuser->getEmail());
		$username = trim($dapuser->getUser_name());
		$firstname = trim($dapuser->getFirst_name());
		$lastname = trim($dapuser->getLast_name());
		$password = $dapuser->getPassword();
		
		$data=explode(":",$params);logToFile("mailchimp.class.php: storeAddress(): email =".$email,LOG_DEBUG_DAP);$api_key=$data[1];if($api_key==""){logToFile("mailchimp.class.php: register(): missing mailchimp API key, so return",LOG_DEBUG_DAP);return;}$list_id=$data[2];logToFile("mailchimp.class.php: storeAddress(): list_id =".$list_id,LOG_DEBUG_DAP);$memberId=md5(strtolower($email));$dataCenter=substr($api_key,strpos($api_key,'-')+1);$url='https://'.$dataCenter.'.api.mailchimp.com/3.0/lists/'.$list_id.'/members/'.$memberId;

		$json = json_encode([
			'email_address' => $email,
			'status'        => "subscribed", // "subscribed","unsubscribed","cleaned","pending"
			'merge_fields'  => [
				'FNAME'     => $firstname,
				'LNAME'     => $lastname,
				'PASSWORD'  => $password
			]
		]);

		$ch = curl_init($url);

		curl_setopt($ch, CURLOPT_USERPWD, 'user:' . $api_key);
		curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_TIMEOUT, 10);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
		
		$result = curl_exec($ch);
		$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		curl_close($ch);
		if($httpCode == "200"){
			logToFile("mailchimp.class.php: register(): Subscribed to list successfully", LOG_DEBUG_DAP);
		}
		else{
			$result1 = json_decode($result);
			logToFile("mailchimp.class.php: register(): List subscribe failed because ".$result1->detail, LOG_DEBUG_DAP);
			// if it says user already there, { } 
			//else return;
			return;
		}
		

    //TAGS
	
	$tag_name_text = $data[3];
	if($tag_name_text != "") {
		
		$dataCenter = substr($api_key,strpos($api_key,'-')+1);
		
		$url = 'https://' . $dataCenter . '.api.mailchimp.com/3.0/lists/' . $list_id . '/segments/';
		$ch = curl_init($url);

		curl_setopt($ch, CURLOPT_USERPWD, 'user:' . $api_key);
		curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_TIMEOUT, 10);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $json);    
		
		$result = curl_exec($ch);
		$result1 = json_decode($result);
		$result1 = (array)$result1->segments;
		$createTag = true;
		if(is_array($result1)){
			foreach($result1 as $data){
				if($data->name == $tag_name_text ){
					$createTag = false;	
					$segmentId = $data->id;
				}
			}
		}
			if($createTag){
				$json = json_encode(array(
					'name' => $tag_name_text,
					'static_segment' => []
				));

				
				$ch = curl_init($url);

				curl_setopt($ch, CURLOPT_USERPWD, 'user:' . $api_key);
				curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($ch, CURLOPT_TIMEOUT, 10);
				curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $json);    
				
				$result = curl_exec($ch);
				$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

				curl_close($ch);
				
				if($httpCode == "200" ){
					$result1 = json_decode($result);
					$id = $result1->id;
					$json = json_encode(array(
						'email_address' => $email,
					));
					
					$url = 'https://' . $dataCenter . '.api.mailchimp.com/3.0/lists/' . $list_id . '/segments/'.$id.'/members' ;
					$ch = curl_init($url);

					curl_setopt($ch, CURLOPT_USERPWD, 'user:' . $api_key);
					curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					curl_setopt($ch, CURLOPT_TIMEOUT, 10);
					curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
					curl_setopt($ch, CURLOPT_POSTFIELDS, $json);    
					
					$result = curl_exec($ch);
					$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
				
					curl_close($ch);
					
					logToFile("mailchimp.class.php: register(): add $tag_name_text to list successfully", LOG_DEBUG_DAP);
				}
				else{
					$result1 = json_decode($result);
					logToFile("mailchimp.class.php: register(): List subscribe failed because ".$result1->detail, LOG_DEBUG_DAP);
				}
			}else if($segmentId != 0 && $segmentId != ''){
				$json = json_encode(array(
						'email_address' => $email,
					));
					
					$url = 'https://' . $dataCenter . '.api.mailchimp.com/3.0/lists/' . $list_id . '/segments/'.$segmentId.'/members' ;
					$ch = curl_init($url);

					curl_setopt($ch, CURLOPT_USERPWD, 'user:' . $api_key);
					curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					curl_setopt($ch, CURLOPT_TIMEOUT, 10);
					curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
					curl_setopt($ch, CURLOPT_POSTFIELDS, $json);    
					
					$result = curl_exec($ch);
					$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
				
					curl_close($ch);	
			}
		
		}
	}
	
	function unregister($userId, $productId, $params){
		logToFile("mailchimp.class.php: register(): calling removeAddress", LOG_INFO_DAP);
		$this->removeAddress($userId, $productId, $params);
	}
	
	function removeAddress($userId, $productId, $params){
		$dapuser = Dap_User::loadUserById($userId);
		if(!isset($dapuser)){
			logToFile("mailchimp.class.php: removeAddress(): user not found in dap, so return", LOG_DEBUG_DAP);
			return;
		}
		
		$email = trim($dapuser->getEmail());
		$data = explode(":",$params);
		logToFile("mailchimp.class.php: removeAddress(): email =" . $email, LOG_INFO_DAP);
		
		$api_key = $data[1];	
		if($api_key == ""){
			logToFile("mailchimp.class.php: removeAddress(): missing mailchimp API key, so return", LOG_DEBUG_DAP);
			return;
		}
		$list_id = $data[2];
		
		$memberId = md5(strtolower($email));
		$dataCenter = substr($api_key,strpos($api_key,'-')+1);
		$url = 'https://' . $dataCenter . '.api.mailchimp.com/3.0/lists/' . $list_id . '/members/' . $memberId;
		
		$json = json_encode([
			'email_address' => $email,
			'status'        => "unsubscribed", // "subscribed","unsubscribed","cleaned","pending"
		]);

		$ch = curl_init($url);

		curl_setopt($ch, CURLOPT_USERPWD, 'user:' . $api_key);
		curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_TIMEOUT, 10);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $json);                                                                                                                 

		$result = curl_exec($ch);
		$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		curl_close($ch);
		if($httpCode == "200"){
			logToFile("mailchimp.class.php: register(): UnSubscribed from list successfully", LOG_DEBUG_DAP);
		}
		else{
			$result1 = json_decode($result);
			logToFile("mailchimp.class.php: register(): List Unsubscribe failed because ".$result1->detail, LOG_DEBUG_DAP);
		}
		
	}

} // class
?>
