<?php

class sendinblue {
	function sendinblue() // constructor
	{
	}

	function register($userId, $productId, $params){
		$dapver=floatval(DAP_VERSION);
		if($dapver<4.7) {
			logToFile("sendinblue.class.php: ADD NOT SUPPORTED", LOG_DEBUG_DAP);	
			return;
		}
		$params = explode ( ":", $params );	
		try {
			$dapuser = Dap_User::loadUserById($userId);

			if(!isset($dapuser)){
				return;
			}
			logToFile("sendinblue.class.php: $action(): Dap_User::loadUserById() was ok", LOG_INFO_DAP);
			
			$address1 = trim($dapuser->getAddress1());
			$address2 = trim($dapuser->getAddress2());
			$city = trim($dapuser->getCity());
			$state = trim($dapuser->getState());
			$zip = trim($dapuser->getZip());
			$country = trim($dapuser->getCountry());
			
			$phone = trim($dapuser->getPhone());
			$company = trim($dapuser->getCompany());

			$email = trim($dapuser->getEmail());
			$first_name = trim($dapuser->getFirst_name());
			$last_name = trim($dapuser->getLast_name());
			$listId = (int)$params[2];

			$api_params = array(
				'email' => $email,
				'attributes' => [
				'FIRSTNAME' => $first_name,
				'LASTNAME' => $last_name,
				],
				'listIds' => [
					$listId
				]

			);

			if(isset($params[3]) && $params[3] != ''){
				$api_params['attributes']['TAGS'] = $params[3];
			}
			logToFile("sendinblue.class.php: list id is ".$params[2], LOG_INFO_DAP);

			$api_params = json_encode($api_params);
			


			$api_key = $params[1];

			$ch = curl_init();

			curl_setopt($ch, CURLOPT_URL, "https://api.sendinblue.com/v3/contacts");
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS,$api_params);
			curl_setopt($ch, CURLOPT_POST, 1);

			$headers = array();
			$headers[] = "Api-Key: ".$api_key;
			$headers[] = "Content-Type: application/json";
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

			$result = curl_exec($ch);


			if (curl_errno($ch)) {
			    echo 'Error:' . curl_error($ch);
			}
			curl_close ($ch);
			
		}catch (PDOException $e) {
			logToFile("sendinblue.class.php: $action(): user details can't be retrieved ".$e->getMessage(), LOG_INFO_DAP);
			return "user details can't be retrieved";
		} catch (Exception $e) {
			logToFile("sendinblue.class.php: $action(): user details can't be retrieved ".$e->getMessage(), LOG_INFO_DAP);
			return "user sendinblue can't be retrieved";
		}
	}


	function unregister($userId, $productId, $params){
		//unlinkListIds
		$dapver=floatval(DAP_VERSION);
		if($dapver<4.7) {
			logToFile("sendinblue.class.php: REMOVE NOT SUPPORTED", LOG_DEBUG_DAP);	
			return;
		}

		$action="removecontact";
		try {
			$dapuser = Dap_User::loadUserById($userId);
			if(isset($dapuser)){
				$email = $dapuser->getEmail();
			}
			else{
				return;
			}
			$params = explode ( ":", $params );	
			$api_key = $params[1];

			$listId = (int)$params[2];

			$email = urlencode($email);

			$api_params = array(
				'unlinkListIds' => [
			      $listId
			    ]    
			);

			if(isset($params[3]) && $params[3] != ''){
				$api_params['attributes']['TAGS'] = '';
			}
			

			$api_params = json_encode($api_params);

			$ch = curl_init();

			curl_setopt($ch, CURLOPT_URL, "https://api.sendinblue.com/v3/contacts/".$email);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST , "PUT");
			curl_setopt($ch, CURLOPT_POSTFIELDS,$api_params);
			curl_setopt($ch, CURLOPT_POST, 1);

			$headers = array();
			$headers[] = "Api-Key: ".$api_key;
			$headers[] = "Content-Type: application/json";
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

			$result = curl_exec($ch);

			
			if (curl_errno($ch)) {
			    echo 'Error:' . curl_error($ch);
			}
			curl_close ($ch);

			
		}catch (PDOException $e) {
			logToFile("sendinblue.class.php: $action(): user details can't be retrieved ".$e->getMessage(), LOG_INFO_DAP);
			return "user details can't be retrieved";
		} catch (Exception $e) {
			logToFile("sendinblue.class.php: $action(): user details can't be retrieved ".$e->getMessage(), LOG_INFO_DAP);
			return "user sendinblue can't be retrieved";
		}
	}
}