<?php

class trepstar {

   function trepstar() // constructor
   {
   }

   //======== USER REGISTRATION / UPDATE / DELETE ========
	// Add if user not there,  else update 
	function register($userId, $productId, $params)
	{
		logToFile("trepstar.class.php: register(): calling storeAddress", LOG_INFO_DAP);
		
		$this->storeAddress($userId, $productId, $params);
	}
		
	function storeAddress($userId, $productId, $params){
		
		$dapuser = Dap_User::loadUserById($userId);
		$email = trim($dapuser->getEmail());
		$username = trim($dapuser->getUser_name());
		$firstname = trim($dapuser->getFirst_name());
		$lastname = trim($dapuser->getLast_name());
		$password = $dapuser->getPassword();
		$city = $dapuser->getCity();
		$address1 = $dapuser->getAddress1();
		$address2 = $dapuser->getAddress2();
		$state = $dapuser->getState();
		$zip = $dapuser->getZip();
		$country = $dapuser->getCountry();
		
		// Added by Veena - Retrieve Custom Fields for the user - 11/19/11
		$customfieldlist = Dap_API::loadCustomFieldsForUser($dapuser);
		if(isset($customfieldlist) && ($customfieldlist != NULL) && ($customfieldlist != "")) {
		  foreach ($customfieldlist as $key=>$val) {
		   // $key is the name of the field and $val is the value of the custom field
			logToFile("trepstar.class.php:key=value: " . $key . "=" . $val, LOG_INFO_DAP);
		  }
		}
		// End custom field retrieval
		
		$data = explode(":",$params);
		
		logToFile("trepstar.class.php: storeAddress(): email =" . $email, LOG_INFO_DAP);
		
		if(!preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*$/i", $email)) {
			logToFile("trepstar.class.php: storeAddress(): invalid email", LOG_INFO_DAP);
			return "Email address is invalid"; 
		}
	
			
		
		$trepstarProductId = $data[1];
		
		logToFile("trepstar.class.php: storeAddress(): dap product ID =" . $productId, LOG_INFO_DAP);
		
		$product = Dap_Product::loadProduct($productId);
		$trial_amount = $product->getTrial_price();
		$amount = $product->getPrice();
		
		if ( isset($trial_amount) && ($trial_amount != "0.00") && ($trial_amount != "0.0") && ($trial_amount != "0") ) 			
		{
			$price = $trial_amount;
		}
		else { 
			$price = $amount;
		}
		
		$customerAddress=$address1.$address2;
		
		logToFile("trepstar.class.php: storeAddress(): load dap userproduct", LOG_INFO_DAP);
		
		$userProduct = Dap_UsersProducts::load($dapuser->getId(), $productId);
		
		if( isset($userProduct) && ($userProduct != null) ) {
			logToFile("trepstar.class.php: storeAddress(): get transaction info", LOG_INFO_DAP);
			
			$transIdFilter = $userProduct->getTransaction_id();
			if($transIdFilter > 0) {
				$emailFilter = $dapuser->getEmail();
				$productIdFilter = $productId;
				$quantity=0;
				
				logToFile("trepstar.class.php: storeAddress(): getting transaction details", LOG_INFO_DAP);
				$TransactionsList = Dap_Transactions::loadTransactions($transNumFilter, $emailFilter, $productIdFilter, $statusFilter,"","",$transIdFilter);
				foreach ($TransactionsList as $transaction) {
					$quantity++;
					 $invoiceId=$transaction->getTrans_num();
				}
				
				logToFile("trepstar.class.php: storeAddress(): got  transaction details, invoiceid=",$invoiceId, LOG_INFO_DAP);
				
				$ordermethod='url';
				$typeMailMethod ='standard';
				$coLoginEmail=$data[2]; //  trepstar email id
				$coLoginPassword = $data[3]; //  trepstar password
				$source="cdfulfill";
				$mode= $data[4]; //live or test
				$customerEmail = $email;
				$customerName = $firstname." " .$lastname;
				
				$postfields = array();

				try {
					$form_data = array(
						'productID'       => trim($trepstarProductId),
						'ordermethod'          => trim($ordermethod),
						'quantity'           => trim($quantity),
						'typeMailMethod'      => trim($typeMailMethod),
						'CoLoginEmail'        => trim($coLoginEmail),
						'CoLoginPassword'             => trim($coLoginPassword),
						'source'               => trim($source),
						'mode'           => trim($mode),
						'email'           => trim($email),
						'name'                => trim(urlencode($customerName)),
						'nprice'               => trim($price),
						'bUsePriceOnCustomsForm'   => 0,
						'co'             => "",
						'addr'         => trim(urlencode($customerAddress)),
						'city'         => trim(urlencode($city)),
						'st'         => trim(urlencode($state)),
						'zip'         => trim(urlencode($zip)),
						'country'         => trim(urlencode($country)),
						'invoice'         => trim($invoiceId),
						'specialtext'         => ""
						
		
					);
					logToFile("trepstar.class.php: $action(): get User details", LOG_INFO_DAP);
				} catch (PDOException $e) {
					logToFile("trepstar.class.php: $action(): user details can't be retrieved ".$e->getMessage(), LOG_INFO_DAP);
					return "user details can't be retrieved";
				} catch (Exception $e) {
					logToFile("trepstar.class.php: $action(): user details can't be retrieved ".$e->getMessage(), LOG_INFO_DAP);
					return "user details can't be retrieved";
				}
		
				foreach ($form_data as $f => $v) {
					logToFile("trepstar.class.php: $action(): data: $f = $v", LOG_INFO_DAP);
					$postfields[] = $f.'='.$v;
				}
				
				$form_url="https://www.trepstar.com/custdata.asp";
				
				$curl = curl_init($form_url);
				if ( $curl ) {
					curl_setopt($curl, CURLOPT_USERAGENT, 'DAP-TREPSTAR');
					curl_setopt($curl, CURLOPT_HEADER,         FALSE);
					curl_setopt($curl, CURLOPT_POST,           TRUE);
					curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
					curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
					curl_setopt($curl, CURLOPT_FOLLOWLOCATION, TRUE);
					curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 30);
					curl_setopt($curl, CURLOPT_TIMEOUT,        30);
					curl_setopt($curl, CURLOPT_POSTFIELDS, implode('&',$postfields));
					curl_exec  ($curl);
					
					if( curl_errno($curl) > 0 ) {
						logToFile("trepstar.class.php: $action(): Unable to connect to $form_url Error: ".curl_error($curl), LOG_INFO_DAP);
						curl_close ($curl);
						return "Unable to connect to $form_url Error: ".curl_error($curl);
					}
					else {
						logToFile("trepstar.class.php: $action(): Response HTTP-CODE: ".curl_getinfo($curl, CURLINFO_HTTP_CODE), LOG_INFO_DAP);
						curl_close ($curl);
						return 0;
					}
				}
				else {
					logToFile("trepstar.class.php: $action(): CURL is not available", LOG_INFO_DAP);
					return "CURL is not available";
				}
				
				//$nPrice = 
			}
		}
	
			
		
		
		//https://www.trepstar.com/custdata.asp?productID=139610&ordermethod=url&quantity=1&typeMailMethod=standard&CoLoginEmail=&CoLoginPassword=&source=cdfulfill&mode=test&email=&name=Jon+Doe&nprice=12&bUsePriceOnCustomsForm=0&co=Customer+CompanyName&addr=35234+SomeStreet&city=Inver+Grove+Heights&st=MN&zip=55077&country=United+States&specialtext=Insert+the+Disc%2C+wait+for+setup+to+run%2C+click+the+unlock+code+button%2C+and+type+in+3452%2D3432%2D3563&invoice=234ABC
		
		
	}
	
	function unregister($userId, $productId, $params)
	{
		logToFile("trepstar.class.php: register(): calling storeAddress", LOG_INFO_DAP);
		
		$this->removeAddress($userId, $productId, $params);
	}
	
	
	function removeAddress($userId, $productId, $params){
		
		$dapuser = Dap_User::loadUserById($userId);
		$email = trim($dapuser->getEmail());
	
		$data = explode(":",$params);
		
		logToFile("trepstar.class.php: removeAddress(): email =" . $email, LOG_INFO_DAP);
		
		if(!preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*$/i", $email)) {
			return "Email address is invalid"; 
		}
	
		require_once('MCAPI.class.php');
		
		// grab an API Key from http://admin.trepstar.com/account/api/
		$api_key = $data[1];
		$api = new MCAPI($api_key);

		logToFile("trepstar.class.php: removeAddress(): api_key =" . $api_key, LOG_INFO_DAP);
		
		$list_id = $data[2];
		logToFile("trepstar.class.php: removeAddress(): list_id =" . $list_id, LOG_INFO_DAP);
		
		//$api = new MCAPI('4f34766900f66832570f205fb08f164a-us2');
		
		// grab your List's Unique Id by going to http://admin.trepstar.com/lists/
		// Click the "settings" link for the list - the Unique Id is at the bottom of that page. 
		//$list_id = "df11c84ab4";
	
		// Merge variables are the names of all of the fields your mailing list accepts
		// Ex: first name is by default FNAME
		// You can define the names of each merge variable in Lists > click the desired list > list settings > Merge tags for personalization
		// Pass merge values to the API in an array as follows
		
		
			 
		if($api->listUnsubscribe($list_id, $email) === true) {
			// It worked!	
			return 0;
		}else{
			// An error ocurred, return error message	
			return 'listUnsubscribe() Error: ' . $api->errorMessage;
		}
	
	}
			
} 
?>